/* This software was developed at the National Institute of Standards and
 * Technology by employees of the Federal Government in the course of
 * their official duties. Pursuant to title 17 Section 105 of the United
 * States Code this software is not subject to copyright protection and
 * is in the public domain.
 * NIST assumes no responsibility whatsoever for its use by other parties,
 * and makes no guarantees, expressed or implied, about its quality,
 * reliability, or any other characteristic.
 * <BR>
 * We would appreciate acknowledgement if the software is used.
 * <BR>
 * NIST ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION AND
 * DISCLAIM ANY LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING
 * FROM THE USE OF THIS SOFTWARE.
 * </PRE></P>
 * @author  rouil
 */

#ifndef CONTENTIONTIMER_H
#define CONTENTIONTIMER_H

//#include "timer-handler.h"
#include "ns3/scheduler.h"
#include "ns3/simulator.h"
#include "ns3/wimax2-timer.h"
namespace ns3 {
class ContentionRequest;

/**
 * Timer for contention window
 */
class ContentionTimer //: public TimerHandler
{
 public:
 
   /**
    * cancels the scheduled event
    */
    void cancel();
    
//    void force_cancel();
    
    /**
     * schedules the event to occur delay seconds from now
     */
    void sched(double delay);
    
  /**
   * Creates a timer to handle the burst's transmission
   * @param c The contention slot
   */
  ContentionTimer( ContentionRequest* c );
  
  /**
   * When it expires, the timer will handle the next packet to send
   * @param e not used
   */
  void expire( EventId* e );
  
  /**
   * used to access status variable
   */
  int status() {return status_;}
 //protected: - uncomment if python bindings generator can handle protected variables in the future
 
 int status_;

 private:

  /**
   * The contention slot containing the packets to send
   */
  ContentionRequest* c_;
  
  /**
   * The EventId of the currently scheduled event
   */
   EventId id;
  
};
} //namespace
#endif
