#ifndef WIMAX2_HELPER_H
#define WIMAX2_HELPER_H

#include <string>
#include "ns3/object-factory.h"
#include "ns3/wimax2-net-device.h"
#include "ns3/wimax2-bs-net-device.h"
#include "ns3/wimax2-ss-net-device.h"
#include "ns3/net-device-container.h"
#include "ns3/node-container.h"
#include "ns3/wimax2-common.h"
#include "ns3/error-model.h"
#include "ns3/trace-helper.h"
#include "ns3/wimax2-channel.h"



namespace ns3 {

class Wimax2Helper :  public PcapHelperForDevice, public AsciiTraceHelperForDevice
{
   public:
     Wimax2Helper();
     NetDeviceContainer Install (NodeContainer nodes, Ptr<Wimax2Channel> channel);
     NetDeviceContainer InstallBS (NodeContainer nodes, Ptr<Wimax2Channel> channel);
//   NetDeviceContainer Install (NodeContainer nodes);
//	 NetDeviceContainer InstallBS (NodeContainer nodes);
     Phy802_16MIB* getPhyMIB();
     Mac802_16MIB* getMacMIB();
     void setPhyMIB(Phy802_16MIB *mib);
     void setMacMIB(Mac802_16MIB *mib);
     void setDlRatio(double rat) {dlratio_init = rat;}
//     virtual void EnablePcapInternal(std::string, ns3::Ptr<ns3::NetDevice>, bool, bool);

     static void EnableAsciiForConnection (Ptr<OutputStreamWrapper> oss, uint32_t nodeid, uint32_t device_id, char *netdevice, char *connection);
     static void EnableLogComponents ();
     
     double dlratio_init;
     
     Phy802_16MIB *phymib;
     Mac802_16MIB *macmib;
     static Wimax2Helper Default (void);

    private:

    static void AsciiRxEvent(Ptr<OutputStreamWrapper> stream, std::string path, Ptr<const Packet> packet, const Mac48Address &source);
    static void AsciiTxEvent (Ptr<OutputStreamWrapper> stream, std::string path, Ptr<const Packet> packet, const Mac48Address &dest);
    static void PcapSniffTxRxEvent (Ptr<PcapFileWrapper> file, Ptr<const Packet> pkt);

    virtual void EnablePcapInternal (std::string prefix, Ptr<NetDevice> netdev, bool explicitFilename, bool promisc);
    virtual void EnableAsciiInternal(Ptr<OutputStreamWrapper> stream, std::string prefix, Ptr<NetDevice> netdev, bool explicitFilename);
};

}//ns3 namespace
#endif //WIMAX2_HELPER_H

