from pybindgen import Module, FileCodeSink, param, retval, cppclass, typehandlers

def register_types(module):
    root_module = module.get_root()
    
    ## wimax2-common.h: ns3::dir_t [enumeration]
    module.add_enum('dir_t', ['NONE', 'DL', 'UL'])
    ## wimax2-common.h: ns3::Ofdm_mod_rate [enumeration]
    module.add_enum('Ofdm_mod_rate', ['OFDM_BPSK_1_2', 'OFDM_QPSK_1_2', 'OFDM_QPSK_3_4', 'OFDM_16QAM_1_2', 'OFDM_16QAM_3_4', 'OFDM_64QAM_2_3', 'OFDM_64QAM_3_4'])
    ## wimax2-common.h: ns3::timer_id [enumeration]
    module.add_enum('timer_id', ['WimaxFrameTimerID', 'WimaxRxTimerID', 'WimaxDCDTimerID', 'WimaxUCDTimerID', 'WimaxRngIntTimerID', 'WimaxLostDLMAPTimerID', 'WimaxLostULMAPTimerID', 'WimaxT1TimerID', 'WimaxT2TimerID', 'WimaxT3TimerID', 'WimaxT6TimerID', 'WimaxT9TimerID', 'WimaxT12TimerID', 'WimaxT16TimerID', 'WimaxT17TimerID', 'WimaxT21TimerID', 'WimaxT44TimerID', 'WimaxMobNbrAdvTimerID', 'WimaxScanIntervalTimerID', 'WimaxRdvTimerID'])
    ## wimax2-phy.h: ns3::Ofdm_phy_state [enumeration]
    module.add_enum('Ofdm_phy_state', ['OFDM_IDLE', 'OFDM_SEND', 'OFDM_RECV', 'OFDM_RX2TX', 'OFDM_TX2RX'])
    ## wimax2-ss-net-device.h: ns3::ss_sub_state [enumeration]
    module.add_enum('ss_sub_state', ['NORMAL', 'SCAN_PENDING', 'SCANNING', 'HANDOVER_PENDING', 'HANDOVER'])
    ## wimax2-phy.h: ns3::Ofdma_index_t [enumeration]
    module.add_enum('Ofdma_index_t', ['OFDMA_INDEX_PERM', 'OFDMA_INDEX_BW', 'OFDMA_INDEX_FFT', 'OFDMA_INDEX_NUSED', 'OFDMA_INDEX_NBSUBCH', 'OFDMA_INDEX_NBSUBCAR', 'OFDMA_INDEX_NBDATASUBCAR', 'OFDMA_INDEX_SLOT_WIDTH', 'OFDMA_INDEX_SLOT_LENGTH'])
    ## wimax2-net-device.h: ns3::station_type_t [enumeration]
    module.add_enum('station_type_t', ['STA_UNKNOWN', 'STA_MN', 'STA_BS'])
    ## wimax2-ss-net-device.h: ns3::Mac802_16State [enumeration]
    module.add_enum('Mac802_16State', ['MAC802_16_DISCONNECTED', 'MAC802_16_WAIT_DL_SYNCH', 'MAC802_16_WAIT_DL_SYNCH_DCD', 'MAC802_16_UL_PARAM', 'MAC802_16_RANGING', 'MAC802_16_WAIT_ANON_RNG_RSP', 'MAC802_16_WAIT_RNG_ALLOC', 'MAC802_16_WAIT_RNG_RSP', 'MAC802_16_REGISTER', 'MAC802_16_SCANNING', 'MAC802_16_CONNECTED'])
    ## wimax2-common.h: ns3::wimax_scanning_type [enumeration]
    module.add_enum('wimax_scanning_type', ['SCAN_WITHOUT_ASSOC', 'SCAN_ASSOC_LVL0', 'SCAN_ASSOC_LVL1', 'SCAN_ASSOC_LVL2'])
    ## wimax2-phy.h: ns3::direction [enumeration]
    module.add_enum('direction', ['DL_', 'UL_'])
    ## wimax2-common.h: ns3::mngmt_type [enumeration]
    module.add_enum('mngmt_type', ['MAC_UCD', 'MAC_DCD', 'MAC_DL_MAP', 'MAC_UL_MAP', 'MAC_RNG_REQ', 'MAC_RNG_RSP', 'MAC_REG_REQ', 'MAC_REG_RSP', 'MAC_DSA_REQ', 'MAC_DSA_RSP', 'MAC_DSA_ACK', 'MAC_MOB_NBR_ADV', 'MAC_MOB_SCN_REQ', 'MAC_MOB_SCN_RSP', 'MAC_MOB_BSHO_REQ', 'MAC_MOB_MSHO_REQ', 'MAC_MOB_BSHO_RSP', 'MAC_MOB_HO_IND', 'MAC_MOB_SCN_REP', 'MAC_MOB_ASC_REP'])
    ## wimax2-phy.h: ns3::Permutation_scheme [enumeration]
    module.add_enum('Permutation_scheme', ['PUSC', 'FUSC', 'AMC', 'OPUSC', 'OFUSC', 'PERM_LAST'])
    ## wimax2-serviceflow.h: ns3::SchedulingType_t [enumeration]
    module.add_enum('SchedulingType_t', ['SERVICE_UGS', 'SERVICE_ertPS', 'SERVICE_rtPS', 'SERVICE_nrtPS', 'SERVICE_BE'])
    ## wimax2-common.h: ns3::fragment_status [enumeration]
    module.add_enum('fragment_status', ['FRAG_NOFRAG', 'FRAG_LAST', 'FRAG_FIRST', 'FRAG_CONT'])
    ## wimax2-common.h: ns3::ranging_status [enumeration]
    module.add_enum('ranging_status', ['RNG_CONTINUE', 'RNG_ABORT', 'RNG_SUCCESS', 'RNG_RERANGE'])
    ## connection.h: ns3::ConnectionType_t [enumeration]
    module.add_enum('ConnectionType_t', ['CONN_INIT_RANGING', 'CONN_AAS_INIT_RANGING', 'CONN_MULTICAST_POLLING', 'CONN_PADDING', 'CONN_BROADCAST', 'CONN_BASIC', 'CONN_PRIMARY', 'CONN_SECONDARY', 'CONN_DATA'])
    ## arqstatus.h: ns3::Arqstatus [class]
    module.add_class('Arqstatus')
    ## connection.h: ns3::Connection [class]
    module.add_class('Connection')
    ## wimax2-bs-net-device.h: ns3::FastRangingInfo [class]
    module.add_class('FastRangingInfo')
    ## framemap.h: ns3::FrameMap [class]
    module.add_class('FrameMap')
    ## globalparams_wimax.h: ns3::GlobalParams_Wimax [class]
    module.add_class('GlobalParams_Wimax', is_singleton=True)
    ## wimax2-common.h: ns3::HelperFunctions [class]
    module.add_class('HelperFunctions')
    ## wimax2-net-device.h: ns3::Mac802_16MIB [class]
    module.add_class('Mac802_16MIB')
    ## 802_16headers.h: ns3::Mac802_16pkt [class]
    module.add_class('Mac802_16pkt')
    ## neighbordb.h: ns3::NeighborDB [class]
    module.add_class('NeighborDB')
    ## wimax2-timer.h: ns3::PacketTimerRecord [struct]
    module.add_class('PacketTimerRecord')
    ## peernode.h: ns3::PeerNode [class]
    module.add_class('PeerNode')
    ## wimax2-net-device.h: ns3::Phy802_16MIB [class]
    module.add_class('Phy802_16MIB')
    ## wimax2-serviceflowhandler.h: ns3::ServiceFlowHandler [class]
    module.add_class('ServiceFlowHandler')
    ## wimax2-bs-net-device.h: ns3::T17Element [class]
    module.add_class('T17Element')
    ## wimax2-timer.h: ns3::UlTimer [class]
    module.add_class('UlTimer', parent=root_module['ns3::Timer'])
    ## wimax2-serviceflow.h: ns3::Wimax2ServiceFlow [class]
    module.add_class('Wimax2ServiceFlow')
    ## wimax2-serviceflowqos.h: ns3::Wimax2ServiceFlowQoS [class]
    module.add_class('Wimax2ServiceFlowQoS')
    ## wimax2-timer.h: ns3::Wimax2Timer [class]
    module.add_class('Wimax2Timer', allow_subclassing=True)
    ## wimax2-timer.h: ns3::WimaxDCDTimer [class]
    module.add_class('WimaxDCDTimer', parent=root_module['ns3::Wimax2Timer'])
    ## wimax2-timer.h: ns3::WimaxLostDLMAPTimer [class]
    module.add_class('WimaxLostDLMAPTimer', parent=root_module['ns3::Wimax2Timer'])
    ## wimax2-timer.h: ns3::WimaxLostULMAPTimer [class]
    module.add_class('WimaxLostULMAPTimer', parent=root_module['ns3::Wimax2Timer'])
    ## wimax2-timer.h: ns3::WimaxMobNbrAdvTimer [class]
    module.add_class('WimaxMobNbrAdvTimer', parent=root_module['ns3::Wimax2Timer'])
    ## wimaxneighborentry.h: ns3::WimaxNeighborEntry [class]
    module.add_class('WimaxNeighborEntry')
    ## wimax2-timer.h: ns3::WimaxRdvTimer [class]
    module.add_class('WimaxRdvTimer', parent=root_module['ns3::Wimax2Timer'])
    ## wimax2-timer.h: ns3::WimaxRngIntTimer [class]
    module.add_class('WimaxRngIntTimer', parent=root_module['ns3::Wimax2Timer'])
    ## wimax2-timer.h: ns3::WimaxRxTimer [class]
    module.add_class('WimaxRxTimer', parent=root_module['ns3::Wimax2Timer'])
    ## wimax2-timer.h: ns3::WimaxScanIntervalTimer [class]
    module.add_class('WimaxScanIntervalTimer', parent=root_module['ns3::Wimax2Timer'])
    ## wimax2-timer.h: ns3::WimaxT12Timer [class]
    module.add_class('WimaxT12Timer', parent=root_module['ns3::Wimax2Timer'])
    ## wimax2-timer.h: ns3::WimaxT16Timer [class]
    module.add_class('WimaxT16Timer', parent=root_module['ns3::Wimax2Timer'])
    ## wimax2-timer.h: ns3::WimaxT17Timer [class]
    module.add_class('WimaxT17Timer', parent=root_module['ns3::Wimax2Timer'])
    ## wimax2-timer.h: ns3::WimaxT1Timer [class]
    module.add_class('WimaxT1Timer', parent=root_module['ns3::Wimax2Timer'])
    ## wimax2-timer.h: ns3::WimaxT21Timer [class]
    module.add_class('WimaxT21Timer', parent=root_module['ns3::Wimax2Timer'])
    ## wimax2-timer.h: ns3::WimaxT2Timer [class]
    module.add_class('WimaxT2Timer', parent=root_module['ns3::Wimax2Timer'])
    ## wimax2-timer.h: ns3::WimaxT3Timer [class]
    module.add_class('WimaxT3Timer', parent=root_module['ns3::Wimax2Timer'])
    ## wimax2-timer.h: ns3::WimaxT44Timer [class]
    module.add_class('WimaxT44Timer', parent=root_module['ns3::Wimax2Timer'])
    ## wimax2-timer.h: ns3::WimaxT6Timer [class]
    module.add_class('WimaxT6Timer', parent=root_module['ns3::Wimax2Timer'])
    ## wimax2-timer.h: ns3::WimaxT9Timer [class]
    module.add_class('WimaxT9Timer', parent=root_module['ns3::Wimax2Timer'])
    ## wimax2-timer.h: ns3::WimaxUCDTimer [class]
    module.add_class('WimaxUCDTimer', parent=root_module['ns3::Wimax2Timer'])
    ## 802_16headers.h: ns3::arq_fb_ie [struct]
    module.add_class('arq_fb_ie')
    ## 802_16headers.h: ns3::bw_req_header_t [struct]
    module.add_class('bw_req_header_t')
    ## connection.h: ns3::cdma_connection [struct]
    module.add_class('cdma_connection')
    ## 802_16headers.h: ns3::cdma_req_header_t [struct]
    module.add_class('cdma_req_header_t')
    ## connection.h: ns3::conn_list_entry [struct]
    module.add_class('conn_list_entry')
    ## connection.h: ns3::connection_list [struct]
    module.add_class('connection_list')
    ## wimax2-bs-net-device.h: ns3::fastRangingInfo_list [struct]
    module.add_class('fastRangingInfo_list')
    ## wimax2-bs-net-device.h: ns3::fast_ranging_list_entry [struct]
    module.add_class('fast_ranging_list_entry')
    ## 802_16headers.h: ns3::ffb_subheader_s [struct]
    module.add_class('ffb_subheader_s')
    ## 802_16headers.h: ns3::frag_subheader_s [struct]
    module.add_class('frag_subheader_s')
    ## 802_16headers.h: ns3::gen_mac_header_t [struct]
    module.add_class('gen_mac_header_t')
    ## 802_16headers.h: ns3::grant_map_ugs_s [struct]
    module.add_class('grant_map_ugs_s')
    ## 802_16headers.h: ns3::grant_subheader_s [struct]
    module.add_class('grant_subheader_s')
    ## wimax2-net-device.h: ns3::incoming_packet [struct]
    module.add_class('incoming_packet')
    ## 802_16headers.h: ns3::mac802_16_cdma_ie [struct]
    module.add_class('mac802_16_cdma_ie')
    ## 802_16headers.h: ns3::mac802_16_compressed_ie [struct]
    module.add_class('mac802_16_compressed_ie')
    ## 802_16headers.h: ns3::mac802_16_dcd_frame [struct]
    module.add_class('mac802_16_dcd_frame')
    ## 802_16headers.h: ns3::mac802_16_dcd_profile [struct]
    module.add_class('mac802_16_dcd_profile')
    ## 802_16headers.h: ns3::mac802_16_dl_map_frame [struct]
    module.add_class('mac802_16_dl_map_frame')
    ## 802_16headers.h: ns3::mac802_16_dlmap_ie [struct]
    module.add_class('mac802_16_dlmap_ie')
    ## 802_16headers.h: ns3::mac802_16_dsa_ack_frame [struct]
    module.add_class('mac802_16_dsa_ack_frame')
    ## 802_16headers.h: ns3::mac802_16_dsa_req_frame [struct]
    module.add_class('mac802_16_dsa_req_frame')
    ## 802_16headers.h: ns3::mac802_16_dsa_rsp_frame [struct]
    module.add_class('mac802_16_dsa_rsp_frame')
    ## 802_16headers.h: ns3::mac802_16_fast_ranging_ie [struct]
    module.add_class('mac802_16_fast_ranging_ie')
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_req_mode_current_bs [struct]
    module.add_class('mac802_16_mob_bsho_req_mode_current_bs')
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_req_mode_new_bs [struct]
    module.add_class('mac802_16_mob_bsho_req_mode_new_bs')
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_req_mode_new_bs3 [struct]
    module.add_class('mac802_16_mob_bsho_req_mode_new_bs3')
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_frame [struct]
    module.add_class('mac802_16_mob_bsho_rsp_frame')
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_mode_new_bs2 [struct]
    module.add_class('mac802_16_mob_bsho_rsp_mode_new_bs2')
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_rec [struct]
    module.add_class('mac802_16_mob_bsho_rsp_rec')
    ## 802_16headers.h: ns3::mac802_16_mob_ho_ind_bs [struct]
    module.add_class('mac802_16_mob_ho_ind_bs')
    ## 802_16headers.h: ns3::mac802_16_mob_ho_ind_frame [struct]
    module.add_class('mac802_16_mob_ho_ind_frame')
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_bs_index [struct]
    module.add_class('mac802_16_mob_msho_req_bs_index')
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_current_bs [struct]
    module.add_class('mac802_16_mob_msho_req_current_bs')
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_frame [struct]
    module.add_class('mac802_16_mob_msho_req_frame')
    ## 802_16headers.h: ns3::mac802_16_mob_nbr_adv_frame [struct]
    module.add_class('mac802_16_mob_nbr_adv_frame')
    ## 802_16headers.h: ns3::mac802_16_mob_scn_req_bs_full [struct]
    module.add_class('mac802_16_mob_scn_req_bs_full')
    ## 802_16headers.h: ns3::mac802_16_mob_scn_req_bs_index [struct]
    module.add_class('mac802_16_mob_scn_req_bs_index')
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_bs_full [struct]
    module.add_class('mac802_16_mob_scn_rsp_bs_full')
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_bs_index [struct]
    module.add_class('mac802_16_mob_scn_rsp_bs_index')
    ## 802_16headers.h: ns3::mac802_16_nbr_adv_info [struct]
    module.add_class('mac802_16_nbr_adv_info')
    ## 802_16headers.h: ns3::mac802_16_ofdma_ulmap_ie [struct]
    module.add_class('mac802_16_ofdma_ulmap_ie')
    ## 802_16headers.h: ns3::mac802_16_phy_mode_id [struct]
    module.add_class('mac802_16_phy_mode_id')
    ## 802_16headers.h: ns3::mac802_16_phy_profile_id [struct]
    module.add_class('mac802_16_phy_profile_id')
    ## 802_16headers.h: ns3::mac802_16_reg_req_frame [struct]
    module.add_class('mac802_16_reg_req_frame')
    ## 802_16headers.h: ns3::mac802_16_reg_rsp_frame [struct]
    module.add_class('mac802_16_reg_rsp_frame')
    ## 802_16headers.h: ns3::mac802_16_rng_req_frame [struct]
    module.add_class('mac802_16_rng_req_frame')
    ## 802_16headers.h: ns3::mac802_16_rng_rsp_frame [struct]
    module.add_class('mac802_16_rng_rsp_frame')
    ## 802_16headers.h: ns3::mac802_16_ucd_frame [struct]
    module.add_class('mac802_16_ucd_frame')
    ## 802_16headers.h: ns3::mac802_16_ucd_profile [struct]
    module.add_class('mac802_16_ucd_profile')
    ## 802_16headers.h: ns3::mac802_16_ul_map_frame [struct]
    module.add_class('mac802_16_ul_map_frame')
    ## 802_16headers.h: ns3::mac802_16_ulmap_ie [struct]
    module.add_class('mac802_16_ulmap_ie')
    ## wimax2-bs-net-device.h: ns3::new_client_t [struct]
    module.add_class('new_client_t')
    ## 802_16headers.h: ns3::pack_subheader_s [struct]
    module.add_class('pack_subheader_s')
    ## peernode.h: ns3::peerNode_list [struct]
    module.add_class('peerNode_list')
    ## peernode.h: ns3::peer_node_link [struct]
    module.add_class('peer_node_link')
    ## wimax2-ss-net-device.h: ns3::scanning_structure [struct]
    module.add_class('scanning_structure')
    ## wimaxneighborentry.h: ns3::sched_state_info [struct]
    module.add_class('sched_state_info')
    ## sduclassifier.h: ns3::sduClassifier_list [struct]
    module.add_class('sduClassifier_list')
    ## sduclassifier.h: ns3::sdulink [struct]
    module.add_class('sdulink')
    ## wimax2-serviceflow.h: ns3::service_flow_link [struct]
    module.add_class('service_flow_link')
    ## wimax2-serviceflow.h: ns3::serviceflow_list [struct]
    module.add_class('serviceflow_list')
    ## wimax2-ss-net-device.h: ns3::state_info [struct]
    module.add_class('state_info')
    ## wimax2-bs-net-device.h: ns3::t17Element_list [struct]
    module.add_class('t17Element_list')
    ## wimax2-bs-net-device.h: ns3::t17_list_entry [struct]
    module.add_class('t17_list_entry')
    ## wimax2-timer.h: ns3::ARQTimer [class]
    module.add_class('ARQTimer', parent=root_module['ns3::Timer'])
    ## wimax2-timer.h: ns3::DlTimer [class]
    module.add_class('DlTimer', parent=root_module['ns3::Timer'])
    ## wimax2-timer.h: ns3::InitTimer [class]
    module.add_class('InitTimer', parent=root_module['ns3::Timer'])
    ## 802_16headers.h: ns3::MAC_TAG [class]
    module.add_class('MAC_TAG', parent=root_module['ns3::Tag'])
    ## 802_16headers.h: ns3::MISC_OTHER_HEADER [class]
    module.add_class('MISC_OTHER_HEADER', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::MOB_HO_IND_FRAME_HEADER [class]
    module.add_class('MOB_HO_IND_FRAME_HEADER', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::MSHO_REQUEST_FRAME_HEADER [class]
    module.add_class('MSHO_REQUEST_FRAME_HEADER', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::NEIGHBOR_ADVERTISEMENT_FRAME_HEADER [class]
    module.add_class('NEIGHBOR_ADVERTISEMENT_FRAME_HEADER', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::PACKING_SUBHEADER [class]
    module.add_class('PACKING_SUBHEADER', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::PHY_INFO_Header [class]
    module.add_class('PHY_INFO_Header', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::RANGING_REQUEST_FRAME [class]
    module.add_class('RANGING_REQUEST_FRAME', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::RANGING_RESPONSE_FRAME [class]
    module.add_class('RANGING_RESPONSE_FRAME', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::REGISTRATION_REQUEST_FRAME [class]
    module.add_class('REGISTRATION_REQUEST_FRAME', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::REGISTRATION_RESPONSE_FRAME [class]
    module.add_class('REGISTRATION_RESPONSE_FRAME', parent=root_module['ns3::Header'])
    ## sduclassifier.h: ns3::SDUClassifier [class]
    module.add_class('SDUClassifier', parent=root_module['ns3::Object'])
    ## 802_16headers.h: ns3::Signaling_MAC_Header [class]
    module.add_class('Signaling_MAC_Header', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::Type_Check [class]
    module.add_class('Type_Check', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::UCD_FRAME_DATA [class]
    module.add_class('UCD_FRAME_DATA', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::UL_MAP_FRAME_HEADER [class]
    module.add_class('UL_MAP_FRAME_HEADER', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::UL_MAP_IE [class]
    module.add_class('UL_MAP_IE', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::UL_Protocol_Header [class]
    module.add_class('UL_Protocol_Header', parent=root_module['ns3::Header'])
    ## wimax2-phy.h: ns3::Wimax2Phy [class]
    module.add_class('Wimax2Phy', parent=root_module['ns3::Object'])
    ## 802_16headers.h: ns3::mac802_16_mob_scn_req_frame [class]
    module.add_class('mac802_16_mob_scn_req_frame', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_frame [class]
    module.add_class('mac802_16_mob_scn_rsp_frame', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::ARQ_FB_IE_HEADER [class]
    module.add_class('ARQ_FB_IE_HEADER', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::All_Headers [class]
    module.add_class('All_Headers', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::BSHO_RESPONCE_FRAME_HEADER [class]
    module.add_class('BSHO_RESPONCE_FRAME_HEADER', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::CDMA_MAP_IE [class]
    module.add_class('CDMA_MAP_IE', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::CDMA_REQUEST_HEADER [class]
    module.add_class('CDMA_REQUEST_HEADER', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::Copy_Trailer [class]
    module.add_class('Copy_Trailer', parent=root_module['ns3::Trailer'])
    ## 802_16headers.h: ns3::DCD_FRAME_HEADER [class]
    module.add_class('DCD_FRAME_HEADER', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::DL_MAP_FRAME_HEADER [class]
    module.add_class('DL_MAP_FRAME_HEADER', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::DL_MAP_IE [class]
    module.add_class('DL_MAP_IE', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::DSA_ACK_FRAME_HEADER [class]
    module.add_class('DSA_ACK_FRAME_HEADER', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::DSA_REQ_FRAME_HEADER [class]
    module.add_class('DSA_REQ_FRAME_HEADER', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::DSA_RSP_FRAME_HEADER [class]
    module.add_class('DSA_RSP_FRAME_HEADER', parent=root_module['ns3::Header'])
    ## destclassifier.h: ns3::DestClassifier [class]
    module.add_class('DestClassifier', parent=root_module['ns3::SDUClassifier'])
    ## 802_16headers.h: ns3::FFB_SUBHEADER [class]
    module.add_class('FFB_SUBHEADER', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::FRAG_SUBHEADER [class]
    module.add_class('FRAG_SUBHEADER', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::Fast_Ranging_IE [class]
    module.add_class('Fast_Ranging_IE', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::Frame_Prefix_Header [class]
    module.add_class('Frame_Prefix_Header', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::GRANT_MAP_SUBHEADER [class]
    module.add_class('GRANT_MAP_SUBHEADER', parent=root_module['ns3::Header'])
    ## 802_16headers.h: ns3::Generic_MAC_Header [class]
    module.add_class('Generic_MAC_Header', parent=root_module['ns3::Header'])
    ## head_queue.h: ns3::HeadQueue [class]
    module.add_class('HeadQueue', parent=root_module['ns3::Queue'])
    ## head_queue.h: ns3::HeadQueue::Mode [enumeration]
    module.add_enum('Mode', ['ILLEGAL', 'PACKETS', 'BYTES'], outer_class=root_module['ns3::HeadQueue'])
    ## wimax2-channel.h: ns3::Wimax2Channel [class]
    module.add_class('Wimax2Channel', parent=root_module['ns3::Channel'])
    ## wimax2-net-device.h: ns3::Wimax2NetDevice [class]
    module.add_class('Wimax2NetDevice', parent=root_module['ns3::NetDevice'])
    ## wimax2-ss-net-device.h: ns3::Wimax2SSNetDevice [class]
    module.add_class('Wimax2SSNetDevice', parent=root_module['ns3::Wimax2NetDevice'])
    ## wimax2-bs-net-device.h: ns3::Wimax2BSNetDevice [class]
    module.add_class('Wimax2BSNetDevice', parent=root_module['ns3::Wimax2NetDevice'])
    
    ## Register a nested module for the namespace Config
    
    nested_module = module.add_cpp_namespace('Config')
    register_types_ns3_Config(nested_module)
    
    
    ## Register a nested module for the namespace FatalImpl
    
    nested_module = module.add_cpp_namespace('FatalImpl')
    register_types_ns3_FatalImpl(nested_module)
    
    
    ## Register a nested module for the namespace addressUtils
    
    nested_module = module.add_cpp_namespace('addressUtils')
    register_types_ns3_addressUtils(nested_module)
    
    
    ## Register a nested module for the namespace aodv
    
    nested_module = module.add_cpp_namespace('aodv')
    register_types_ns3_aodv(nested_module)
    
    
    ## Register a nested module for the namespace dot11s
    
    nested_module = module.add_cpp_namespace('dot11s')
    register_types_ns3_dot11s(nested_module)
    
    
    ## Register a nested module for the namespace dsdv
    
    nested_module = module.add_cpp_namespace('dsdv')
    register_types_ns3_dsdv(nested_module)
    
    
    ## Register a nested module for the namespace flame
    
    nested_module = module.add_cpp_namespace('flame')
    register_types_ns3_flame(nested_module)
    
    
    ## Register a nested module for the namespace internal
    
    nested_module = module.add_cpp_namespace('internal')
    register_types_ns3_internal(nested_module)
    
    
    ## Register a nested module for the namespace olsr
    
    nested_module = module.add_cpp_namespace('olsr')
    register_types_ns3_olsr(nested_module)
    

def register_types_ns3_Config(module):
    root_module = module.get_root()
    

def register_types_ns3_FatalImpl(module):
    root_module = module.get_root()
    

def register_types_ns3_addressUtils(module):
    root_module = module.get_root()
    

def register_types_ns3_aodv(module):
    root_module = module.get_root()
    

def register_types_ns3_dot11s(module):
    root_module = module.get_root()
    

def register_types_ns3_dsdv(module):
    root_module = module.get_root()
    

def register_types_ns3_flame(module):
    root_module = module.get_root()
    

def register_types_ns3_internal(module):
    root_module = module.get_root()
    

def register_types_ns3_olsr(module):
    root_module = module.get_root()
    

def register_methods(root_module):
    register_Ns3Arqstatus_methods(root_module, root_module['ns3::Arqstatus'])
    register_Ns3Connection_methods(root_module, root_module['ns3::Connection'])
    register_Ns3FastRangingInfo_methods(root_module, root_module['ns3::FastRangingInfo'])
    register_Ns3FrameMap_methods(root_module, root_module['ns3::FrameMap'])
    register_Ns3GlobalParams_Wimax_methods(root_module, root_module['ns3::GlobalParams_Wimax'])
    register_Ns3HelperFunctions_methods(root_module, root_module['ns3::HelperFunctions'])
    register_Ns3Mac802_16MIB_methods(root_module, root_module['ns3::Mac802_16MIB'])
    register_Ns3Mac802_16pkt_methods(root_module, root_module['ns3::Mac802_16pkt'])
    register_Ns3NeighborDB_methods(root_module, root_module['ns3::NeighborDB'])
    register_Ns3PacketTimerRecord_methods(root_module, root_module['ns3::PacketTimerRecord'])
    register_Ns3PeerNode_methods(root_module, root_module['ns3::PeerNode'])
    register_Ns3Phy802_16MIB_methods(root_module, root_module['ns3::Phy802_16MIB'])
    register_Ns3ServiceFlowHandler_methods(root_module, root_module['ns3::ServiceFlowHandler'])
    register_Ns3T17Element_methods(root_module, root_module['ns3::T17Element'])
    register_Ns3UlTimer_methods(root_module, root_module['ns3::UlTimer'])
    register_Ns3Wimax2ServiceFlow_methods(root_module, root_module['ns3::Wimax2ServiceFlow'])
    register_Ns3Wimax2ServiceFlowQoS_methods(root_module, root_module['ns3::Wimax2ServiceFlowQoS'])
    register_Ns3Wimax2Timer_methods(root_module, root_module['ns3::Wimax2Timer'])
    register_Ns3WimaxDCDTimer_methods(root_module, root_module['ns3::WimaxDCDTimer'])
    register_Ns3WimaxLostDLMAPTimer_methods(root_module, root_module['ns3::WimaxLostDLMAPTimer'])
    register_Ns3WimaxLostULMAPTimer_methods(root_module, root_module['ns3::WimaxLostULMAPTimer'])
    register_Ns3WimaxMobNbrAdvTimer_methods(root_module, root_module['ns3::WimaxMobNbrAdvTimer'])
    register_Ns3WimaxNeighborEntry_methods(root_module, root_module['ns3::WimaxNeighborEntry'])
    register_Ns3WimaxRdvTimer_methods(root_module, root_module['ns3::WimaxRdvTimer'])
    register_Ns3WimaxRngIntTimer_methods(root_module, root_module['ns3::WimaxRngIntTimer'])
    register_Ns3WimaxRxTimer_methods(root_module, root_module['ns3::WimaxRxTimer'])
    register_Ns3WimaxScanIntervalTimer_methods(root_module, root_module['ns3::WimaxScanIntervalTimer'])
    register_Ns3WimaxT12Timer_methods(root_module, root_module['ns3::WimaxT12Timer'])
    register_Ns3WimaxT16Timer_methods(root_module, root_module['ns3::WimaxT16Timer'])
    register_Ns3WimaxT17Timer_methods(root_module, root_module['ns3::WimaxT17Timer'])
    register_Ns3WimaxT1Timer_methods(root_module, root_module['ns3::WimaxT1Timer'])
    register_Ns3WimaxT21Timer_methods(root_module, root_module['ns3::WimaxT21Timer'])
    register_Ns3WimaxT2Timer_methods(root_module, root_module['ns3::WimaxT2Timer'])
    register_Ns3WimaxT3Timer_methods(root_module, root_module['ns3::WimaxT3Timer'])
    register_Ns3WimaxT44Timer_methods(root_module, root_module['ns3::WimaxT44Timer'])
    register_Ns3WimaxT6Timer_methods(root_module, root_module['ns3::WimaxT6Timer'])
    register_Ns3WimaxT9Timer_methods(root_module, root_module['ns3::WimaxT9Timer'])
    register_Ns3WimaxUCDTimer_methods(root_module, root_module['ns3::WimaxUCDTimer'])
    register_Ns3Arq_fb_ie_methods(root_module, root_module['ns3::arq_fb_ie'])
    register_Ns3Bw_req_header_t_methods(root_module, root_module['ns3::bw_req_header_t'])
    register_Ns3Cdma_connection_methods(root_module, root_module['ns3::cdma_connection'])
    register_Ns3Cdma_req_header_t_methods(root_module, root_module['ns3::cdma_req_header_t'])
    register_Ns3Conn_list_entry_methods(root_module, root_module['ns3::conn_list_entry'])
    register_Ns3Connection_list_methods(root_module, root_module['ns3::connection_list'])
    register_Ns3FastRangingInfo_list_methods(root_module, root_module['ns3::fastRangingInfo_list'])
    register_Ns3Fast_ranging_list_entry_methods(root_module, root_module['ns3::fast_ranging_list_entry'])
    register_Ns3Ffb_subheader_s_methods(root_module, root_module['ns3::ffb_subheader_s'])
    register_Ns3Frag_subheader_s_methods(root_module, root_module['ns3::frag_subheader_s'])
    register_Ns3Gen_mac_header_t_methods(root_module, root_module['ns3::gen_mac_header_t'])
    register_Ns3Grant_map_ugs_s_methods(root_module, root_module['ns3::grant_map_ugs_s'])
    register_Ns3Grant_subheader_s_methods(root_module, root_module['ns3::grant_subheader_s'])
    register_Ns3Incoming_packet_methods(root_module, root_module['ns3::incoming_packet'])
    register_Ns3Mac802_16_cdma_ie_methods(root_module, root_module['ns3::mac802_16_cdma_ie'])
    register_Ns3Mac802_16_compressed_ie_methods(root_module, root_module['ns3::mac802_16_compressed_ie'])
    register_Ns3Mac802_16_dcd_frame_methods(root_module, root_module['ns3::mac802_16_dcd_frame'])
    register_Ns3Mac802_16_dcd_profile_methods(root_module, root_module['ns3::mac802_16_dcd_profile'])
    register_Ns3Mac802_16_dl_map_frame_methods(root_module, root_module['ns3::mac802_16_dl_map_frame'])
    register_Ns3Mac802_16_dlmap_ie_methods(root_module, root_module['ns3::mac802_16_dlmap_ie'])
    register_Ns3Mac802_16_dsa_ack_frame_methods(root_module, root_module['ns3::mac802_16_dsa_ack_frame'])
    register_Ns3Mac802_16_dsa_req_frame_methods(root_module, root_module['ns3::mac802_16_dsa_req_frame'])
    register_Ns3Mac802_16_dsa_rsp_frame_methods(root_module, root_module['ns3::mac802_16_dsa_rsp_frame'])
    register_Ns3Mac802_16_fast_ranging_ie_methods(root_module, root_module['ns3::mac802_16_fast_ranging_ie'])
    register_Ns3Mac802_16_mob_bsho_req_mode_current_bs_methods(root_module, root_module['ns3::mac802_16_mob_bsho_req_mode_current_bs'])
    register_Ns3Mac802_16_mob_bsho_req_mode_new_bs_methods(root_module, root_module['ns3::mac802_16_mob_bsho_req_mode_new_bs'])
    register_Ns3Mac802_16_mob_bsho_req_mode_new_bs3_methods(root_module, root_module['ns3::mac802_16_mob_bsho_req_mode_new_bs3'])
    register_Ns3Mac802_16_mob_bsho_rsp_frame_methods(root_module, root_module['ns3::mac802_16_mob_bsho_rsp_frame'])
    register_Ns3Mac802_16_mob_bsho_rsp_mode_new_bs2_methods(root_module, root_module['ns3::mac802_16_mob_bsho_rsp_mode_new_bs2'])
    register_Ns3Mac802_16_mob_bsho_rsp_rec_methods(root_module, root_module['ns3::mac802_16_mob_bsho_rsp_rec'])
    register_Ns3Mac802_16_mob_ho_ind_bs_methods(root_module, root_module['ns3::mac802_16_mob_ho_ind_bs'])
    register_Ns3Mac802_16_mob_ho_ind_frame_methods(root_module, root_module['ns3::mac802_16_mob_ho_ind_frame'])
    register_Ns3Mac802_16_mob_msho_req_bs_index_methods(root_module, root_module['ns3::mac802_16_mob_msho_req_bs_index'])
    register_Ns3Mac802_16_mob_msho_req_current_bs_methods(root_module, root_module['ns3::mac802_16_mob_msho_req_current_bs'])
    register_Ns3Mac802_16_mob_msho_req_frame_methods(root_module, root_module['ns3::mac802_16_mob_msho_req_frame'])
    register_Ns3Mac802_16_mob_nbr_adv_frame_methods(root_module, root_module['ns3::mac802_16_mob_nbr_adv_frame'])
    register_Ns3Mac802_16_mob_scn_req_bs_full_methods(root_module, root_module['ns3::mac802_16_mob_scn_req_bs_full'])
    register_Ns3Mac802_16_mob_scn_req_bs_index_methods(root_module, root_module['ns3::mac802_16_mob_scn_req_bs_index'])
    register_Ns3Mac802_16_mob_scn_rsp_bs_full_methods(root_module, root_module['ns3::mac802_16_mob_scn_rsp_bs_full'])
    register_Ns3Mac802_16_mob_scn_rsp_bs_index_methods(root_module, root_module['ns3::mac802_16_mob_scn_rsp_bs_index'])
    register_Ns3Mac802_16_nbr_adv_info_methods(root_module, root_module['ns3::mac802_16_nbr_adv_info'])
    register_Ns3Mac802_16_ofdma_ulmap_ie_methods(root_module, root_module['ns3::mac802_16_ofdma_ulmap_ie'])
    register_Ns3Mac802_16_phy_mode_id_methods(root_module, root_module['ns3::mac802_16_phy_mode_id'])
    register_Ns3Mac802_16_phy_profile_id_methods(root_module, root_module['ns3::mac802_16_phy_profile_id'])
    register_Ns3Mac802_16_reg_req_frame_methods(root_module, root_module['ns3::mac802_16_reg_req_frame'])
    register_Ns3Mac802_16_reg_rsp_frame_methods(root_module, root_module['ns3::mac802_16_reg_rsp_frame'])
    register_Ns3Mac802_16_rng_req_frame_methods(root_module, root_module['ns3::mac802_16_rng_req_frame'])
    register_Ns3Mac802_16_rng_rsp_frame_methods(root_module, root_module['ns3::mac802_16_rng_rsp_frame'])
    register_Ns3Mac802_16_ucd_frame_methods(root_module, root_module['ns3::mac802_16_ucd_frame'])
    register_Ns3Mac802_16_ucd_profile_methods(root_module, root_module['ns3::mac802_16_ucd_profile'])
    register_Ns3Mac802_16_ul_map_frame_methods(root_module, root_module['ns3::mac802_16_ul_map_frame'])
    register_Ns3Mac802_16_ulmap_ie_methods(root_module, root_module['ns3::mac802_16_ulmap_ie'])
    register_Ns3New_client_t_methods(root_module, root_module['ns3::new_client_t'])
    register_Ns3Pack_subheader_s_methods(root_module, root_module['ns3::pack_subheader_s'])
    register_Ns3PeerNode_list_methods(root_module, root_module['ns3::peerNode_list'])
    register_Ns3Peer_node_link_methods(root_module, root_module['ns3::peer_node_link'])
    register_Ns3Scanning_structure_methods(root_module, root_module['ns3::scanning_structure'])
    register_Ns3Sched_state_info_methods(root_module, root_module['ns3::sched_state_info'])
    register_Ns3SduClassifier_list_methods(root_module, root_module['ns3::sduClassifier_list'])
    register_Ns3Sdulink_methods(root_module, root_module['ns3::sdulink'])
    register_Ns3Service_flow_link_methods(root_module, root_module['ns3::service_flow_link'])
    register_Ns3Serviceflow_list_methods(root_module, root_module['ns3::serviceflow_list'])
    register_Ns3State_info_methods(root_module, root_module['ns3::state_info'])
    register_Ns3T17Element_list_methods(root_module, root_module['ns3::t17Element_list'])
    register_Ns3T17_list_entry_methods(root_module, root_module['ns3::t17_list_entry'])
    register_Ns3ARQTimer_methods(root_module, root_module['ns3::ARQTimer'])
    register_Ns3DlTimer_methods(root_module, root_module['ns3::DlTimer'])
    register_Ns3InitTimer_methods(root_module, root_module['ns3::InitTimer'])
    register_Ns3MAC_TAG_methods(root_module, root_module['ns3::MAC_TAG'])
    register_Ns3MISC_OTHER_HEADER_methods(root_module, root_module['ns3::MISC_OTHER_HEADER'])
    register_Ns3MOB_HO_IND_FRAME_HEADER_methods(root_module, root_module['ns3::MOB_HO_IND_FRAME_HEADER'])
    register_Ns3MSHO_REQUEST_FRAME_HEADER_methods(root_module, root_module['ns3::MSHO_REQUEST_FRAME_HEADER'])
    register_Ns3NEIGHBOR_ADVERTISEMENT_FRAME_HEADER_methods(root_module, root_module['ns3::NEIGHBOR_ADVERTISEMENT_FRAME_HEADER'])
    register_Ns3PACKING_SUBHEADER_methods(root_module, root_module['ns3::PACKING_SUBHEADER'])
    register_Ns3PHY_INFO_Header_methods(root_module, root_module['ns3::PHY_INFO_Header'])
    register_Ns3RANGING_REQUEST_FRAME_methods(root_module, root_module['ns3::RANGING_REQUEST_FRAME'])
    register_Ns3RANGING_RESPONSE_FRAME_methods(root_module, root_module['ns3::RANGING_RESPONSE_FRAME'])
    register_Ns3REGISTRATION_REQUEST_FRAME_methods(root_module, root_module['ns3::REGISTRATION_REQUEST_FRAME'])
    register_Ns3REGISTRATION_RESPONSE_FRAME_methods(root_module, root_module['ns3::REGISTRATION_RESPONSE_FRAME'])
    register_Ns3SDUClassifier_methods(root_module, root_module['ns3::SDUClassifier'])
    register_Ns3Signaling_MAC_Header_methods(root_module, root_module['ns3::Signaling_MAC_Header'])
    register_Ns3Type_Check_methods(root_module, root_module['ns3::Type_Check'])
    register_Ns3UCD_FRAME_DATA_methods(root_module, root_module['ns3::UCD_FRAME_DATA'])
    register_Ns3UL_MAP_FRAME_HEADER_methods(root_module, root_module['ns3::UL_MAP_FRAME_HEADER'])
    register_Ns3UL_MAP_IE_methods(root_module, root_module['ns3::UL_MAP_IE'])
    register_Ns3UL_Protocol_Header_methods(root_module, root_module['ns3::UL_Protocol_Header'])
    register_Ns3Wimax2Phy_methods(root_module, root_module['ns3::Wimax2Phy'])
    register_Ns3Mac802_16_mob_scn_req_frame_methods(root_module, root_module['ns3::mac802_16_mob_scn_req_frame'])
    register_Ns3Mac802_16_mob_scn_rsp_frame_methods(root_module, root_module['ns3::mac802_16_mob_scn_rsp_frame'])
    register_Ns3ARQ_FB_IE_HEADER_methods(root_module, root_module['ns3::ARQ_FB_IE_HEADER'])
    register_Ns3All_Headers_methods(root_module, root_module['ns3::All_Headers'])
    register_Ns3BSHO_RESPONCE_FRAME_HEADER_methods(root_module, root_module['ns3::BSHO_RESPONCE_FRAME_HEADER'])
    register_Ns3CDMA_MAP_IE_methods(root_module, root_module['ns3::CDMA_MAP_IE'])
    register_Ns3CDMA_REQUEST_HEADER_methods(root_module, root_module['ns3::CDMA_REQUEST_HEADER'])
    register_Ns3Copy_Trailer_methods(root_module, root_module['ns3::Copy_Trailer'])
    register_Ns3DCD_FRAME_HEADER_methods(root_module, root_module['ns3::DCD_FRAME_HEADER'])
    register_Ns3DL_MAP_FRAME_HEADER_methods(root_module, root_module['ns3::DL_MAP_FRAME_HEADER'])
    register_Ns3DL_MAP_IE_methods(root_module, root_module['ns3::DL_MAP_IE'])
    register_Ns3DSA_ACK_FRAME_HEADER_methods(root_module, root_module['ns3::DSA_ACK_FRAME_HEADER'])
    register_Ns3DSA_REQ_FRAME_HEADER_methods(root_module, root_module['ns3::DSA_REQ_FRAME_HEADER'])
    register_Ns3DSA_RSP_FRAME_HEADER_methods(root_module, root_module['ns3::DSA_RSP_FRAME_HEADER'])
    register_Ns3DestClassifier_methods(root_module, root_module['ns3::DestClassifier'])
    register_Ns3FFB_SUBHEADER_methods(root_module, root_module['ns3::FFB_SUBHEADER'])
    register_Ns3FRAG_SUBHEADER_methods(root_module, root_module['ns3::FRAG_SUBHEADER'])
    register_Ns3Fast_Ranging_IE_methods(root_module, root_module['ns3::Fast_Ranging_IE'])
    register_Ns3Frame_Prefix_Header_methods(root_module, root_module['ns3::Frame_Prefix_Header'])
    register_Ns3GRANT_MAP_SUBHEADER_methods(root_module, root_module['ns3::GRANT_MAP_SUBHEADER'])
    register_Ns3Generic_MAC_Header_methods(root_module, root_module['ns3::Generic_MAC_Header'])
    register_Ns3HeadQueue_methods(root_module, root_module['ns3::HeadQueue'])
    register_Ns3Wimax2Channel_methods(root_module, root_module['ns3::Wimax2Channel'])
    register_Ns3Wimax2NetDevice_methods(root_module, root_module['ns3::Wimax2NetDevice'])
    register_Ns3Wimax2SSNetDevice_methods(root_module, root_module['ns3::Wimax2SSNetDevice'])
    register_Ns3Wimax2BSNetDevice_methods(root_module, root_module['ns3::Wimax2BSNetDevice'])
    return

def register_Ns3Arqstatus_methods(root_module, cls):
    ## arqstatus.h: ns3::Arqstatus::Arqstatus(ns3::Arqstatus const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::Arqstatus const &', 'arg0')])
    ## arqstatus.h: ns3::Arqstatus::Arqstatus() [constructor]
    cls.add_constructor([])
    ## arqstatus.h: void ns3::Arqstatus::arqReceive(ns3::Ptr<ns3::Packet> p, ns3::Connection * connection, uint8_t * inOrder) [member function]
    cls.add_method('arqReceive', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p'), param('ns3::Connection *', 'connection', transfer_ownership=True), param('uint8_t *', 'inOrder', transfer_ownership=True)])
    ## arqstatus.h: void ns3::Arqstatus::arqReceiveBufferTransfer(ns3::Ptr<ns3::Packet> p, ns3::Connection * connection, uint8_t * inOrder) [member function]
    cls.add_method('arqReceiveBufferTransfer', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p'), param('ns3::Connection *', 'connection', transfer_ownership=True), param('uint8_t *', 'inOrder', transfer_ownership=True)])
    ## arqstatus.h: void ns3::Arqstatus::arqRecvFeedback(ns3::Ptr<ns3::Packet> p, uint16_t i, ns3::Connection * connection) [member function]
    cls.add_method('arqRecvFeedback', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p'), param('uint16_t', 'i'), param('ns3::Connection *', 'connection', transfer_ownership=True)])
    ## arqstatus.h: void ns3::Arqstatus::arqSend(ns3::Ptr<ns3::Packet> p, ns3::Connection * connection, ns3::fragment_status status) [member function]
    cls.add_method('arqSend', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p'), param('ns3::Connection *', 'connection', transfer_ownership=True), param('ns3::fragment_status', 'status')])
    ## arqstatus.h: void ns3::Arqstatus::arqTimerHandler() [member function]
    cls.add_method('arqTimerHandler', 
                   'void', 
                   [])
    ## arqstatus.h: void ns3::Arqstatus::cancelTimer() [member function]
    cls.add_method('cancelTimer', 
                   'void', 
                   [])
    ## arqstatus.h: uint8_t ns3::Arqstatus::getAckCounter() [member function]
    cls.add_method('getAckCounter', 
                   'uint8_t', 
                   [])
    ## arqstatus.h: uint8_t ns3::Arqstatus::getAckPeriod() [member function]
    cls.add_method('getAckPeriod', 
                   'uint8_t', 
                   [])
    ## arqstatus.h: uint32_t ns3::Arqstatus::getAckSeq() [member function]
    cls.add_method('getAckSeq', 
                   'uint32_t', 
                   [])
    ## arqstatus.h: uint32_t ns3::Arqstatus::getCurrSeq() [member function]
    cls.add_method('getCurrSeq', 
                   'uint32_t', 
                   [])
    ## arqstatus.h: uint32_t ns3::Arqstatus::getCurrWindow() [member function]
    cls.add_method('getCurrWindow', 
                   'uint32_t', 
                   [])
    ## arqstatus.h: uint32_t ns3::Arqstatus::getLastAckSent() [member function]
    cls.add_method('getLastAckSent', 
                   'uint32_t', 
                   [])
    ## arqstatus.h: uint32_t ns3::Arqstatus::getMaxSeq() [member function]
    cls.add_method('getMaxSeq', 
                   'uint32_t', 
                   [])
    ## arqstatus.h: uint32_t ns3::Arqstatus::getMaxWindow() [member function]
    cls.add_method('getMaxWindow', 
                   'uint32_t', 
                   [])
    ## arqstatus.h: double ns3::Arqstatus::getRetransTime() [member function]
    cls.add_method('getRetransTime', 
                   'double', 
                   [])
    ## arqstatus.h: uint8_t ns3::Arqstatus::isArqEnabled() [member function]
    cls.add_method('isArqEnabled', 
                   'uint8_t', 
                   [])
    ## arqstatus.h: void ns3::Arqstatus::setAckCounter(uint8_t ack_counter) [member function]
    cls.add_method('setAckCounter', 
                   'void', 
                   [param('uint8_t', 'ack_counter')])
    ## arqstatus.h: void ns3::Arqstatus::setAckPeriod(uint8_t ack_period) [member function]
    cls.add_method('setAckPeriod', 
                   'void', 
                   [param('uint8_t', 'ack_period')])
    ## arqstatus.h: void ns3::Arqstatus::setAckSeq(uint32_t ack_seq) [member function]
    cls.add_method('setAckSeq', 
                   'void', 
                   [param('uint32_t', 'ack_seq')])
    ## arqstatus.h: void ns3::Arqstatus::setArqEnabled(uint8_t is_arq_enabled) [member function]
    cls.add_method('setArqEnabled', 
                   'void', 
                   [param('uint8_t', 'is_arq_enabled')])
    ## arqstatus.h: void ns3::Arqstatus::setCurrSeq(uint32_t arq_curr_seq) [member function]
    cls.add_method('setCurrSeq', 
                   'void', 
                   [param('uint32_t', 'arq_curr_seq')])
    ## arqstatus.h: void ns3::Arqstatus::setCurrWindow(uint32_t arq_curr_window) [member function]
    cls.add_method('setCurrWindow', 
                   'void', 
                   [param('uint32_t', 'arq_curr_window')])
    ## arqstatus.h: void ns3::Arqstatus::setLastAckSent(uint32_t last_ack_sent) [member function]
    cls.add_method('setLastAckSent', 
                   'void', 
                   [param('uint32_t', 'last_ack_sent')])
    ## arqstatus.h: void ns3::Arqstatus::setMaxWindow(uint32_t arq_max_window) [member function]
    cls.add_method('setMaxWindow', 
                   'void', 
                   [param('uint32_t', 'arq_max_window')])
    ## arqstatus.h: void ns3::Arqstatus::setRetransTime(double arq_retrans_time) [member function]
    cls.add_method('setRetransTime', 
                   'void', 
                   [param('double', 'arq_retrans_time')])
    ## arqstatus.h: ns3::Arqstatus::arqRetransTimer [variable]
    cls.add_instance_attribute('arqRetransTimer', 'ns3::ARQTimer *', is_const=False)
    ## arqstatus.h: ns3::Arqstatus::arq_feedback_queue_ [variable]
    cls.add_instance_attribute('arq_feedback_queue_', 'ns3::Ptr< ns3::HeadQueue >', is_const=False)
    ## arqstatus.h: ns3::Arqstatus::arq_retrans_queue_ [variable]
    cls.add_instance_attribute('arq_retrans_queue_', 'ns3::Ptr< ns3::HeadQueue >', is_const=False)
    ## arqstatus.h: ns3::Arqstatus::arq_trans_queue_ [variable]
    cls.add_instance_attribute('arq_trans_queue_', 'ns3::Ptr< ns3::HeadQueue >', is_const=False)
    return

def register_Ns3Connection_methods(root_module, cls):
    ## connection.h: ns3::Connection::Connection(ns3::Connection const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::Connection const &', 'arg0')])
    ## connection.h: ns3::Connection::Connection(ns3::ConnectionType_t arg0) [constructor]
    cls.add_constructor([param('ns3::ConnectionType_t', 'arg0')])
    ## connection.h: ns3::Connection::Connection(ns3::ConnectionType_t arg0, int cid) [constructor]
    cls.add_constructor([param('ns3::ConnectionType_t', 'arg0'), param('int', 'cid')])
    ## connection.h: ns3::Ptr<ns3::Packet> ns3::Connection::dequeue() [member function]
    cls.add_method('dequeue', 
                   'ns3::Ptr< ns3::Packet >', 
                   [])
    ## connection.h: void ns3::Connection::enable_fragmentation(bool enable) [member function]
    cls.add_method('enable_fragmentation', 
                   'void', 
                   [param('bool', 'enable')])
    ## connection.h: void ns3::Connection::enable_packing(bool enable) [member function]
    cls.add_method('enable_packing', 
                   'void', 
                   [param('bool', 'enable')])
    ## connection.h: void ns3::Connection::enqueue(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('enqueue', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')])
    ## connection.h: void ns3::Connection::enqueue_head(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('enqueue_head', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')])
    ## connection.h: int ns3::Connection::flush_queue() [member function]
    cls.add_method('flush_queue', 
                   'int', 
                   [])
    ## connection.h: ns3::Arqstatus * ns3::Connection::getArqStatus() [member function]
    cls.add_method('getArqStatus', 
                   'ns3::Arqstatus *', 
                   [])
    ## connection.h: int ns3::Connection::getBW_REQ_QUEUE() [member function]
    cls.add_method('getBW_REQ_QUEUE', 
                   'int', 
                   [])
    ## connection.h: int ns3::Connection::getBw() [member function]
    cls.add_method('getBw', 
                   'int', 
                   [])
    ## connection.h: int ns3::Connection::getCDMA() [member function]
    cls.add_method('getCDMA', 
                   'int', 
                   [])
    ## connection.h: int ns3::Connection::getCDMA_SSID_CID(int ssid) [member function]
    cls.add_method('getCDMA_SSID_CID', 
                   'int', 
                   [param('int', 'ssid')])
    ## connection.h: uint8_t ns3::Connection::getCDMA_SSID_CODE(int ssid) [member function]
    cls.add_method('getCDMA_SSID_CODE', 
                   'uint8_t', 
                   [param('int', 'ssid')])
    ## connection.h: int ns3::Connection::getCDMA_SSID_FLAG(int ssid) [member function]
    cls.add_method('getCDMA_SSID_FLAG', 
                   'int', 
                   [param('int', 'ssid')])
    ## connection.h: int ns3::Connection::getCDMA_SSID_SSID(int ssid) [member function]
    cls.add_method('getCDMA_SSID_SSID', 
                   'int', 
                   [param('int', 'ssid')])
    ## connection.h: uint8_t ns3::Connection::getCDMA_SSID_TOP(int ssid) [member function]
    cls.add_method('getCDMA_SSID_TOP', 
                   'uint8_t', 
                   [param('int', 'ssid')])
    ## connection.h: uint8_t ns3::Connection::getCDMA_code() [member function]
    cls.add_method('getCDMA_code', 
                   'uint8_t', 
                   [])
    ## connection.h: uint8_t ns3::Connection::getCDMA_top() [member function]
    cls.add_method('getCDMA_top', 
                   'uint8_t', 
                   [])
    ## connection.h: uint16_t ns3::Connection::getFragNumber() [member function]
    cls.add_method('getFragNumber', 
                   'uint16_t', 
                   [])
    ## connection.h: int ns3::Connection::getFragmentBytes() [member function]
    cls.add_method('getFragmentBytes', 
                   'int', 
                   [])
    ## connection.h: int ns3::Connection::getFragmentNumber() [member function]
    cls.add_method('getFragmentNumber', 
                   'int', 
                   [])
    ## connection.h: ns3::fragment_status ns3::Connection::getFragmentationStatus() [member function]
    cls.add_method('getFragmentationStatus', 
                   'ns3::fragment_status', 
                   [])
    ## connection.h: int ns3::Connection::getINIT_REQ_QUEUE(int ss_id) [member function]
    cls.add_method('getINIT_REQ_QUEUE', 
                   'int', 
                   [param('int', 'ss_id')])
    ## connection.h: uint32_t ns3::Connection::getLastFrameTransmitted() [member function]
    cls.add_method('getLastFrameTransmitted', 
                   'uint32_t', 
                   [])
    ## connection.h: int ns3::Connection::getPOLL_interval() [member function]
    cls.add_method('getPOLL_interval', 
                   'int', 
                   [])
    ## connection.h: uint16_t ns3::Connection::getPackNumber() [member function]
    cls.add_method('getPackNumber', 
                   'uint16_t', 
                   [])
    ## connection.h: ns3::PeerNode * ns3::Connection::getPeerNode() [member function]
    cls.add_method('getPeerNode', 
                   'ns3::PeerNode *', 
                   [])
    ## connection.h: ns3::ConnectionType_t ns3::Connection::getType() [member function]
    cls.add_method('getType', 
                   'ns3::ConnectionType_t', 
                   [])
    ## connection.h: ns3::ConnectionType_t ns3::Connection::get_category() [member function]
    cls.add_method('get_category', 
                   'ns3::ConnectionType_t', 
                   [])
    ## connection.h: int ns3::Connection::get_cid() [member function]
    cls.add_method('get_cid', 
                   'int', 
                   [])
    ## connection.h: ns3::HeadQueue * ns3::Connection::get_queue() [member function]
    cls.add_method('get_queue', 
                   'ns3::HeadQueue *', 
                   [])
    ## connection.h: ns3::Wimax2ServiceFlow * ns3::Connection::get_serviceflow() [member function]
    cls.add_method('get_serviceflow', 
                   'ns3::Wimax2ServiceFlow *', 
                   [])
    ## connection.h: uint16_t ns3::Connection::incrementFragNumber() [member function]
    cls.add_method('incrementFragNumber', 
                   'uint16_t', 
                   [])
    ## connection.h: uint16_t ns3::Connection::incrementPackNumber() [member function]
    cls.add_method('incrementPackNumber', 
                   'uint16_t', 
                   [])
    ## connection.h: void ns3::Connection::initCDMA() [member function]
    cls.add_method('initCDMA', 
                   'void', 
                   [])
    ## connection.h: void ns3::Connection::initCDMA_SSID() [member function]
    cls.add_method('initCDMA_SSID', 
                   'void', 
                   [])
    ## connection.h: void ns3::Connection::insert_entry(ns3::connection_list * head) [member function]
    cls.add_method('insert_entry', 
                   'void', 
                   [param('ns3::connection_list *', 'head')])
    ## connection.h: bool ns3::Connection::isFragEnable() [member function]
    cls.add_method('isFragEnable', 
                   'bool', 
                   [])
    ## connection.h: bool ns3::Connection::isPackingEnable() [member function]
    cls.add_method('isPackingEnable', 
                   'bool', 
                   [])
    ## connection.h: ns3::Connection * ns3::Connection::next_entry() const [member function]
    cls.add_method('next_entry', 
                   'ns3::Connection *', 
                   [], 
                   is_const=True)
    ## connection.h: uint32_t ns3::Connection::queueByteLength() [member function]
    cls.add_method('queueByteLength', 
                   'uint32_t', 
                   [])
    ## connection.h: int ns3::Connection::queueLength() [member function]
    cls.add_method('queueLength', 
                   'int', 
                   [])
    ## connection.h: ns3::Ptr<ns3::Packet> ns3::Connection::queueLookup(int n) [member function]
    cls.add_method('queueLookup', 
                   'ns3::Ptr< ns3::Packet >', 
                   [param('int', 'n')])
    ## connection.h: void ns3::Connection::remove_entry() [member function]
    cls.add_method('remove_entry', 
                   'void', 
                   [])
    ## connection.h: void ns3::Connection::setArqStatus(ns3::Arqstatus * arqstatus) [member function]
    cls.add_method('setArqStatus', 
                   'void', 
                   [param('ns3::Arqstatus *', 'arqstatus')])
    ## connection.h: void ns3::Connection::setBW_REQ_QUEUE(int bw_req_queue) [member function]
    cls.add_method('setBW_REQ_QUEUE', 
                   'void', 
                   [param('int', 'bw_req_queue')])
    ## connection.h: void ns3::Connection::setBw(int bw) [member function]
    cls.add_method('setBw', 
                   'void', 
                   [param('int', 'bw')])
    ## connection.h: void ns3::Connection::setCDMA(int cdma_flag) [member function]
    cls.add_method('setCDMA', 
                   'void', 
                   [param('int', 'cdma_flag')])
    ## connection.h: void ns3::Connection::setCDMA_SSID_CID(int ssid, int cid_ssid) [member function]
    cls.add_method('setCDMA_SSID_CID', 
                   'void', 
                   [param('int', 'ssid'), param('int', 'cid_ssid')])
    ## connection.h: void ns3::Connection::setCDMA_SSID_CODE(int ssid, uint8_t code_ssid) [member function]
    cls.add_method('setCDMA_SSID_CODE', 
                   'void', 
                   [param('int', 'ssid'), param('uint8_t', 'code_ssid')])
    ## connection.h: void ns3::Connection::setCDMA_SSID_FLAG(int ssid, int flag_ssid) [member function]
    cls.add_method('setCDMA_SSID_FLAG', 
                   'void', 
                   [param('int', 'ssid'), param('int', 'flag_ssid')])
    ## connection.h: void ns3::Connection::setCDMA_SSID_SSID(int ssid, int ssid_ssid) [member function]
    cls.add_method('setCDMA_SSID_SSID', 
                   'void', 
                   [param('int', 'ssid'), param('int', 'ssid_ssid')])
    ## connection.h: void ns3::Connection::setCDMA_SSID_TOP(int ssid, uint8_t top_ssid) [member function]
    cls.add_method('setCDMA_SSID_TOP', 
                   'void', 
                   [param('int', 'ssid'), param('uint8_t', 'top_ssid')])
    ## connection.h: void ns3::Connection::setCDMA_code(uint8_t cdma_code) [member function]
    cls.add_method('setCDMA_code', 
                   'void', 
                   [param('uint8_t', 'cdma_code')])
    ## connection.h: void ns3::Connection::setCDMA_top(uint8_t cdma_top) [member function]
    cls.add_method('setCDMA_top', 
                   'void', 
                   [param('uint8_t', 'cdma_top')])
    ## connection.h: void ns3::Connection::setFragStatus(ns3::fragment_status f) [member function]
    cls.add_method('setFragStatus', 
                   'void', 
                   [param('ns3::fragment_status', 'f')])
    ## connection.h: void ns3::Connection::setINIT_REQ_QUEUE(int ss_id, int init_req_queue) [member function]
    cls.add_method('setINIT_REQ_QUEUE', 
                   'void', 
                   [param('int', 'ss_id'), param('int', 'init_req_queue')])
    ## connection.h: void ns3::Connection::setLastFrameTransmitted(uint32_t fr) [member function]
    cls.add_method('setLastFrameTransmitted', 
                   'void', 
                   [param('uint32_t', 'fr')])
    ## connection.h: void ns3::Connection::setManager(ns3::ConnectionManager * manager) [member function]
    cls.add_method('setManager', 
                   'void', 
                   [param('ns3::ConnectionManager *', 'manager')])
    ## connection.h: void ns3::Connection::setPOLL_interval(int poll_int) [member function]
    cls.add_method('setPOLL_interval', 
                   'void', 
                   [param('int', 'poll_int')])
    ## connection.h: void ns3::Connection::setPeerNode(ns3::PeerNode * peer) [member function]
    cls.add_method('setPeerNode', 
                   'void', 
                   [param('ns3::PeerNode *', 'peer')])
    ## connection.h: void ns3::Connection::set_serviceflow(ns3::Wimax2ServiceFlow * value) [member function]
    cls.add_method('set_serviceflow', 
                   'void', 
                   [param('ns3::Wimax2ServiceFlow *', 'value')])
    ## connection.h: void ns3::Connection::updateFragmentation(ns3::fragment_status status, int index, int bytes) [member function]
    cls.add_method('updateFragmentation', 
                   'void', 
                   [param('ns3::fragment_status', 'status'), param('int', 'index'), param('int', 'bytes')])
    ## connection.h: ns3::Connection::link [variable]
    cls.add_instance_attribute('link', 'ns3::conn_list_entry', is_const=False)
    return

def register_Ns3FastRangingInfo_methods(root_module, cls):
    ## wimax2-bs-net-device.h: ns3::FastRangingInfo::FastRangingInfo(ns3::FastRangingInfo const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::FastRangingInfo const &', 'arg0')])
    ## wimax2-bs-net-device.h: ns3::FastRangingInfo::FastRangingInfo(int frame, ns3::Mac48Address macAddr) [constructor]
    cls.add_constructor([param('int', 'frame'), param('ns3::Mac48Address', 'macAddr')])
    ## wimax2-bs-net-device.h: int ns3::FastRangingInfo::frame() [member function]
    cls.add_method('frame', 
                   'int', 
                   [])
    ## wimax2-bs-net-device.h: void ns3::FastRangingInfo::insert_entry(ns3::fastRangingInfo_list * head) [member function]
    cls.add_method('insert_entry', 
                   'void', 
                   [param('ns3::fastRangingInfo_list *', 'head')])
    ## wimax2-bs-net-device.h: ns3::Mac48Address ns3::FastRangingInfo::macAddr() [member function]
    cls.add_method('macAddr', 
                   'ns3::Mac48Address', 
                   [])
    ## wimax2-bs-net-device.h: ns3::FastRangingInfo * ns3::FastRangingInfo::next_entry() const [member function]
    cls.add_method('next_entry', 
                   'ns3::FastRangingInfo *', 
                   [], 
                   is_const=True)
    ## wimax2-bs-net-device.h: void ns3::FastRangingInfo::remove_entry() [member function]
    cls.add_method('remove_entry', 
                   'void', 
                   [])
    ## wimax2-bs-net-device.h: ns3::FastRangingInfo::link [variable]
    cls.add_instance_attribute('link', 'ns3::fast_ranging_list_entry', is_const=False)
    return

def register_Ns3FrameMap_methods(root_module, cls):
    ## framemap.h: ns3::FrameMap::FrameMap(ns3::FrameMap const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::FrameMap const &', 'arg0')])
    ## framemap.h: ns3::FrameMap::FrameMap(ns3::Ptr<ns3::Wimax2NetDevice> mac) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'mac')])
    ## framemap.h: ns3::Ptr<ns3::Packet> ns3::FrameMap::getDCD() [member function]
    cls.add_method('getDCD', 
                   'ns3::Ptr< ns3::Packet >', 
                   [])
    ## framemap.h: ns3::Ptr<ns3::Packet> ns3::FrameMap::getDL_MAP() [member function]
    cls.add_method('getDL_MAP', 
                   'ns3::Ptr< ns3::Packet >', 
                   [])
    ## framemap.h: ns3::DlSubFrame * ns3::FrameMap::getDlSubframe() [member function]
    cls.add_method('getDlSubframe', 
                   'ns3::DlSubFrame *', 
                   [])
    ## framemap.h: double ns3::FrameMap::getDuration() [member function]
    cls.add_method('getDuration', 
                   'double', 
                   [])
    ## framemap.h: ns3::Ptr<ns3::Wimax2NetDevice> ns3::FrameMap::getMac() [member function]
    cls.add_method('getMac', 
                   'ns3::Ptr< ns3::Wimax2NetDevice >', 
                   [])
    ## framemap.h: double ns3::FrameMap::getStarttime() [member function]
    cls.add_method('getStarttime', 
                   'double', 
                   [])
    ## framemap.h: ns3::Ptr<ns3::Packet> ns3::FrameMap::getUCD() [member function]
    cls.add_method('getUCD', 
                   'ns3::Ptr< ns3::Packet >', 
                   [])
    ## framemap.h: ns3::Ptr<ns3::Packet> ns3::FrameMap::getUL_MAP() [member function]
    cls.add_method('getUL_MAP', 
                   'ns3::Ptr< ns3::Packet >', 
                   [])
    ## framemap.h: ns3::UlSubFrame * ns3::FrameMap::getUlSubframe() [member function]
    cls.add_method('getUlSubframe', 
                   'ns3::UlSubFrame *', 
                   [])
    ## framemap.h: void ns3::FrameMap::parseDCDframe(ns3::mac802_16_dcd_frame * frame) [member function]
    cls.add_method('parseDCDframe', 
                   'void', 
                   [param('ns3::mac802_16_dcd_frame *', 'frame')])
    ## framemap.h: void ns3::FrameMap::parseDLMAPframe(ns3::DL_MAP_FRAME_HEADER * frame) [member function]
    cls.add_method('parseDLMAPframe', 
                   'void', 
                   [param('ns3::DL_MAP_FRAME_HEADER *', 'frame')])
    ## framemap.h: void ns3::FrameMap::parseUCDframe(ns3::mac802_16_ucd_frame * frame) [member function]
    cls.add_method('parseUCDframe', 
                   'void', 
                   [param('ns3::mac802_16_ucd_frame *', 'frame')])
    ## framemap.h: void ns3::FrameMap::parseULMAPframe(ns3::UL_MAP_FRAME_HEADER * frame, double txtime) [member function]
    cls.add_method('parseULMAPframe', 
                   'void', 
                   [param('ns3::UL_MAP_FRAME_HEADER *', 'frame'), param('double', 'txtime')])
    ## framemap.h: void ns3::FrameMap::print_frame() [member function]
    cls.add_method('print_frame', 
                   'void', 
                   [])
    ## framemap.h: void ns3::FrameMap::setDuration(double duration) [member function]
    cls.add_method('setDuration', 
                   'void', 
                   [param('double', 'duration')])
    ## framemap.h: void ns3::FrameMap::setStarttime(double time) [member function]
    cls.add_method('setStarttime', 
                   'void', 
                   [param('double', 'time')])
    return

def register_Ns3GlobalParams_Wimax_methods(root_module, cls):
    ## globalparams_wimax.h: int ns3::GlobalParams_Wimax::CountLines(std::ifstream & In) [member function]
    cls.add_method('CountLines', 
                   'int', 
                   [param('std::ifstream &', 'In')])
    ## globalparams_wimax.h: double ns3::GlobalParams_Wimax::GetTablePrecision(double FullDoubleNumber) [member function]
    cls.add_method('GetTablePrecision', 
                   'double', 
                   [param('double', 'FullDoubleNumber')])
    ## globalparams_wimax.h: static ns3::GlobalParams_Wimax * ns3::GlobalParams_Wimax::Instance() [member function]
    cls.add_method('Instance', 
                   'ns3::GlobalParams_Wimax *', 
                   [], 
                   is_static=True)
    ## globalparams_wimax.h: int ns3::GlobalParams_Wimax::LoadBetaFile() [member function]
    cls.add_method('LoadBetaFile', 
                   'int', 
                   [])
    ## globalparams_wimax.h: int ns3::GlobalParams_Wimax::ReadTableFromFile() [member function]
    cls.add_method('ReadTableFromFile', 
                   'int', 
                   [])
    ## globalparams_wimax.h: double ns3::GlobalParams_Wimax::TableLookup(int Index, double SINR) [member function]
    cls.add_method('TableLookup', 
                   'double', 
                   [param('int', 'Index'), param('double', 'SINR')])
    ## globalparams_wimax.h: ns3::GlobalParams_Wimax::Beta [variable]
    cls.add_instance_attribute('Beta', 'double [ 33 ] [ 3 ]', is_const=False)
    ## globalparams_wimax.h: ns3::GlobalParams_Wimax::NumLines [variable]
    cls.add_instance_attribute('NumLines', 'int', is_const=False)
    ## globalparams_wimax.h: ns3::GlobalParams_Wimax::Num_SINR_Decimals [variable]
    cls.add_instance_attribute('Num_SINR_Decimals', 'int', is_const=False)
    ## globalparams_wimax.h: ns3::GlobalParams_Wimax::Table_BLER [variable]
    cls.add_instance_attribute('Table_BLER', 'double *', is_const=False)
    ## globalparams_wimax.h: ns3::GlobalParams_Wimax::Table_High_SINR_Bounds [variable]
    cls.add_instance_attribute('Table_High_SINR_Bounds', 'double *', is_const=False)
    ## globalparams_wimax.h: ns3::GlobalParams_Wimax::Table_Index [variable]
    cls.add_instance_attribute('Table_Index', 'int *', is_const=False)
    ## globalparams_wimax.h: ns3::GlobalParams_Wimax::Table_Low_SINR_Bounds [variable]
    cls.add_instance_attribute('Table_Low_SINR_Bounds', 'double *', is_const=False)
    ## globalparams_wimax.h: ns3::GlobalParams_Wimax::Table_SINR [variable]
    cls.add_instance_attribute('Table_SINR', 'double *', is_const=False)
    ## globalparams_wimax.h: ns3::GlobalParams_Wimax::GlobalParams_Wimax() [constructor]
    cls.add_constructor([], 
                        visibility='protected')
    return

def register_Ns3HelperFunctions_methods(root_module, cls):
    ## wimax2-common.h: ns3::HelperFunctions::HelperFunctions() [constructor]
    cls.add_constructor([])
    ## wimax2-common.h: ns3::HelperFunctions::HelperFunctions(ns3::HelperFunctions const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::HelperFunctions const &', 'arg0')])
    ## wimax2-common.h: static std::string ns3::HelperFunctions::getMacAddrString(ns3::Mac48Address adr) [member function]
    cls.add_method('getMacAddrString', 
                   'std::string', 
                   [param('ns3::Mac48Address', 'adr')], 
                   is_static=True)
    ## wimax2-common.h: static char const * ns3::HelperFunctions::getPacketTypeString(int gm_sm) [member function]
    cls.add_method('getPacketTypeString', 
                   'char const *', 
                   [param('int', 'gm_sm')], 
                   is_static=True)
    return

def register_Ns3Mac802_16MIB_methods(root_module, cls):
    ## wimax2-net-device.h: ns3::Mac802_16MIB::Mac802_16MIB(ns3::Mac802_16MIB const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::Mac802_16MIB const &', 'arg0')])
    ## wimax2-net-device.h: ns3::Mac802_16MIB::Mac802_16MIB() [constructor]
    cls.add_constructor([])
    ## wimax2-net-device.h: ns3::Mac802_16MIB::ITU_PDP_ [variable]
    cls.add_instance_attribute('ITU_PDP_', 'int', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::RXThreshold_ [variable]
    cls.add_instance_attribute('RXThreshold_', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::bw_backoff_start [variable]
    cls.add_instance_attribute('bw_backoff_start', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::bw_backoff_stop [variable]
    cls.add_instance_attribute('bw_backoff_stop', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::bw_req_contention_size [variable]
    cls.add_instance_attribute('bw_req_contention_size', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::cdma_code_bw_start [variable]
    cls.add_instance_attribute('cdma_code_bw_start', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::cdma_code_bw_stop [variable]
    cls.add_instance_attribute('cdma_code_bw_stop', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::cdma_code_cqich_start [variable]
    cls.add_instance_attribute('cdma_code_cqich_start', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::cdma_code_cqich_stop [variable]
    cls.add_instance_attribute('cdma_code_cqich_stop', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::cdma_code_handover_start [variable]
    cls.add_instance_attribute('cdma_code_handover_start', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::cdma_code_handover_stop [variable]
    cls.add_instance_attribute('cdma_code_handover_stop', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::cdma_code_init_start [variable]
    cls.add_instance_attribute('cdma_code_init_start', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::cdma_code_init_stop [variable]
    cls.add_instance_attribute('cdma_code_init_stop', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::client_timeout [variable]
    cls.add_instance_attribute('client_timeout', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::contention_rng_retry [variable]
    cls.add_instance_attribute('contention_rng_retry', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::dcd_interval [variable]
    cls.add_instance_attribute('dcd_interval', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::dsx_req_retry [variable]
    cls.add_instance_attribute('dsx_req_retry', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::dsx_rsp_retry [variable]
    cls.add_instance_attribute('dsx_rsp_retry', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::frame_duration [variable]
    cls.add_instance_attribute('frame_duration', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::init_contention_size [variable]
    cls.add_instance_attribute('init_contention_size', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::init_rng_interval [variable]
    cls.add_instance_attribute('init_rng_interval', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::interleaving [variable]
    cls.add_instance_attribute('interleaving', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::invited_rng_retry [variable]
    cls.add_instance_attribute('invited_rng_retry', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::lgd_factor_ [variable]
    cls.add_instance_attribute('lgd_factor_', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::lost_dlmap_interval [variable]
    cls.add_instance_attribute('lost_dlmap_interval', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::lost_ulmap_interval [variable]
    cls.add_instance_attribute('lost_ulmap_interval', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::max_dir_scan_time [variable]
    cls.add_instance_attribute('max_dir_scan_time', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::nbr_adv_interval [variable]
    cls.add_instance_attribute('nbr_adv_interval', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::queue_length [variable]
    cls.add_instance_attribute('queue_length', 'int', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::reg_req_retry [variable]
    cls.add_instance_attribute('reg_req_retry', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::request_retry [variable]
    cls.add_instance_attribute('request_retry', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::rng_backoff_start [variable]
    cls.add_instance_attribute('rng_backoff_start', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::rng_backoff_stop [variable]
    cls.add_instance_attribute('rng_backoff_stop', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::rxp_avg_alpha [variable]
    cls.add_instance_attribute('rxp_avg_alpha', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::scan_duration [variable]
    cls.add_instance_attribute('scan_duration', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::scan_iteration [variable]
    cls.add_instance_attribute('scan_iteration', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::scan_req_retry [variable]
    cls.add_instance_attribute('scan_req_retry', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::t12_timeout [variable]
    cls.add_instance_attribute('t12_timeout', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::t16_timeout [variable]
    cls.add_instance_attribute('t16_timeout', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::t17_timeout [variable]
    cls.add_instance_attribute('t17_timeout', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::t1_timeout [variable]
    cls.add_instance_attribute('t1_timeout', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::t21_timeout [variable]
    cls.add_instance_attribute('t21_timeout', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::t2_timeout [variable]
    cls.add_instance_attribute('t2_timeout', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::t3_timeout [variable]
    cls.add_instance_attribute('t3_timeout', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::t44_timeout [variable]
    cls.add_instance_attribute('t44_timeout', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::t6_timeout [variable]
    cls.add_instance_attribute('t6_timeout', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::tproc [variable]
    cls.add_instance_attribute('tproc', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Mac802_16MIB::ucd_interval [variable]
    cls.add_instance_attribute('ucd_interval', 'double', is_const=False)
    return

def register_Ns3Mac802_16pkt_methods(root_module, cls):
    ## 802_16headers.h: ns3::Mac802_16pkt::Mac802_16pkt() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::Mac802_16pkt::Mac802_16pkt(ns3::Mac802_16pkt const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::Mac802_16pkt const &', 'arg0')])
    ## 802_16headers.h: static int ns3::Mac802_16pkt::getMOB_BSHO_RSP_size(ns3::mac802_16_mob_bsho_rsp_frame * frame) [member function]
    cls.add_method('getMOB_BSHO_RSP_size', 
                   'int', 
                   [param('ns3::mac802_16_mob_bsho_rsp_frame *', 'frame')], 
                   is_static=True)
    ## 802_16headers.h: static int ns3::Mac802_16pkt::getMOB_HO_IND_size(ns3::mac802_16_mob_ho_ind_frame * frame) [member function]
    cls.add_method('getMOB_HO_IND_size', 
                   'int', 
                   [param('ns3::mac802_16_mob_ho_ind_frame *', 'frame')], 
                   is_static=True)
    ## 802_16headers.h: static int ns3::Mac802_16pkt::getMOB_MSHO_REQ_size(ns3::mac802_16_mob_msho_req_frame * frame) [member function]
    cls.add_method('getMOB_MSHO_REQ_size', 
                   'int', 
                   [param('ns3::mac802_16_mob_msho_req_frame *', 'frame')], 
                   is_static=True)
    ## 802_16headers.h: static int ns3::Mac802_16pkt::getMOB_NBR_ADV_size(ns3::mac802_16_mob_nbr_adv_frame * frame) [member function]
    cls.add_method('getMOB_NBR_ADV_size', 
                   'int', 
                   [param('ns3::mac802_16_mob_nbr_adv_frame *', 'frame')], 
                   is_static=True)
    ## 802_16headers.h: static int ns3::Mac802_16pkt::getMOB_SCN_REQ_size(ns3::mac802_16_mob_scn_req_frame * frame) [member function]
    cls.add_method('getMOB_SCN_REQ_size', 
                   'int', 
                   [param('ns3::mac802_16_mob_scn_req_frame *', 'frame')], 
                   is_static=True)
    ## 802_16headers.h: static int ns3::Mac802_16pkt::getMOB_SCN_RSP_size(ns3::mac802_16_mob_scn_rsp_frame * frame) [member function]
    cls.add_method('getMOB_SCN_RSP_size', 
                   'int', 
                   [param('ns3::mac802_16_mob_scn_rsp_frame *', 'frame')], 
                   is_static=True)
    return

def register_Ns3NeighborDB_methods(root_module, cls):
    ## neighbordb.h: ns3::NeighborDB::NeighborDB(ns3::NeighborDB const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::NeighborDB const &', 'arg0')])
    ## neighbordb.h: ns3::NeighborDB::NeighborDB() [constructor]
    cls.add_constructor([])
    ## neighbordb.h: void ns3::NeighborDB::addNeighbor(ns3::WimaxNeighborEntry * nb) [member function]
    cls.add_method('addNeighbor', 
                   'void', 
                   [param('ns3::WimaxNeighborEntry *', 'nb')])
    ## neighbordb.h: int ns3::NeighborDB::getNbNeighbor() [member function]
    cls.add_method('getNbNeighbor', 
                   'int', 
                   [])
    ## neighbordb.h: ns3::WimaxNeighborEntry * ns3::NeighborDB::getNeighbor(ns3::Mac48Address nbid) [member function]
    cls.add_method('getNeighbor', 
                   'ns3::WimaxNeighborEntry *', 
                   [param('ns3::Mac48Address', 'nbid')])
    ## neighbordb.h: ns3::WimaxNeighborEntry * * ns3::NeighborDB::getNeighbors() [member function]
    cls.add_method('getNeighbors', 
                   'ns3::WimaxNeighborEntry * *', 
                   [])
    ## neighbordb.h: void ns3::NeighborDB::removeNeighbor(ns3::Mac48Address nbid) [member function]
    cls.add_method('removeNeighbor', 
                   'void', 
                   [param('ns3::Mac48Address', 'nbid')])
    return

def register_Ns3PacketTimerRecord_methods(root_module, cls):
    ## wimax2-timer.h: ns3::PacketTimerRecord::PacketTimerRecord(ns3::PacketTimerRecord const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::PacketTimerRecord const &', 'arg0')])
    ## wimax2-timer.h: ns3::PacketTimerRecord::PacketTimerRecord(ns3::Ptr<ns3::Wimax2NetDevice> m) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'm')])
    ## wimax2-timer.h: ns3::PacketTimerRecord::next [variable]
    cls.add_instance_attribute('next', 'ns3::PacketTimerRecord *', is_const=False)
    ## wimax2-timer.h: ns3::PacketTimerRecord::p [variable]
    cls.add_instance_attribute('p', 'ns3::Ptr< ns3::Packet >', is_const=False)
    ## wimax2-timer.h: ns3::PacketTimerRecord::prev [variable]
    cls.add_instance_attribute('prev', 'ns3::PacketTimerRecord *', is_const=False)
    ## wimax2-timer.h: ns3::PacketTimerRecord::timer [variable]
    cls.add_instance_attribute('timer', 'ns3::WimaxRxTimer', is_const=False)
    return

def register_Ns3PeerNode_methods(root_module, cls):
    ## peernode.h: ns3::PeerNode::PeerNode(ns3::PeerNode const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::PeerNode const &', 'arg0')])
    ## peernode.h: ns3::PeerNode::PeerNode(ns3::Mac48Address const & index) [constructor]
    cls.add_constructor([param('ns3::Mac48Address const &', 'index')])
    ## peernode.h: ns3::Mac48Address const & ns3::PeerNode::getAddr() [member function]
    cls.add_method('getAddr', 
                   'ns3::Mac48Address const &', 
                   [])
    ## peernode.h: ns3::Connection * ns3::PeerNode::getBasic(bool out) [member function]
    cls.add_method('getBasic', 
                   'ns3::Connection *', 
                   [param('bool', 'out')])
    ## peernode.h: int ns3::PeerNode::getDIUC() [member function]
    cls.add_method('getDIUC', 
                   'int', 
                   [])
    ## peernode.h: ns3::Connection * ns3::PeerNode::getInData() [member function]
    cls.add_method('getInData', 
                   'ns3::Connection *', 
                   [])
    ## peernode.h: ns3::Connection * ns3::PeerNode::getOutData() [member function]
    cls.add_method('getOutData', 
                   'ns3::Connection *', 
                   [])
    ## peernode.h: ns3::Connection * ns3::PeerNode::getPrimary(bool out) [member function]
    cls.add_method('getPrimary', 
                   'ns3::Connection *', 
                   [param('bool', 'out')])
    ## peernode.h: int ns3::PeerNode::getQueueLength() [member function]
    cls.add_method('getQueueLength', 
                   'int', 
                   [])
    ## peernode.h: int ns3::PeerNode::getReqBw() [member function]
    cls.add_method('getReqBw', 
                   'int', 
                   [])
    ## peernode.h: double ns3::PeerNode::getRxTime() [member function]
    cls.add_method('getRxTime', 
                   'double', 
                   [])
    ## peernode.h: ns3::Connection * ns3::PeerNode::getSecondary(bool out) [member function]
    cls.add_method('getSecondary', 
                   'ns3::Connection *', 
                   [param('bool', 'out')])
    ## peernode.h: int ns3::PeerNode::getchannel() [member function]
    cls.add_method('getchannel', 
                   'int', 
                   [])
    ## peernode.h: void ns3::PeerNode::insert_entry(ns3::peerNode_list * head) [member function]
    cls.add_method('insert_entry', 
                   'void', 
                   [param('ns3::peerNode_list *', 'head')])
    ## peernode.h: bool ns3::PeerNode::isGoingDown() [member function]
    cls.add_method('isGoingDown', 
                   'bool', 
                   [])
    ## peernode.h: ns3::PeerNode * ns3::PeerNode::next_entry() const [member function]
    cls.add_method('next_entry', 
                   'ns3::PeerNode *', 
                   [], 
                   is_const=True)
    ## peernode.h: void ns3::PeerNode::remove_entry() [member function]
    cls.add_method('remove_entry', 
                   'void', 
                   [])
    ## peernode.h: void ns3::PeerNode::setBasic(ns3::Connection * i_con, ns3::Connection * o_con) [member function]
    cls.add_method('setBasic', 
                   'void', 
                   [param('ns3::Connection *', 'i_con'), param('ns3::Connection *', 'o_con')])
    ## peernode.h: void ns3::PeerNode::setDIUC(int diuc) [member function]
    cls.add_method('setDIUC', 
                   'void', 
                   [param('int', 'diuc')])
    ## peernode.h: void ns3::PeerNode::setGoingDown(bool status) [member function]
    cls.add_method('setGoingDown', 
                   'void', 
                   [param('bool', 'status')])
    ## peernode.h: void ns3::PeerNode::setInData(ns3::Connection * connection) [member function]
    cls.add_method('setInData', 
                   'void', 
                   [param('ns3::Connection *', 'connection')])
    ## peernode.h: void ns3::PeerNode::setOutData(ns3::Connection * connection) [member function]
    cls.add_method('setOutData', 
                   'void', 
                   [param('ns3::Connection *', 'connection')])
    ## peernode.h: void ns3::PeerNode::setPrimary(ns3::Connection * i_con, ns3::Connection * o_con) [member function]
    cls.add_method('setPrimary', 
                   'void', 
                   [param('ns3::Connection *', 'i_con'), param('ns3::Connection *', 'o_con')])
    ## peernode.h: void ns3::PeerNode::setRxTime(double time) [member function]
    cls.add_method('setRxTime', 
                   'void', 
                   [param('double', 'time')])
    ## peernode.h: void ns3::PeerNode::setSecondary(ns3::Connection * i_con, ns3::Connection * o_con) [member function]
    cls.add_method('setSecondary', 
                   'void', 
                   [param('ns3::Connection *', 'i_con'), param('ns3::Connection *', 'o_con')])
    ## peernode.h: void ns3::PeerNode::setchannel(int channel) [member function]
    cls.add_method('setchannel', 
                   'void', 
                   [param('int', 'channel')])
    ## peernode.h: ns3::PeerNode::link [variable]
    cls.add_instance_attribute('link', 'ns3::peer_node_link', is_const=False)
    return

def register_Ns3Phy802_16MIB_methods(root_module, cls):
    ## wimax2-net-device.h: ns3::Phy802_16MIB::Phy802_16MIB(ns3::Phy802_16MIB const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::Phy802_16MIB const &', 'arg0')])
    ## wimax2-net-device.h: ns3::Phy802_16MIB::Phy802_16MIB() [constructor]
    cls.add_constructor([])
    ## wimax2-net-device.h: ns3::Phy802_16MIB::MIMO_enable [variable]
    cls.add_instance_attribute('MIMO_enable', 'unsigned char', is_const=False)
    ## wimax2-net-device.h: ns3::Phy802_16MIB::channel [variable]
    cls.add_instance_attribute('channel', 'int', is_const=False)
    ## wimax2-net-device.h: ns3::Phy802_16MIB::disableInterference [variable]
    cls.add_instance_attribute('disableInterference', 'int', is_const=False)
    ## wimax2-net-device.h: ns3::Phy802_16MIB::dl_perm [variable]
    cls.add_instance_attribute('dl_perm', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Phy802_16MIB::fbandwidth [variable]
    cls.add_instance_attribute('fbandwidth', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Phy802_16MIB::num_antenna [variable]
    cls.add_instance_attribute('num_antenna', 'unsigned char', is_const=False)
    ## wimax2-net-device.h: ns3::Phy802_16MIB::rtg [variable]
    cls.add_instance_attribute('rtg', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Phy802_16MIB::ttg [variable]
    cls.add_instance_attribute('ttg', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Phy802_16MIB::ul_perm [variable]
    cls.add_instance_attribute('ul_perm', 'uint32_t', is_const=False)
    return

def register_Ns3ServiceFlowHandler_methods(root_module, cls):
    ## wimax2-serviceflowhandler.h: ns3::ServiceFlowHandler::ServiceFlowHandler(ns3::ServiceFlowHandler const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::ServiceFlowHandler const &', 'arg0')])
    ## wimax2-serviceflowhandler.h: ns3::ServiceFlowHandler::ServiceFlowHandler() [constructor]
    cls.add_constructor([])
    ## wimax2-serviceflowhandler.h: ns3::Wimax2ServiceFlow * ns3::ServiceFlowHandler::addFlow(ns3::Wimax2ServiceFlowQoS * qos) [member function]
    cls.add_method('addFlow', 
                   'ns3::Wimax2ServiceFlow *', 
                   [param('ns3::Wimax2ServiceFlowQoS *', 'qos')])
    ## wimax2-serviceflowhandler.h: int ns3::ServiceFlowHandler::addStaticFlow(int argc, char const * const * argv) [member function]
    cls.add_method('addStaticFlow', 
                   'int', 
                   [param('int', 'argc'), param('char const * const *', 'argv')])
    ## wimax2-serviceflowhandler.h: int ns3::ServiceFlowHandler::addStaticFlow(bool UL, int drate, ns3::SchedulingType_t ft, int dsize, int prid, uint8_t arq_en, double arq_ret_time, uint32_t arq_maxwin, uint8_t ack_per, int traffic_pri, int peak_traffic_rate, int min_res_traffic_rate, int req_xmit_pol, int jitter, int sdu_indicator, int min_tol_traffic_rate, int sdusize, int max_burst_size, int said) [member function]
    cls.add_method('addStaticFlow', 
                   'int', 
                   [param('bool', 'UL'), param('int', 'drate'), param('ns3::SchedulingType_t', 'ft'), param('int', 'dsize'), param('int', 'prid'), param('uint8_t', 'arq_en'), param('double', 'arq_ret_time'), param('uint32_t', 'arq_maxwin'), param('uint8_t', 'ack_per'), param('int', 'traffic_pri'), param('int', 'peak_traffic_rate'), param('int', 'min_res_traffic_rate'), param('int', 'req_xmit_pol'), param('int', 'jitter'), param('int', 'sdu_indicator'), param('int', 'min_tol_traffic_rate'), param('int', 'sdusize'), param('int', 'max_burst_size'), param('int', 'said')])
    ## wimax2-serviceflowhandler.h: void ns3::ServiceFlowHandler::init_static_flows(ns3::Mac48Address index) [member function]
    cls.add_method('init_static_flows', 
                   'void', 
                   [param('ns3::Mac48Address', 'index')])
    ## wimax2-serviceflowhandler.h: void ns3::ServiceFlowHandler::process(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('process', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')])
    ## wimax2-serviceflowhandler.h: void ns3::ServiceFlowHandler::removeFlow(int id) [member function]
    cls.add_method('removeFlow', 
                   'void', 
                   [param('int', 'id')])
    ## wimax2-serviceflowhandler.h: void ns3::ServiceFlowHandler::sendFlowRequest(ns3::Mac48Address index, bool incoming) [member function]
    cls.add_method('sendFlowRequest', 
                   'void', 
                   [param('ns3::Mac48Address', 'index'), param('bool', 'incoming')])
    ## wimax2-serviceflowhandler.h: void ns3::ServiceFlowHandler::setMac(ns3::Ptr<ns3::Wimax2NetDevice> mac) [member function]
    cls.add_method('setMac', 
                   'void', 
                   [param('ns3::Ptr< ns3::Wimax2NetDevice >', 'mac')])
    ## wimax2-serviceflowhandler.h: void ns3::ServiceFlowHandler::processDSA_ack(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('processDSA_ack', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')], 
                   visibility='protected')
    ## wimax2-serviceflowhandler.h: void ns3::ServiceFlowHandler::processDSA_req(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('processDSA_req', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')], 
                   visibility='protected')
    ## wimax2-serviceflowhandler.h: void ns3::ServiceFlowHandler::processDSA_rsp(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('processDSA_rsp', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')], 
                   visibility='protected')
    return

def register_Ns3T17Element_methods(root_module, cls):
    ## wimax2-bs-net-device.h: ns3::T17Element::T17Element(ns3::T17Element const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::T17Element const &', 'arg0')])
    ## wimax2-bs-net-device.h: ns3::T17Element::T17Element(ns3::Ptr<ns3::Wimax2NetDevice> mac, ns3::Mac48Address index) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'mac'), param('ns3::Mac48Address', 'index')])
    ## wimax2-bs-net-device.h: int ns3::T17Element::busy() [member function]
    cls.add_method('busy', 
                   'int', 
                   [])
    ## wimax2-bs-net-device.h: void ns3::T17Element::cancel() [member function]
    cls.add_method('cancel', 
                   'void', 
                   [])
    ## wimax2-bs-net-device.h: ns3::Mac48Address ns3::T17Element::index() [member function]
    cls.add_method('index', 
                   'ns3::Mac48Address', 
                   [])
    ## wimax2-bs-net-device.h: void ns3::T17Element::insert_entry(ns3::t17Element_list * head) [member function]
    cls.add_method('insert_entry', 
                   'void', 
                   [param('ns3::t17Element_list *', 'head')])
    ## wimax2-bs-net-device.h: ns3::T17Element * ns3::T17Element::next_entry() const [member function]
    cls.add_method('next_entry', 
                   'ns3::T17Element *', 
                   [], 
                   is_const=True)
    ## wimax2-bs-net-device.h: int ns3::T17Element::paused() [member function]
    cls.add_method('paused', 
                   'int', 
                   [])
    ## wimax2-bs-net-device.h: void ns3::T17Element::remove_entry() [member function]
    cls.add_method('remove_entry', 
                   'void', 
                   [])
    ## wimax2-bs-net-device.h: ns3::T17Element::link [variable]
    cls.add_instance_attribute('link', 'ns3::t17_list_entry', is_const=False)
    return

def register_Ns3UlTimer_methods(root_module, cls):
    ## wimax2-timer.h: ns3::UlTimer::UlTimer(ns3::UlTimer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::UlTimer const &', 'arg0')])
    ## wimax2-timer.h: ns3::UlTimer::UlTimer(ns3::Ptr<ns3::Wimax2NetDevice> m) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'm')])
    ## wimax2-timer.h: void ns3::UlTimer::expire() [member function]
    cls.add_method('expire', 
                   'void', 
                   [])
    ## wimax2-timer.h: void ns3::UlTimer::resched(double d) [member function]
    cls.add_method('resched', 
                   'void', 
                   [param('double', 'd')])
    return

def register_Ns3Wimax2ServiceFlow_methods(root_module, cls):
    ## wimax2-serviceflow.h: ns3::Wimax2ServiceFlow::Wimax2ServiceFlow(ns3::Wimax2ServiceFlow const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::Wimax2ServiceFlow const &', 'arg0')])
    ## wimax2-serviceflow.h: ns3::Wimax2ServiceFlow::Wimax2ServiceFlow(ns3::SchedulingType_t arg0, ns3::Wimax2ServiceFlowQoS * arg1) [constructor]
    cls.add_constructor([param('ns3::SchedulingType_t', 'arg0'), param('ns3::Wimax2ServiceFlowQoS *', 'arg1')])
    ## wimax2-serviceflow.h: ns3::dir_t ns3::Wimax2ServiceFlow::getDirection() [member function]
    cls.add_method('getDirection', 
                   'ns3::dir_t', 
                   [])
    ## wimax2-serviceflow.h: int ns3::Wimax2ServiceFlow::getID() [member function]
    cls.add_method('getID', 
                   'int', 
                   [])
    ## wimax2-serviceflow.h: ns3::Wimax2ServiceFlowQoS * ns3::Wimax2ServiceFlow::getQoS() [member function]
    cls.add_method('getQoS', 
                   'ns3::Wimax2ServiceFlowQoS *', 
                   [])
    ## wimax2-serviceflow.h: ns3::SchedulingType_t ns3::Wimax2ServiceFlow::getScheduling() [member function]
    cls.add_method('getScheduling', 
                   'ns3::SchedulingType_t', 
                   [])
    ## wimax2-serviceflow.h: void ns3::Wimax2ServiceFlow::insert_entry(ns3::Wimax2ServiceFlow * elem) [member function]
    cls.add_method('insert_entry', 
                   'void', 
                   [param('ns3::Wimax2ServiceFlow *', 'elem')])
    ## wimax2-serviceflow.h: void ns3::Wimax2ServiceFlow::insert_entry_head(ns3::serviceflow_list * head) [member function]
    cls.add_method('insert_entry_head', 
                   'void', 
                   [param('ns3::serviceflow_list *', 'head')])
    ## wimax2-serviceflow.h: ns3::Wimax2ServiceFlow * ns3::Wimax2ServiceFlow::next_entry() const [member function]
    cls.add_method('next_entry', 
                   'ns3::Wimax2ServiceFlow *', 
                   [], 
                   is_const=True)
    ## wimax2-serviceflow.h: void ns3::Wimax2ServiceFlow::pickID() [member function]
    cls.add_method('pickID', 
                   'void', 
                   [])
    ## wimax2-serviceflow.h: void ns3::Wimax2ServiceFlow::remove_entry() [member function]
    cls.add_method('remove_entry', 
                   'void', 
                   [])
    ## wimax2-serviceflow.h: void ns3::Wimax2ServiceFlow::setDirection(ns3::dir_t dir) [member function]
    cls.add_method('setDirection', 
                   'void', 
                   [param('ns3::dir_t', 'dir')])
    ## wimax2-serviceflow.h: void ns3::Wimax2ServiceFlow::setID(int id) [member function]
    cls.add_method('setID', 
                   'void', 
                   [param('int', 'id')])
    ## wimax2-serviceflow.h: void ns3::Wimax2ServiceFlow::setQoS(ns3::Wimax2ServiceFlowQoS * qos) [member function]
    cls.add_method('setQoS', 
                   'void', 
                   [param('ns3::Wimax2ServiceFlowQoS *', 'qos')])
    ## wimax2-serviceflow.h: void ns3::Wimax2ServiceFlow::setScheduling(ns3::SchedulingType_t scheduling) [member function]
    cls.add_method('setScheduling', 
                   'void', 
                   [param('ns3::SchedulingType_t', 'scheduling')])
    ## wimax2-serviceflow.h: ns3::Wimax2ServiceFlow::link [variable]
    cls.add_instance_attribute('link', 'ns3::service_flow_link', is_const=False)
    return

def register_Ns3Wimax2ServiceFlowQoS_methods(root_module, cls):
    ## wimax2-serviceflowqos.h: ns3::Wimax2ServiceFlowQoS::Wimax2ServiceFlowQoS(ns3::Wimax2ServiceFlowQoS const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::Wimax2ServiceFlowQoS const &', 'arg0')])
    ## wimax2-serviceflowqos.h: ns3::Wimax2ServiceFlowQoS::Wimax2ServiceFlowQoS(int delay, int datarate, int burstsize) [constructor]
    cls.add_constructor([param('int', 'delay'), param('int', 'datarate'), param('int', 'burstsize')])
    ## wimax2-serviceflowqos.h: uint8_t ns3::Wimax2ServiceFlowQoS::getArqAckPeriod() [member function]
    cls.add_method('getArqAckPeriod', 
                   'uint8_t', 
                   [])
    ## wimax2-serviceflowqos.h: uint32_t ns3::Wimax2ServiceFlowQoS::getArqMaxWindow() [member function]
    cls.add_method('getArqMaxWindow', 
                   'uint32_t', 
                   [])
    ## wimax2-serviceflowqos.h: double ns3::Wimax2ServiceFlowQoS::getArqRetransTime() [member function]
    cls.add_method('getArqRetransTime', 
                   'double', 
                   [])
    ## wimax2-serviceflowqos.h: int ns3::Wimax2ServiceFlowQoS::getBurstSize() [member function]
    cls.add_method('getBurstSize', 
                   'int', 
                   [])
    ## wimax2-serviceflowqos.h: double ns3::Wimax2ServiceFlowQoS::getDataSize() [member function]
    cls.add_method('getDataSize', 
                   'double', 
                   [])
    ## wimax2-serviceflowqos.h: double ns3::Wimax2ServiceFlowQoS::getDatarate() [member function]
    cls.add_method('getDatarate', 
                   'double', 
                   [])
    ## wimax2-serviceflowqos.h: double ns3::Wimax2ServiceFlowQoS::getDelay() [member function]
    cls.add_method('getDelay', 
                   'double', 
                   [])
    ## wimax2-serviceflowqos.h: uint8_t ns3::Wimax2ServiceFlowQoS::getIsArqEnabled() [member function]
    cls.add_method('getIsArqEnabled', 
                   'uint8_t', 
                   [])
    ## wimax2-serviceflowqos.h: uint32_t ns3::Wimax2ServiceFlowQoS::getJitter() [member function]
    cls.add_method('getJitter', 
                   'uint32_t', 
                   [])
    ## wimax2-serviceflowqos.h: uint32_t ns3::Wimax2ServiceFlowQoS::getMaxBurstSize() [member function]
    cls.add_method('getMaxBurstSize', 
                   'uint32_t', 
                   [])
    ## wimax2-serviceflowqos.h: uint32_t ns3::Wimax2ServiceFlowQoS::getMinReservedRate() [member function]
    cls.add_method('getMinReservedRate', 
                   'uint32_t', 
                   [])
    ## wimax2-serviceflowqos.h: uint32_t ns3::Wimax2ServiceFlowQoS::getMinReservedTrafficRate() [member function]
    cls.add_method('getMinReservedTrafficRate', 
                   'uint32_t', 
                   [])
    ## wimax2-serviceflowqos.h: uint32_t ns3::Wimax2ServiceFlowQoS::getMinTolerableTrafficRate() [member function]
    cls.add_method('getMinTolerableTrafficRate', 
                   'uint32_t', 
                   [])
    ## wimax2-serviceflowqos.h: uint32_t ns3::Wimax2ServiceFlowQoS::getPeakTrafficRate() [member function]
    cls.add_method('getPeakTrafficRate', 
                   'uint32_t', 
                   [])
    ## wimax2-serviceflowqos.h: uint16_t ns3::Wimax2ServiceFlowQoS::getPeriod() [member function]
    cls.add_method('getPeriod', 
                   'uint16_t', 
                   [])
    ## wimax2-serviceflowqos.h: uint32_t ns3::Wimax2ServiceFlowQoS::getReqTransmitPolicy() [member function]
    cls.add_method('getReqTransmitPolicy', 
                   'uint32_t', 
                   [])
    ## wimax2-serviceflowqos.h: uint16_t ns3::Wimax2ServiceFlowQoS::getSAID() [member function]
    cls.add_method('getSAID', 
                   'uint16_t', 
                   [])
    ## wimax2-serviceflowqos.h: uint8_t ns3::Wimax2ServiceFlowQoS::getSDUIndicator() [member function]
    cls.add_method('getSDUIndicator', 
                   'uint8_t', 
                   [])
    ## wimax2-serviceflowqos.h: uint8_t ns3::Wimax2ServiceFlowQoS::getSDUSize() [member function]
    cls.add_method('getSDUSize', 
                   'uint8_t', 
                   [])
    ## wimax2-serviceflowqos.h: uint8_t ns3::Wimax2ServiceFlowQoS::getTrafficPriority() [member function]
    cls.add_method('getTrafficPriority', 
                   'uint8_t', 
                   [])
    ## wimax2-serviceflowqos.h: void ns3::Wimax2ServiceFlowQoS::setArqAckPeriod(uint8_t ack_period) [member function]
    cls.add_method('setArqAckPeriod', 
                   'void', 
                   [param('uint8_t', 'ack_period')])
    ## wimax2-serviceflowqos.h: void ns3::Wimax2ServiceFlowQoS::setArqMaxWindow(uint32_t arq_max_window) [member function]
    cls.add_method('setArqMaxWindow', 
                   'void', 
                   [param('uint32_t', 'arq_max_window')])
    ## wimax2-serviceflowqos.h: void ns3::Wimax2ServiceFlowQoS::setArqRetransTime(double arq_retrans_time) [member function]
    cls.add_method('setArqRetransTime', 
                   'void', 
                   [param('double', 'arq_retrans_time')])
    ## wimax2-serviceflowqos.h: void ns3::Wimax2ServiceFlowQoS::setBurstSize(int size) [member function]
    cls.add_method('setBurstSize', 
                   'void', 
                   [param('int', 'size')])
    ## wimax2-serviceflowqos.h: void ns3::Wimax2ServiceFlowQoS::setDataSize(double data_size) [member function]
    cls.add_method('setDataSize', 
                   'void', 
                   [param('double', 'data_size')])
    ## wimax2-serviceflowqos.h: void ns3::Wimax2ServiceFlowQoS::setDatarate(double datarate) [member function]
    cls.add_method('setDatarate', 
                   'void', 
                   [param('double', 'datarate')])
    ## wimax2-serviceflowqos.h: void ns3::Wimax2ServiceFlowQoS::setDelay(double delay) [member function]
    cls.add_method('setDelay', 
                   'void', 
                   [param('double', 'delay')])
    ## wimax2-serviceflowqos.h: void ns3::Wimax2ServiceFlowQoS::setIsArqEnabled(uint8_t is_arq_enabled) [member function]
    cls.add_method('setIsArqEnabled', 
                   'void', 
                   [param('uint8_t', 'is_arq_enabled')])
    ## wimax2-serviceflowqos.h: void ns3::Wimax2ServiceFlowQoS::setJitter(uint32_t jitter) [member function]
    cls.add_method('setJitter', 
                   'void', 
                   [param('uint32_t', 'jitter')])
    ## wimax2-serviceflowqos.h: void ns3::Wimax2ServiceFlowQoS::setMaxBurstSize(uint32_t max_burst_size) [member function]
    cls.add_method('setMaxBurstSize', 
                   'void', 
                   [param('uint32_t', 'max_burst_size')])
    ## wimax2-serviceflowqos.h: void ns3::Wimax2ServiceFlowQoS::setMinReservedTrafficRate(uint32_t min_reserved_traffic_rate) [member function]
    cls.add_method('setMinReservedTrafficRate', 
                   'void', 
                   [param('uint32_t', 'min_reserved_traffic_rate')])
    ## wimax2-serviceflowqos.h: void ns3::Wimax2ServiceFlowQoS::setMinTolerableTrafficRate(uint32_t min_tolerable_traffic_rate) [member function]
    cls.add_method('setMinTolerableTrafficRate', 
                   'void', 
                   [param('uint32_t', 'min_tolerable_traffic_rate')])
    ## wimax2-serviceflowqos.h: void ns3::Wimax2ServiceFlowQoS::setPeakTrafficRate(uint32_t peak_traffic_rate) [member function]
    cls.add_method('setPeakTrafficRate', 
                   'void', 
                   [param('uint32_t', 'peak_traffic_rate')])
    ## wimax2-serviceflowqos.h: void ns3::Wimax2ServiceFlowQoS::setPeriod(uint16_t period) [member function]
    cls.add_method('setPeriod', 
                   'void', 
                   [param('uint16_t', 'period')])
    ## wimax2-serviceflowqos.h: void ns3::Wimax2ServiceFlowQoS::setReqTransmitPolicy(uint32_t reqtransmit_policy) [member function]
    cls.add_method('setReqTransmitPolicy', 
                   'void', 
                   [param('uint32_t', 'reqtransmit_policy')])
    ## wimax2-serviceflowqos.h: void ns3::Wimax2ServiceFlowQoS::setSAID(uint16_t said) [member function]
    cls.add_method('setSAID', 
                   'void', 
                   [param('uint16_t', 'said')])
    ## wimax2-serviceflowqos.h: void ns3::Wimax2ServiceFlowQoS::setSDUIndicator(uint8_t sdu_indicator) [member function]
    cls.add_method('setSDUIndicator', 
                   'void', 
                   [param('uint8_t', 'sdu_indicator')])
    ## wimax2-serviceflowqos.h: void ns3::Wimax2ServiceFlowQoS::setSDUSize(uint8_t sdu_size) [member function]
    cls.add_method('setSDUSize', 
                   'void', 
                   [param('uint8_t', 'sdu_size')])
    ## wimax2-serviceflowqos.h: void ns3::Wimax2ServiceFlowQoS::setTrafficPriority(uint8_t traffic_priority) [member function]
    cls.add_method('setTrafficPriority', 
                   'void', 
                   [param('uint8_t', 'traffic_priority')])
    return

def register_Ns3Wimax2Timer_methods(root_module, cls):
    ## wimax2-timer.h: ns3::Wimax2Timer::Wimax2Timer(ns3::Wimax2Timer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::Wimax2Timer const &', 'arg0')])
    ## wimax2-timer.h: ns3::Wimax2Timer::Wimax2Timer(ns3::Ptr<ns3::Wimax2NetDevice> m) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'm')])
    ## wimax2-timer.h: int ns3::Wimax2Timer::busy() [member function]
    cls.add_method('busy', 
                   'int', 
                   [])
    ## wimax2-timer.h: double ns3::Wimax2Timer::expire() [member function]
    cls.add_method('expire', 
                   'double', 
                   [])
    ## wimax2-timer.h: void ns3::Wimax2Timer::handle() [member function]
    cls.add_method('handle', 
                   'void', 
                   [], 
                   is_pure_virtual=True, is_virtual=True)
    ## wimax2-timer.h: void ns3::Wimax2Timer::pause() [member function]
    cls.add_method('pause', 
                   'void', 
                   [])
    ## wimax2-timer.h: int ns3::Wimax2Timer::paused() [member function]
    cls.add_method('paused', 
                   'int', 
                   [])
    ## wimax2-timer.h: void ns3::Wimax2Timer::resched(double delay) [member function]
    cls.add_method('resched', 
                   'void', 
                   [param('double', 'delay')])
    ## wimax2-timer.h: void ns3::Wimax2Timer::resched_absolute(double expiration_time) [member function]
    cls.add_method('resched_absolute', 
                   'void', 
                   [param('double', 'expiration_time')])
    ## wimax2-timer.h: void ns3::Wimax2Timer::resume() [member function]
    cls.add_method('resume', 
                   'void', 
                   [])
    ## wimax2-timer.h: void ns3::Wimax2Timer::start(double time) [member function]
    cls.add_method('start', 
                   'void', 
                   [param('double', 'time')], 
                   is_virtual=True)
    ## wimax2-timer.h: int ns3::Wimax2Timer::status() [member function]
    cls.add_method('status', 
                   'int', 
                   [])
    ## wimax2-timer.h: void ns3::Wimax2Timer::stop() [member function]
    cls.add_method('stop', 
                   'void', 
                   [], 
                   is_virtual=True)
    ## wimax2-timer.h: ns3::Wimax2Timer::busy_ [variable]
    cls.add_instance_attribute('busy_', 'int', is_const=False)
    ## wimax2-timer.h: ns3::Wimax2Timer::intr [variable]
    cls.add_instance_attribute('intr', 'ns3::EventId', is_const=False)
    ## wimax2-timer.h: ns3::Wimax2Timer::mac [variable]
    cls.add_instance_attribute('mac', 'ns3::Ptr< ns3::Wimax2NetDevice >', is_const=False)
    ## wimax2-timer.h: ns3::Wimax2Timer::paused_ [variable]
    cls.add_instance_attribute('paused_', 'int', is_const=False)
    ## wimax2-timer.h: ns3::Wimax2Timer::rtime [variable]
    cls.add_instance_attribute('rtime', 'double', is_const=False)
    ## wimax2-timer.h: ns3::Wimax2Timer::status_ [variable]
    cls.add_instance_attribute('status_', 'int', is_const=False)
    ## wimax2-timer.h: ns3::Wimax2Timer::stime [variable]
    cls.add_instance_attribute('stime', 'double', is_const=False)
    return

def register_Ns3WimaxDCDTimer_methods(root_module, cls):
    ## wimax2-timer.h: ns3::WimaxDCDTimer::WimaxDCDTimer(ns3::WimaxDCDTimer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::WimaxDCDTimer const &', 'arg0')])
    ## wimax2-timer.h: ns3::WimaxDCDTimer::WimaxDCDTimer(ns3::Ptr<ns3::Wimax2NetDevice> m) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'm')])
    ## wimax2-timer.h: void ns3::WimaxDCDTimer::handle() [member function]
    cls.add_method('handle', 
                   'void', 
                   [], 
                   is_virtual=True)
    return

def register_Ns3WimaxLostDLMAPTimer_methods(root_module, cls):
    ## wimax2-timer.h: ns3::WimaxLostDLMAPTimer::WimaxLostDLMAPTimer(ns3::WimaxLostDLMAPTimer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::WimaxLostDLMAPTimer const &', 'arg0')])
    ## wimax2-timer.h: ns3::WimaxLostDLMAPTimer::WimaxLostDLMAPTimer(ns3::Ptr<ns3::Wimax2NetDevice> m) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'm')])
    ## wimax2-timer.h: void ns3::WimaxLostDLMAPTimer::handle() [member function]
    cls.add_method('handle', 
                   'void', 
                   [], 
                   is_virtual=True)
    return

def register_Ns3WimaxLostULMAPTimer_methods(root_module, cls):
    ## wimax2-timer.h: ns3::WimaxLostULMAPTimer::WimaxLostULMAPTimer(ns3::WimaxLostULMAPTimer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::WimaxLostULMAPTimer const &', 'arg0')])
    ## wimax2-timer.h: ns3::WimaxLostULMAPTimer::WimaxLostULMAPTimer(ns3::Ptr<ns3::Wimax2NetDevice> m) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'm')])
    ## wimax2-timer.h: void ns3::WimaxLostULMAPTimer::handle() [member function]
    cls.add_method('handle', 
                   'void', 
                   [], 
                   is_virtual=True)
    return

def register_Ns3WimaxMobNbrAdvTimer_methods(root_module, cls):
    ## wimax2-timer.h: ns3::WimaxMobNbrAdvTimer::WimaxMobNbrAdvTimer(ns3::WimaxMobNbrAdvTimer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::WimaxMobNbrAdvTimer const &', 'arg0')])
    ## wimax2-timer.h: ns3::WimaxMobNbrAdvTimer::WimaxMobNbrAdvTimer(ns3::Ptr<ns3::Wimax2NetDevice> m) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'm')])
    ## wimax2-timer.h: void ns3::WimaxMobNbrAdvTimer::handle() [member function]
    cls.add_method('handle', 
                   'void', 
                   [], 
                   is_virtual=True)
    return

def register_Ns3WimaxNeighborEntry_methods(root_module, cls):
    ## wimaxneighborentry.h: ns3::WimaxNeighborEntry::WimaxNeighborEntry(ns3::WimaxNeighborEntry const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::WimaxNeighborEntry const &', 'arg0')])
    ## wimaxneighborentry.h: ns3::WimaxNeighborEntry::WimaxNeighborEntry(ns3::Mac48Address id) [constructor]
    cls.add_constructor([param('ns3::Mac48Address', 'id')])
    ## wimaxneighborentry.h: ns3::DCD_FRAME_HEADER * ns3::WimaxNeighborEntry::getDCD() [member function]
    cls.add_method('getDCD', 
                   'ns3::DCD_FRAME_HEADER *', 
                   [])
    ## wimaxneighborentry.h: ns3::Mac48Address ns3::WimaxNeighborEntry::getID() [member function]
    cls.add_method('getID', 
                   'ns3::Mac48Address', 
                   [])
    ## wimaxneighborentry.h: ns3::mac802_16_nbr_adv_info * ns3::WimaxNeighborEntry::getNbrAdvMessage() [member function]
    cls.add_method('getNbrAdvMessage', 
                   'ns3::mac802_16_nbr_adv_info *', 
                   [])
    ## wimaxneighborentry.h: ns3::RANGING_RESPONSE_FRAME * ns3::WimaxNeighborEntry::getRangingRsp() [member function]
    cls.add_method('getRangingRsp', 
                   'ns3::RANGING_RESPONSE_FRAME *', 
                   [])
    ## wimaxneighborentry.h: ns3::sched_state_info * ns3::WimaxNeighborEntry::getState() [member function]
    cls.add_method('getState', 
                   'ns3::sched_state_info *', 
                   [])
    ## wimaxneighborentry.h: ns3::UCD_FRAME_DATA * ns3::WimaxNeighborEntry::getUCD() [member function]
    cls.add_method('getUCD', 
                   'ns3::UCD_FRAME_DATA *', 
                   [])
    ## wimaxneighborentry.h: bool ns3::WimaxNeighborEntry::isDetected() [member function]
    cls.add_method('isDetected', 
                   'bool', 
                   [])
    ## wimaxneighborentry.h: void ns3::WimaxNeighborEntry::setDCD(ns3::DCD_FRAME_HEADER * frame) [member function]
    cls.add_method('setDCD', 
                   'void', 
                   [param('ns3::DCD_FRAME_HEADER *', 'frame')])
    ## wimaxneighborentry.h: void ns3::WimaxNeighborEntry::setDetected(bool detected) [member function]
    cls.add_method('setDetected', 
                   'void', 
                   [param('bool', 'detected')])
    ## wimaxneighborentry.h: void ns3::WimaxNeighborEntry::setNbrAdvMessage(ns3::mac802_16_nbr_adv_info * frame) [member function]
    cls.add_method('setNbrAdvMessage', 
                   'void', 
                   [param('ns3::mac802_16_nbr_adv_info *', 'frame')])
    ## wimaxneighborentry.h: void ns3::WimaxNeighborEntry::setRangingRsp(ns3::RANGING_RESPONSE_FRAME * frame) [member function]
    cls.add_method('setRangingRsp', 
                   'void', 
                   [param('ns3::RANGING_RESPONSE_FRAME *', 'frame')])
    ## wimaxneighborentry.h: void ns3::WimaxNeighborEntry::setUCD(ns3::UCD_FRAME_DATA * frame) [member function]
    cls.add_method('setUCD', 
                   'void', 
                   [param('ns3::UCD_FRAME_DATA *', 'frame')])
    return

def register_Ns3WimaxRdvTimer_methods(root_module, cls):
    ## wimax2-timer.h: ns3::WimaxRdvTimer::WimaxRdvTimer(ns3::WimaxRdvTimer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::WimaxRdvTimer const &', 'arg0')])
    ## wimax2-timer.h: ns3::WimaxRdvTimer::WimaxRdvTimer(ns3::Ptr<ns3::Wimax2NetDevice> m, int channel) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'm'), param('int', 'channel')])
    ## wimax2-timer.h: void ns3::WimaxRdvTimer::handle() [member function]
    cls.add_method('handle', 
                   'void', 
                   [], 
                   is_virtual=True)
    return

def register_Ns3WimaxRngIntTimer_methods(root_module, cls):
    ## wimax2-timer.h: ns3::WimaxRngIntTimer::WimaxRngIntTimer(ns3::WimaxRngIntTimer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::WimaxRngIntTimer const &', 'arg0')])
    ## wimax2-timer.h: ns3::WimaxRngIntTimer::WimaxRngIntTimer(ns3::Ptr<ns3::Wimax2NetDevice> m) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'm')])
    ## wimax2-timer.h: void ns3::WimaxRngIntTimer::handle() [member function]
    cls.add_method('handle', 
                   'void', 
                   [], 
                   is_virtual=True)
    return

def register_Ns3WimaxRxTimer_methods(root_module, cls):
    ## wimax2-timer.h: ns3::WimaxRxTimer::WimaxRxTimer(ns3::WimaxRxTimer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::WimaxRxTimer const &', 'arg0')])
    ## wimax2-timer.h: ns3::WimaxRxTimer::WimaxRxTimer(ns3::Ptr<ns3::Wimax2NetDevice> m, ns3::PacketTimerRecord * ptr) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'm'), param('ns3::PacketTimerRecord *', 'ptr')])
    ## wimax2-timer.h: void ns3::WimaxRxTimer::handle() [member function]
    cls.add_method('handle', 
                   'void', 
                   [], 
                   is_virtual=True)
    ## wimax2-timer.h: ns3::WimaxRxTimer::record_ [variable]
    cls.add_instance_attribute('record_', 'ns3::PacketTimerRecord *', is_const=False)
    return

def register_Ns3WimaxScanIntervalTimer_methods(root_module, cls):
    ## wimax2-timer.h: ns3::WimaxScanIntervalTimer::WimaxScanIntervalTimer(ns3::WimaxScanIntervalTimer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::WimaxScanIntervalTimer const &', 'arg0')])
    ## wimax2-timer.h: ns3::WimaxScanIntervalTimer::WimaxScanIntervalTimer(ns3::Ptr<ns3::Wimax2NetDevice> m) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'm')])
    ## wimax2-timer.h: void ns3::WimaxScanIntervalTimer::handle() [member function]
    cls.add_method('handle', 
                   'void', 
                   [], 
                   is_virtual=True)
    return

def register_Ns3WimaxT12Timer_methods(root_module, cls):
    ## wimax2-timer.h: ns3::WimaxT12Timer::WimaxT12Timer(ns3::WimaxT12Timer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::WimaxT12Timer const &', 'arg0')])
    ## wimax2-timer.h: ns3::WimaxT12Timer::WimaxT12Timer(ns3::Ptr<ns3::Wimax2NetDevice> m) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'm')])
    ## wimax2-timer.h: void ns3::WimaxT12Timer::handle() [member function]
    cls.add_method('handle', 
                   'void', 
                   [], 
                   is_virtual=True)
    return

def register_Ns3WimaxT16Timer_methods(root_module, cls):
    ## wimax2-timer.h: ns3::WimaxT16Timer::WimaxT16Timer(ns3::WimaxT16Timer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::WimaxT16Timer const &', 'arg0')])
    ## wimax2-timer.h: ns3::WimaxT16Timer::WimaxT16Timer(ns3::Ptr<ns3::Wimax2NetDevice> m) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'm')])
    ## wimax2-timer.h: void ns3::WimaxT16Timer::handle() [member function]
    cls.add_method('handle', 
                   'void', 
                   [], 
                   is_virtual=True)
    return

def register_Ns3WimaxT17Timer_methods(root_module, cls):
    ## wimax2-timer.h: ns3::WimaxT17Timer::WimaxT17Timer(ns3::WimaxT17Timer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::WimaxT17Timer const &', 'arg0')])
    ## wimax2-timer.h: ns3::WimaxT17Timer::WimaxT17Timer(ns3::Ptr<ns3::Wimax2NetDevice> m, ns3::Mac48Address peerIndex) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'm'), param('ns3::Mac48Address', 'peerIndex')])
    ## wimax2-timer.h: void ns3::WimaxT17Timer::handle() [member function]
    cls.add_method('handle', 
                   'void', 
                   [], 
                   is_virtual=True)
    return

def register_Ns3WimaxT1Timer_methods(root_module, cls):
    ## wimax2-timer.h: ns3::WimaxT1Timer::WimaxT1Timer(ns3::WimaxT1Timer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::WimaxT1Timer const &', 'arg0')])
    ## wimax2-timer.h: ns3::WimaxT1Timer::WimaxT1Timer(ns3::Ptr<ns3::Wimax2NetDevice> m) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'm')])
    ## wimax2-timer.h: void ns3::WimaxT1Timer::handle() [member function]
    cls.add_method('handle', 
                   'void', 
                   [], 
                   is_virtual=True)
    return

def register_Ns3WimaxT21Timer_methods(root_module, cls):
    ## wimax2-timer.h: ns3::WimaxT21Timer::WimaxT21Timer(ns3::WimaxT21Timer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::WimaxT21Timer const &', 'arg0')])
    ## wimax2-timer.h: ns3::WimaxT21Timer::WimaxT21Timer(ns3::Ptr<ns3::Wimax2NetDevice> m) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'm')])
    ## wimax2-timer.h: void ns3::WimaxT21Timer::handle() [member function]
    cls.add_method('handle', 
                   'void', 
                   [], 
                   is_virtual=True)
    return

def register_Ns3WimaxT2Timer_methods(root_module, cls):
    ## wimax2-timer.h: ns3::WimaxT2Timer::WimaxT2Timer(ns3::WimaxT2Timer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::WimaxT2Timer const &', 'arg0')])
    ## wimax2-timer.h: ns3::WimaxT2Timer::WimaxT2Timer(ns3::Ptr<ns3::Wimax2NetDevice> m) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'm')])
    ## wimax2-timer.h: void ns3::WimaxT2Timer::handle() [member function]
    cls.add_method('handle', 
                   'void', 
                   [], 
                   is_virtual=True)
    return

def register_Ns3WimaxT3Timer_methods(root_module, cls):
    ## wimax2-timer.h: ns3::WimaxT3Timer::WimaxT3Timer(ns3::WimaxT3Timer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::WimaxT3Timer const &', 'arg0')])
    ## wimax2-timer.h: ns3::WimaxT3Timer::WimaxT3Timer(ns3::Ptr<ns3::Wimax2NetDevice> m) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'm')])
    ## wimax2-timer.h: void ns3::WimaxT3Timer::handle() [member function]
    cls.add_method('handle', 
                   'void', 
                   [], 
                   is_virtual=True)
    return

def register_Ns3WimaxT44Timer_methods(root_module, cls):
    ## wimax2-timer.h: ns3::WimaxT44Timer::WimaxT44Timer(ns3::WimaxT44Timer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::WimaxT44Timer const &', 'arg0')])
    ## wimax2-timer.h: ns3::WimaxT44Timer::WimaxT44Timer(ns3::Ptr<ns3::Wimax2NetDevice> m) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'm')])
    ## wimax2-timer.h: void ns3::WimaxT44Timer::handle() [member function]
    cls.add_method('handle', 
                   'void', 
                   [], 
                   is_virtual=True)
    return

def register_Ns3WimaxT6Timer_methods(root_module, cls):
    ## wimax2-timer.h: ns3::WimaxT6Timer::WimaxT6Timer(ns3::WimaxT6Timer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::WimaxT6Timer const &', 'arg0')])
    ## wimax2-timer.h: ns3::WimaxT6Timer::WimaxT6Timer(ns3::Ptr<ns3::Wimax2NetDevice> m) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'm')])
    ## wimax2-timer.h: void ns3::WimaxT6Timer::handle() [member function]
    cls.add_method('handle', 
                   'void', 
                   [], 
                   is_virtual=True)
    return

def register_Ns3WimaxT9Timer_methods(root_module, cls):
    ## wimax2-timer.h: ns3::WimaxT9Timer::WimaxT9Timer(ns3::WimaxT9Timer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::WimaxT9Timer const &', 'arg0')])
    ## wimax2-timer.h: ns3::WimaxT9Timer::WimaxT9Timer(ns3::Ptr<ns3::Wimax2NetDevice> m) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'm')])
    ## wimax2-timer.h: void ns3::WimaxT9Timer::handle() [member function]
    cls.add_method('handle', 
                   'void', 
                   [], 
                   is_virtual=True)
    return

def register_Ns3WimaxUCDTimer_methods(root_module, cls):
    ## wimax2-timer.h: ns3::WimaxUCDTimer::WimaxUCDTimer(ns3::WimaxUCDTimer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::WimaxUCDTimer const &', 'arg0')])
    ## wimax2-timer.h: ns3::WimaxUCDTimer::WimaxUCDTimer(ns3::Ptr<ns3::Wimax2NetDevice> m) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'm')])
    ## wimax2-timer.h: void ns3::WimaxUCDTimer::handle() [member function]
    cls.add_method('handle', 
                   'void', 
                   [], 
                   is_virtual=True)
    return

def register_Ns3Arq_fb_ie_methods(root_module, cls):
    ## 802_16headers.h: ns3::arq_fb_ie::arq_fb_ie() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::arq_fb_ie::arq_fb_ie(ns3::arq_fb_ie const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::arq_fb_ie const &', 'arg0')])
    ## 802_16headers.h: ns3::arq_fb_ie::ack_type [variable]
    cls.add_instance_attribute('ack_type', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::arq_fb_ie::cid [variable]
    cls.add_instance_attribute('cid', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::arq_fb_ie::fsn [variable]
    cls.add_instance_attribute('fsn', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::arq_fb_ie::last [variable]
    cls.add_instance_attribute('last', 'uint8_t', is_const=False)
    return

def register_Ns3Bw_req_header_t_methods(root_module, cls):
    ## 802_16headers.h: ns3::bw_req_header_t::bw_req_header_t() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::bw_req_header_t::bw_req_header_t(ns3::bw_req_header_t const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::bw_req_header_t const &', 'arg0')])
    ## 802_16headers.h: ns3::bw_req_header_t::br [variable]
    cls.add_instance_attribute('br', 'uint32_t', is_const=False)
    ## 802_16headers.h: ns3::bw_req_header_t::cid [variable]
    cls.add_instance_attribute('cid', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::bw_req_header_t::ec [variable]
    cls.add_instance_attribute('ec', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::bw_req_header_t::hcs [variable]
    cls.add_instance_attribute('hcs', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::bw_req_header_t::ht [variable]
    cls.add_instance_attribute('ht', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::bw_req_header_t::type [variable]
    cls.add_instance_attribute('type', 'uint8_t', is_const=False)
    return

def register_Ns3Cdma_connection_methods(root_module, cls):
    ## connection.h: ns3::cdma_connection::cdma_connection() [constructor]
    cls.add_constructor([])
    ## connection.h: ns3::cdma_connection::cdma_connection(ns3::cdma_connection const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::cdma_connection const &', 'arg0')])
    ## connection.h: ns3::cdma_connection::cdma_cid [variable]
    cls.add_instance_attribute('cdma_cid', 'int', is_const=False)
    ## connection.h: ns3::cdma_connection::cdma_code [variable]
    cls.add_instance_attribute('cdma_code', 'uint8_t', is_const=False)
    ## connection.h: ns3::cdma_connection::cdma_flag [variable]
    cls.add_instance_attribute('cdma_flag', 'int', is_const=False)
    ## connection.h: ns3::cdma_connection::cdma_ssid [variable]
    cls.add_instance_attribute('cdma_ssid', 'int', is_const=False)
    ## connection.h: ns3::cdma_connection::cdma_top [variable]
    cls.add_instance_attribute('cdma_top', 'uint8_t', is_const=False)
    return

def register_Ns3Cdma_req_header_t_methods(root_module, cls):
    ## 802_16headers.h: ns3::cdma_req_header_t::cdma_req_header_t() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::cdma_req_header_t::cdma_req_header_t(ns3::cdma_req_header_t const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::cdma_req_header_t const &', 'arg0')])
    ## 802_16headers.h: ns3::cdma_req_header_t::br [variable]
    cls.add_instance_attribute('br', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::cdma_req_header_t::cid [variable]
    cls.add_instance_attribute('cid', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::cdma_req_header_t::code [variable]
    cls.add_instance_attribute('code', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::cdma_req_header_t::ec [variable]
    cls.add_instance_attribute('ec', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::cdma_req_header_t::ht [variable]
    cls.add_instance_attribute('ht', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::cdma_req_header_t::top [variable]
    cls.add_instance_attribute('top', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::cdma_req_header_t::type [variable]
    cls.add_instance_attribute('type', 'uint8_t', is_const=False)
    return

def register_Ns3Conn_list_entry_methods(root_module, cls):
    ## connection.h: ns3::conn_list_entry::conn_list_entry() [constructor]
    cls.add_constructor([])
    ## connection.h: ns3::conn_list_entry::conn_list_entry(ns3::conn_list_entry const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::conn_list_entry const &', 'arg0')])
    ## connection.h: ns3::conn_list_entry::le_next [variable]
    cls.add_instance_attribute('le_next', 'ns3::Connection *', is_const=False)
    ## connection.h: ns3::conn_list_entry::le_prev [variable]
    cls.add_instance_attribute('le_prev', 'ns3::Connection * *', is_const=False)
    return

def register_Ns3Connection_list_methods(root_module, cls):
    ## connection.h: ns3::connection_list::connection_list() [constructor]
    cls.add_constructor([])
    ## connection.h: ns3::connection_list::connection_list(ns3::connection_list const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::connection_list const &', 'arg0')])
    ## connection.h: ns3::connection_list::lh_first [variable]
    cls.add_instance_attribute('lh_first', 'ns3::Connection *', is_const=False)
    return

def register_Ns3FastRangingInfo_list_methods(root_module, cls):
    ## wimax2-bs-net-device.h: ns3::fastRangingInfo_list::fastRangingInfo_list() [constructor]
    cls.add_constructor([])
    ## wimax2-bs-net-device.h: ns3::fastRangingInfo_list::fastRangingInfo_list(ns3::fastRangingInfo_list const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::fastRangingInfo_list const &', 'arg0')])
    ## wimax2-bs-net-device.h: ns3::fastRangingInfo_list::lh_first [variable]
    cls.add_instance_attribute('lh_first', 'ns3::FastRangingInfo *', is_const=False)
    return

def register_Ns3Fast_ranging_list_entry_methods(root_module, cls):
    ## wimax2-bs-net-device.h: ns3::fast_ranging_list_entry::fast_ranging_list_entry() [constructor]
    cls.add_constructor([])
    ## wimax2-bs-net-device.h: ns3::fast_ranging_list_entry::fast_ranging_list_entry(ns3::fast_ranging_list_entry const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::fast_ranging_list_entry const &', 'arg0')])
    ## wimax2-bs-net-device.h: ns3::fast_ranging_list_entry::le_next [variable]
    cls.add_instance_attribute('le_next', 'ns3::FastRangingInfo *', is_const=False)
    ## wimax2-bs-net-device.h: ns3::fast_ranging_list_entry::le_prev [variable]
    cls.add_instance_attribute('le_prev', 'ns3::FastRangingInfo * *', is_const=False)
    return

def register_Ns3Ffb_subheader_s_methods(root_module, cls):
    ## 802_16headers.h: ns3::ffb_subheader_s::ffb_subheader_s() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::ffb_subheader_s::ffb_subheader_s(ns3::ffb_subheader_s const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::ffb_subheader_s const &', 'arg0')])
    ## 802_16headers.h: ns3::ffb_subheader_s::alloc_offset [variable]
    cls.add_instance_attribute('alloc_offset', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::ffb_subheader_s::type [variable]
    cls.add_instance_attribute('type', 'uint8_t', is_const=False)
    return

def register_Ns3Frag_subheader_s_methods(root_module, cls):
    ## 802_16headers.h: ns3::frag_subheader_s::frag_subheader_s() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::frag_subheader_s::frag_subheader_s(ns3::frag_subheader_s const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::frag_subheader_s const &', 'arg0')])
    ## 802_16headers.h: ns3::frag_subheader_s::fc [variable]
    cls.add_instance_attribute('fc', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::frag_subheader_s::fsn [variable]
    cls.add_instance_attribute('fsn', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::frag_subheader_s::rsv [variable]
    cls.add_instance_attribute('rsv', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::frag_subheader_s::sn [variable]
    cls.add_instance_attribute('sn', 'uint16_t', is_const=False)
    return

def register_Ns3Gen_mac_header_t_methods(root_module, cls):
    ## 802_16headers.h: ns3::gen_mac_header_t::gen_mac_header_t() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::gen_mac_header_t::gen_mac_header_t(ns3::gen_mac_header_t const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::gen_mac_header_t const &', 'arg0')])
    ## 802_16headers.h: ns3::gen_mac_header_t::ci [variable]
    cls.add_instance_attribute('ci', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::gen_mac_header_t::cid [variable]
    cls.add_instance_attribute('cid', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::gen_mac_header_t::ec [variable]
    cls.add_instance_attribute('ec', 'bool', is_const=False)
    ## 802_16headers.h: ns3::gen_mac_header_t::eks [variable]
    cls.add_instance_attribute('eks', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::gen_mac_header_t::hcs [variable]
    cls.add_instance_attribute('hcs', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::gen_mac_header_t::ht [variable]
    cls.add_instance_attribute('ht', 'bool', is_const=False)
    ## 802_16headers.h: ns3::gen_mac_header_t::len [variable]
    cls.add_instance_attribute('len', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::gen_mac_header_t::rsv1 [variable]
    cls.add_instance_attribute('rsv1', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::gen_mac_header_t::rsv2 [variable]
    cls.add_instance_attribute('rsv2', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::gen_mac_header_t::type_arqfb [variable]
    cls.add_instance_attribute('type_arqfb', 'bool', is_const=False)
    ## 802_16headers.h: ns3::gen_mac_header_t::type_ext [variable]
    cls.add_instance_attribute('type_ext', 'bool', is_const=False)
    ## 802_16headers.h: ns3::gen_mac_header_t::type_fbgm [variable]
    cls.add_instance_attribute('type_fbgm', 'bool', is_const=False)
    ## 802_16headers.h: ns3::gen_mac_header_t::type_frag [variable]
    cls.add_instance_attribute('type_frag', 'bool', is_const=False)
    ## 802_16headers.h: ns3::gen_mac_header_t::type_mesh [variable]
    cls.add_instance_attribute('type_mesh', 'bool', is_const=False)
    ## 802_16headers.h: ns3::gen_mac_header_t::type_pck [variable]
    cls.add_instance_attribute('type_pck', 'bool', is_const=False)
    return

def register_Ns3Grant_map_ugs_s_methods(root_module, cls):
    ## 802_16headers.h: ns3::grant_map_ugs_s::grant_map_ugs_s() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::grant_map_ugs_s::grant_map_ugs_s(ns3::grant_map_ugs_s const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::grant_map_ugs_s const &', 'arg0')])
    ## 802_16headers.h: ns3::grant_map_ugs_s::pm [variable]
    cls.add_instance_attribute('pm', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::grant_map_ugs_s::rsv [variable]
    cls.add_instance_attribute('rsv', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::grant_map_ugs_s::si [variable]
    cls.add_instance_attribute('si', 'uint8_t', is_const=False)
    return

def register_Ns3Grant_subheader_s_methods(root_module, cls):
    ## 802_16headers.h: ns3::grant_subheader_s::grant_subheader_s() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::grant_subheader_s::grant_subheader_s(ns3::grant_subheader_s const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::grant_subheader_s const &', 'arg0')])
    ## 802_16headers.h: ns3::grant_subheader_s::piggyback_req [variable]
    cls.add_instance_attribute('piggyback_req', 'uint16_t', is_const=False)
    return

def register_Ns3Incoming_packet_methods(root_module, cls):
    ## wimax2-net-device.h: ns3::incoming_packet::incoming_packet() [constructor]
    cls.add_constructor([])
    ## wimax2-net-device.h: ns3::incoming_packet::incoming_packet(ns3::incoming_packet const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::incoming_packet const &', 'arg0')])
    ## wimax2-net-device.h: ns3::incoming_packet::collision [variable]
    cls.add_instance_attribute('collision', 'bool', is_const=False)
    ## wimax2-net-device.h: ns3::incoming_packet::data [variable]
    cls.add_instance_attribute('data', 'ns3::Ptr< ns3::Packet >', is_const=False)
    ## wimax2-net-device.h: ns3::incoming_packet::received [variable]
    cls.add_instance_attribute('received', 'bool', is_const=False)
    return

def register_Ns3Mac802_16_cdma_ie_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_cdma_ie::mac802_16_cdma_ie() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_cdma_ie::mac802_16_cdma_ie(ns3::mac802_16_cdma_ie const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_cdma_ie const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_cdma_ie::bw_req [variable]
    cls.add_instance_attribute('bw_req', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_cdma_ie::code [variable]
    cls.add_instance_attribute('code', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_cdma_ie::duration [variable]
    cls.add_instance_attribute('duration', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_cdma_ie::frame_number [variable]
    cls.add_instance_attribute('frame_number', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_cdma_ie::repetition [variable]
    cls.add_instance_attribute('repetition', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_cdma_ie::subchannel [variable]
    cls.add_instance_attribute('subchannel', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_cdma_ie::symbol [variable]
    cls.add_instance_attribute('symbol', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_cdma_ie::uiuc [variable]
    cls.add_instance_attribute('uiuc', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_compressed_ie_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_compressed_ie::mac802_16_compressed_ie() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_compressed_ie::mac802_16_compressed_ie(ns3::mac802_16_compressed_ie const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_compressed_ie const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_compressed_ie::OFDMASymbol_offset [variable]
    cls.add_instance_attribute('OFDMASymbol_offset', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_compressed_ie::boost [variable]
    cls.add_instance_attribute('boost', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_compressed_ie::cid [variable]
    cls.add_instance_attribute('cid', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_compressed_ie::diuc [variable]
    cls.add_instance_attribute('diuc', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_compressed_ie::num_OFDMASymbol [variable]
    cls.add_instance_attribute('num_OFDMASymbol', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_compressed_ie::num_subchannel [variable]
    cls.add_instance_attribute('num_subchannel', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_compressed_ie::repetition_coding [variable]
    cls.add_instance_attribute('repetition_coding', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_compressed_ie::subchannel_offset [variable]
    cls.add_instance_attribute('subchannel_offset', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_dcd_frame_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_dcd_frame::mac802_16_dcd_frame() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_dcd_frame::mac802_16_dcd_frame(ns3::mac802_16_dcd_frame const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_dcd_frame const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_dcd_frame::config_change_count [variable]
    cls.add_instance_attribute('config_change_count', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dcd_frame::dcid [variable]
    cls.add_instance_attribute('dcid', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dcd_frame::frame_duration_code [variable]
    cls.add_instance_attribute('frame_duration_code', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dcd_frame::frame_number [variable]
    cls.add_instance_attribute('frame_number', 'uint32_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dcd_frame::frequency [variable]
    cls.add_instance_attribute('frequency', 'uint32_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dcd_frame::nb_prof [variable]
    cls.add_instance_attribute('nb_prof', 'uint32_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dcd_frame::profiles [variable]
    cls.add_instance_attribute('profiles', 'ns3::mac802_16_dcd_profile [ 10 ]', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dcd_frame::rtg [variable]
    cls.add_instance_attribute('rtg', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dcd_frame::ttg [variable]
    cls.add_instance_attribute('ttg', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dcd_frame::type [variable]
    cls.add_instance_attribute('type', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_dcd_profile_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_dcd_profile::mac802_16_dcd_profile() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_dcd_profile::mac802_16_dcd_profile(ns3::mac802_16_dcd_profile const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_dcd_profile const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_dcd_profile::diuc [variable]
    cls.add_instance_attribute('diuc', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dcd_profile::fec [variable]
    cls.add_instance_attribute('fec', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dcd_profile::frequency [variable]
    cls.add_instance_attribute('frequency', 'uint32_t', is_const=False)
    return

def register_Ns3Mac802_16_dl_map_frame_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_dl_map_frame::mac802_16_dl_map_frame() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_dl_map_frame::mac802_16_dl_map_frame(ns3::mac802_16_dl_map_frame const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_dl_map_frame const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_dl_map_frame::bsid [variable]
    cls.add_instance_attribute('bsid', 'ns3::Mac48Address', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dl_map_frame::dcd_count [variable]
    cls.add_instance_attribute('dcd_count', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dl_map_frame::ies [variable]
    cls.add_instance_attribute('ies', 'ns3::DL_MAP_IE [ 2048 ]', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dl_map_frame::nb_ies [variable]
    cls.add_instance_attribute('nb_ies', 'uint32_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dl_map_frame::num_of_ofdma_symbols [variable]
    cls.add_instance_attribute('num_of_ofdma_symbols', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dl_map_frame::type [variable]
    cls.add_instance_attribute('type', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_dlmap_ie_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_dlmap_ie::mac802_16_dlmap_ie() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_dlmap_ie::mac802_16_dlmap_ie(ns3::mac802_16_dlmap_ie const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_dlmap_ie const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_dlmap_ie::boosting [variable]
    cls.add_instance_attribute('boosting', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dlmap_ie::cid [variable]
    cls.add_instance_attribute('cid', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dlmap_ie::diuc [variable]
    cls.add_instance_attribute('diuc', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dlmap_ie::n_cid [variable]
    cls.add_instance_attribute('n_cid', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dlmap_ie::num_of_subchannels [variable]
    cls.add_instance_attribute('num_of_subchannels', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dlmap_ie::num_of_symbols [variable]
    cls.add_instance_attribute('num_of_symbols', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dlmap_ie::preamble [variable]
    cls.add_instance_attribute('preamble', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dlmap_ie::repition_coding_indicator [variable]
    cls.add_instance_attribute('repition_coding_indicator', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dlmap_ie::start_time [variable]
    cls.add_instance_attribute('start_time', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dlmap_ie::subchannel_offset [variable]
    cls.add_instance_attribute('subchannel_offset', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dlmap_ie::symbol_offset [variable]
    cls.add_instance_attribute('symbol_offset', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_dsa_ack_frame_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_dsa_ack_frame::mac802_16_dsa_ack_frame() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_dsa_ack_frame::mac802_16_dsa_ack_frame(ns3::mac802_16_dsa_ack_frame const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_dsa_ack_frame const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_dsa_ack_frame::confirmation_code [variable]
    cls.add_instance_attribute('confirmation_code', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dsa_ack_frame::transaction_id [variable]
    cls.add_instance_attribute('transaction_id', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dsa_ack_frame::type [variable]
    cls.add_instance_attribute('type', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dsa_ack_frame::uplink [variable]
    cls.add_instance_attribute('uplink', 'bool', is_const=False)
    return

def register_Ns3Mac802_16_dsa_req_frame_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_dsa_req_frame::mac802_16_dsa_req_frame() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_dsa_req_frame::mac802_16_dsa_req_frame(ns3::mac802_16_dsa_req_frame const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_dsa_req_frame const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_dsa_req_frame::cid [variable]
    cls.add_instance_attribute('cid', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dsa_req_frame::staticflow [variable]
    cls.add_instance_attribute('staticflow', 'ns3::Wimax2ServiceFlow *', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dsa_req_frame::transaction_id [variable]
    cls.add_instance_attribute('transaction_id', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dsa_req_frame::type [variable]
    cls.add_instance_attribute('type', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dsa_req_frame::uplink [variable]
    cls.add_instance_attribute('uplink', 'bool', is_const=False)
    return

def register_Ns3Mac802_16_dsa_rsp_frame_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_dsa_rsp_frame::mac802_16_dsa_rsp_frame() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_dsa_rsp_frame::mac802_16_dsa_rsp_frame(ns3::mac802_16_dsa_rsp_frame const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_dsa_rsp_frame const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_dsa_rsp_frame::cid [variable]
    cls.add_instance_attribute('cid', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dsa_rsp_frame::confirmation_code [variable]
    cls.add_instance_attribute('confirmation_code', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dsa_rsp_frame::staticflow [variable]
    cls.add_instance_attribute('staticflow', 'ns3::Wimax2ServiceFlow *', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dsa_rsp_frame::transaction_id [variable]
    cls.add_instance_attribute('transaction_id', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dsa_rsp_frame::type [variable]
    cls.add_instance_attribute('type', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_dsa_rsp_frame::uplink [variable]
    cls.add_instance_attribute('uplink', 'bool', is_const=False)
    return

def register_Ns3Mac802_16_fast_ranging_ie_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_fast_ranging_ie::mac802_16_fast_ranging_ie() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_fast_ranging_ie::mac802_16_fast_ranging_ie(ns3::mac802_16_fast_ranging_ie const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_fast_ranging_ie const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_fast_ranging_ie::duration [variable]
    cls.add_instance_attribute('duration', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_fast_ranging_ie::mac_addr [variable]
    cls.add_instance_attribute('mac_addr', 'ns3::Mac48Address', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_fast_ranging_ie::uiuc [variable]
    cls.add_instance_attribute('uiuc', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_mob_bsho_req_mode_current_bs_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_req_mode_current_bs::mac802_16_mob_bsho_req_mode_current_bs() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_req_mode_current_bs::mac802_16_mob_bsho_req_mode_current_bs(ns3::mac802_16_mob_bsho_req_mode_current_bs const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_mob_bsho_req_mode_current_bs const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_req_mode_current_bs::temp_bsid [variable]
    cls.add_instance_attribute('temp_bsid', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_mob_bsho_req_mode_new_bs_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_req_mode_new_bs::mac802_16_mob_bsho_req_mode_new_bs() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_req_mode_new_bs::mac802_16_mob_bsho_req_mode_new_bs(ns3::mac802_16_mob_bsho_req_mode_new_bs const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_mob_bsho_req_mode_new_bs const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_req_mode_new_bs::neighbor_bsid [variable]
    cls.add_instance_attribute('neighbor_bsid', 'ns3::Mac48Address', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_req_mode_new_bs::temp_bsid [variable]
    cls.add_instance_attribute('temp_bsid', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_mob_bsho_req_mode_new_bs3_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_req_mode_new_bs3::mac802_16_mob_bsho_req_mode_new_bs3() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_req_mode_new_bs3::mac802_16_mob_bsho_req_mode_new_bs3(ns3::mac802_16_mob_bsho_req_mode_new_bs3 const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_mob_bsho_req_mode_new_bs3 const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_req_mode_new_bs3::cqich_id [variable]
    cls.add_instance_attribute('cqich_id', 'int', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_req_mode_new_bs3::duration [variable]
    cls.add_instance_attribute('duration', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_req_mode_new_bs3::feedback_channel_off [variable]
    cls.add_instance_attribute('feedback_channel_off', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_req_mode_new_bs3::frame_offset [variable]
    cls.add_instance_attribute('frame_offset', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_req_mode_new_bs3::mimo_permutation_feedback [variable]
    cls.add_instance_attribute('mimo_permutation_feedback', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_req_mode_new_bs3::neighbor_bsid [variable]
    cls.add_instance_attribute('neighbor_bsid', 'int', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_req_mode_new_bs3::new_cid [variable]
    cls.add_instance_attribute('new_cid', 'uint16_t [ 10 ]', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_req_mode_new_bs3::new_said [variable]
    cls.add_instance_attribute('new_said', 'uint16_t [ 10 ]', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_req_mode_new_bs3::period [variable]
    cls.add_instance_attribute('period', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_req_mode_new_bs3::temp_bsid [variable]
    cls.add_instance_attribute('temp_bsid', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_mob_bsho_rsp_frame_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_frame::mac802_16_mob_bsho_rsp_frame() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_frame::mac802_16_mob_bsho_rsp_frame(ns3::mac802_16_mob_bsho_rsp_frame const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_mob_bsho_rsp_frame const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_frame::action_time [variable]
    cls.add_instance_attribute('action_time', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_frame::ak_change_indicator [variable]
    cls.add_instance_attribute('ak_change_indicator', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_frame::cids [variable]
    cls.add_instance_attribute('cids', 'uint16_t [ 10 ]', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_frame::current_bs [variable]
    cls.add_instance_attribute('current_bs', 'ns3::mac802_16_mob_bsho_req_mode_current_bs [ 10 ]', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_frame::ho_operation_mode [variable]
    cls.add_instance_attribute('ho_operation_mode', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_frame::mode [variable]
    cls.add_instance_attribute('mode', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_frame::n_cids [variable]
    cls.add_instance_attribute('n_cids', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_frame::n_current_bs [variable]
    cls.add_instance_attribute('n_current_bs', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_frame::n_new_bs [variable]
    cls.add_instance_attribute('n_new_bs', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_frame::n_rec [variable]
    cls.add_instance_attribute('n_rec', 'ns3::mac802_16_mob_bsho_rsp_rec [ 10 ]', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_frame::n_recommended [variable]
    cls.add_instance_attribute('n_recommended', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_frame::n_saids [variable]
    cls.add_instance_attribute('n_saids', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_frame::new_bs [variable]
    cls.add_instance_attribute('new_bs', 'ns3::mac802_16_mob_bsho_req_mode_new_bs [ 10 ]', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_frame::new_bs2 [variable]
    cls.add_instance_attribute('new_bs2', 'ns3::mac802_16_mob_bsho_rsp_mode_new_bs2 [ 10 ]', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_frame::new_bs3 [variable]
    cls.add_instance_attribute('new_bs3', 'ns3::mac802_16_mob_bsho_req_mode_new_bs3 [ 10 ]', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_frame::resource_retain_flag [variable]
    cls.add_instance_attribute('resource_retain_flag', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_frame::saids [variable]
    cls.add_instance_attribute('saids', 'uint16_t [ 10 ]', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_frame::tmp_bsid [variable]
    cls.add_instance_attribute('tmp_bsid', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_frame::type [variable]
    cls.add_instance_attribute('type', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_mob_bsho_rsp_mode_new_bs2_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_mode_new_bs2::mac802_16_mob_bsho_rsp_mode_new_bs2() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_mode_new_bs2::mac802_16_mob_bsho_rsp_mode_new_bs2(ns3::mac802_16_mob_bsho_rsp_mode_new_bs2 const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_mob_bsho_rsp_mode_new_bs2 const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_mode_new_bs2::neighbor_bsid [variable]
    cls.add_instance_attribute('neighbor_bsid', 'ns3::Mac48Address', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_mode_new_bs2::new_cid [variable]
    cls.add_instance_attribute('new_cid', 'uint16_t [ 0 ]', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_mode_new_bs2::temp_bsid [variable]
    cls.add_instance_attribute('temp_bsid', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_mob_bsho_rsp_rec_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_rec::mac802_16_mob_bsho_rsp_rec() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_rec::mac802_16_mob_bsho_rsp_rec(ns3::mac802_16_mob_bsho_rsp_rec const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_mob_bsho_rsp_rec const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_rec::ho_autho_policy_indicator [variable]
    cls.add_instance_attribute('ho_autho_policy_indicator', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_rec::ho_autho_policy_support [variable]
    cls.add_instance_attribute('ho_autho_policy_support', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_rec::ho_id [variable]
    cls.add_instance_attribute('ho_id', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_rec::ho_id_included_indicator [variable]
    cls.add_instance_attribute('ho_id_included_indicator', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_rec::ho_process_optimization [variable]
    cls.add_instance_attribute('ho_process_optimization', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_rec::neighbor_bsid [variable]
    cls.add_instance_attribute('neighbor_bsid', 'ns3::Mac48Address', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_rec::net_assisted_ho_supported [variable]
    cls.add_instance_attribute('net_assisted_ho_supported', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_rec::preamble_index [variable]
    cls.add_instance_attribute('preamble_index', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_bsho_rsp_rec::service_level_prediction [variable]
    cls.add_instance_attribute('service_level_prediction', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_mob_ho_ind_bs_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_mob_ho_ind_bs::mac802_16_mob_ho_ind_bs() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_mob_ho_ind_bs::mac802_16_mob_ho_ind_bs(ns3::mac802_16_mob_ho_ind_bs const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_mob_ho_ind_bs const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_mob_ho_ind_bs::temp_bsid [variable]
    cls.add_instance_attribute('temp_bsid', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_mob_ho_ind_frame_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_mob_ho_ind_frame::mac802_16_mob_ho_ind_frame() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_mob_ho_ind_frame::mac802_16_mob_ho_ind_frame(ns3::mac802_16_mob_ho_ind_frame const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_mob_ho_ind_frame const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_mob_ho_ind_frame::action_time [variable]
    cls.add_instance_attribute('action_time', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_ho_ind_frame::anchor_bsid [variable]
    cls.add_instance_attribute('anchor_bsid', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_ho_ind_frame::bs [variable]
    cls.add_instance_attribute('bs', 'ns3::mac802_16_mob_ho_ind_bs [ 10 ]', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_ho_ind_frame::bsid [variable]
    cls.add_instance_attribute('bsid', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_ho_ind_frame::diversity_set_included [variable]
    cls.add_instance_attribute('diversity_set_included', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_ho_ind_frame::ho_ind_type [variable]
    cls.add_instance_attribute('ho_ind_type', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_ho_ind_frame::mdhofbss_ind_type [variable]
    cls.add_instance_attribute('mdhofbss_ind_type', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_ho_ind_frame::mode [variable]
    cls.add_instance_attribute('mode', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_ho_ind_frame::n_bs [variable]
    cls.add_instance_attribute('n_bs', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_ho_ind_frame::preamble_index [variable]
    cls.add_instance_attribute('preamble_index', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_ho_ind_frame::rng_param_valid_ind [variable]
    cls.add_instance_attribute('rng_param_valid_ind', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_ho_ind_frame::target_bsid [variable]
    cls.add_instance_attribute('target_bsid', 'ns3::Mac48Address', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_ho_ind_frame::type [variable]
    cls.add_instance_attribute('type', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_mob_msho_req_bs_index_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_bs_index::mac802_16_mob_msho_req_bs_index() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_bs_index::mac802_16_mob_msho_req_bs_index(ns3::mac802_16_mob_msho_req_bs_index const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_mob_msho_req_bs_index const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_bs_index::arrival_time_diff [variable]
    cls.add_instance_attribute('arrival_time_diff', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_bs_index::arrival_time_diff_ind [variable]
    cls.add_instance_attribute('arrival_time_diff_ind', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_bs_index::bs_cinr_mean [variable]
    cls.add_instance_attribute('bs_cinr_mean', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_bs_index::bs_rssi_mean [variable]
    cls.add_instance_attribute('bs_rssi_mean', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_bs_index::neighbor_bs_index [variable]
    cls.add_instance_attribute('neighbor_bs_index', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_bs_index::preamble_index [variable]
    cls.add_instance_attribute('preamble_index', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_bs_index::relative_delay [variable]
    cls.add_instance_attribute('relative_delay', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_bs_index::service_level_prediction [variable]
    cls.add_instance_attribute('service_level_prediction', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_mob_msho_req_current_bs_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_current_bs::mac802_16_mob_msho_req_current_bs() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_current_bs::mac802_16_mob_msho_req_current_bs(ns3::mac802_16_mob_msho_req_current_bs const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_mob_msho_req_current_bs const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_current_bs::bs_cinr_mean [variable]
    cls.add_instance_attribute('bs_cinr_mean', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_current_bs::bs_rssi_mean [variable]
    cls.add_instance_attribute('bs_rssi_mean', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_current_bs::bs_rtd [variable]
    cls.add_instance_attribute('bs_rtd', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_current_bs::relative_delay [variable]
    cls.add_instance_attribute('relative_delay', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_current_bs::temp_bsid [variable]
    cls.add_instance_attribute('temp_bsid', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_mob_msho_req_frame_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_frame::mac802_16_mob_msho_req_frame() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_frame::mac802_16_mob_msho_req_frame(ns3::mac802_16_mob_msho_req_frame const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_mob_msho_req_frame const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_frame::bs_current [variable]
    cls.add_instance_attribute('bs_current', 'ns3::mac802_16_mob_msho_req_current_bs [ 10 ]', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_frame::bs_full [variable]
    cls.add_instance_attribute('bs_full', 'ns3::mac802_16_mob_msho_req_bs_index [ 10 ]', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_frame::bs_index [variable]
    cls.add_instance_attribute('bs_index', 'ns3::mac802_16_mob_msho_req_bs_index [ 10 ]', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_frame::ccc_mob_nbr_adv [variable]
    cls.add_instance_attribute('ccc_mob_nbr_adv', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_frame::n_current_bs [variable]
    cls.add_instance_attribute('n_current_bs', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_frame::n_new_bs_full [variable]
    cls.add_instance_attribute('n_new_bs_full', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_frame::n_new_bs_index [variable]
    cls.add_instance_attribute('n_new_bs_index', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_frame::report_metric [variable]
    cls.add_instance_attribute('report_metric', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_msho_req_frame::type [variable]
    cls.add_instance_attribute('type', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_mob_nbr_adv_frame_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_mob_nbr_adv_frame::mac802_16_mob_nbr_adv_frame() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_mob_nbr_adv_frame::mac802_16_mob_nbr_adv_frame(ns3::mac802_16_mob_nbr_adv_frame const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_mob_nbr_adv_frame const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_mob_nbr_adv_frame::ccc [variable]
    cls.add_instance_attribute('ccc', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_nbr_adv_frame::frag_index [variable]
    cls.add_instance_attribute('frag_index', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_nbr_adv_frame::n_neighbors [variable]
    cls.add_instance_attribute('n_neighbors', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_nbr_adv_frame::nbr_info [variable]
    cls.add_instance_attribute('nbr_info', 'ns3::mac802_16_nbr_adv_info [ 10 ]', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_nbr_adv_frame::operatorID [variable]
    cls.add_instance_attribute('operatorID', 'uint32_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_nbr_adv_frame::skip_opt_field [variable]
    cls.add_instance_attribute('skip_opt_field', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_nbr_adv_frame::total_frag [variable]
    cls.add_instance_attribute('total_frag', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_nbr_adv_frame::type [variable]
    cls.add_instance_attribute('type', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_mob_scn_req_bs_full_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_mob_scn_req_bs_full::mac802_16_mob_scn_req_bs_full() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_mob_scn_req_bs_full::mac802_16_mob_scn_req_bs_full(ns3::mac802_16_mob_scn_req_bs_full const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_mob_scn_req_bs_full const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_mob_scn_req_bs_full::recommended_bs_id [variable]
    cls.add_instance_attribute('recommended_bs_id', 'ns3::Mac48Address', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_req_bs_full::scanning_type [variable]
    cls.add_instance_attribute('scanning_type', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_mob_scn_req_bs_index_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_mob_scn_req_bs_index::mac802_16_mob_scn_req_bs_index() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_mob_scn_req_bs_index::mac802_16_mob_scn_req_bs_index(ns3::mac802_16_mob_scn_req_bs_index const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_mob_scn_req_bs_index const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_mob_scn_req_bs_index::neighbor_bs_index [variable]
    cls.add_instance_attribute('neighbor_bs_index', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_req_bs_index::scanning_type [variable]
    cls.add_instance_attribute('scanning_type', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_mob_scn_rsp_bs_full_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_bs_full::mac802_16_mob_scn_rsp_bs_full() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_bs_full::mac802_16_mob_scn_rsp_bs_full(ns3::mac802_16_mob_scn_rsp_bs_full const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_mob_scn_rsp_bs_full const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_bs_full::cdma_code [variable]
    cls.add_instance_attribute('cdma_code', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_bs_full::rdv_time [variable]
    cls.add_instance_attribute('rdv_time', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_bs_full::recommended_bs_id [variable]
    cls.add_instance_attribute('recommended_bs_id', 'ns3::Mac48Address', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_bs_full::scanning_type [variable]
    cls.add_instance_attribute('scanning_type', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_bs_full::transmission_opp_offset [variable]
    cls.add_instance_attribute('transmission_opp_offset', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_mob_scn_rsp_bs_index_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_bs_index::mac802_16_mob_scn_rsp_bs_index() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_bs_index::mac802_16_mob_scn_rsp_bs_index(ns3::mac802_16_mob_scn_rsp_bs_index const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_mob_scn_rsp_bs_index const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_bs_index::cdma_code [variable]
    cls.add_instance_attribute('cdma_code', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_bs_index::neighbor_bs_index [variable]
    cls.add_instance_attribute('neighbor_bs_index', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_bs_index::rdv_time [variable]
    cls.add_instance_attribute('rdv_time', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_bs_index::scanning_type [variable]
    cls.add_instance_attribute('scanning_type', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_bs_index::transmission_opp_offset [variable]
    cls.add_instance_attribute('transmission_opp_offset', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_nbr_adv_info_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_nbr_adv_info::mac802_16_nbr_adv_info() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_nbr_adv_info::mac802_16_nbr_adv_info(ns3::mac802_16_nbr_adv_info const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_nbr_adv_info const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_nbr_adv_info::bs_eirp [variable]
    cls.add_instance_attribute('bs_eirp', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_nbr_adv_info::dcd_ccc [variable]
    cls.add_instance_attribute('dcd_ccc', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_nbr_adv_info::dcd_included [variable]
    cls.add_instance_attribute('dcd_included', 'bool', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_nbr_adv_info::dcd_settings [variable]
    cls.add_instance_attribute('dcd_settings', 'ns3::DCD_FRAME_HEADER', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_nbr_adv_info::fa_index [variable]
    cls.add_instance_attribute('fa_index', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_nbr_adv_info::ho_process_opt [variable]
    cls.add_instance_attribute('ho_process_opt', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_nbr_adv_info::length [variable]
    cls.add_instance_attribute('length', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_nbr_adv_info::nbr_bsid [variable]
    cls.add_instance_attribute('nbr_bsid', 'ns3::Mac48Address', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_nbr_adv_info::phy_included [variable]
    cls.add_instance_attribute('phy_included', 'bool', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_nbr_adv_info::phy_mode_id [variable]
    cls.add_instance_attribute('phy_mode_id', 'ns3::mac802_16_phy_mode_id', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_nbr_adv_info::phy_profile_id [variable]
    cls.add_instance_attribute('phy_profile_id', 'ns3::mac802_16_phy_profile_id', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_nbr_adv_info::preamble_index [variable]
    cls.add_instance_attribute('preamble_index', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_nbr_adv_info::sched_srv_supported [variable]
    cls.add_instance_attribute('sched_srv_supported', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_nbr_adv_info::ucd_ccc [variable]
    cls.add_instance_attribute('ucd_ccc', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_nbr_adv_info::ucd_included [variable]
    cls.add_instance_attribute('ucd_included', 'bool', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_nbr_adv_info::ucd_settings [variable]
    cls.add_instance_attribute('ucd_settings', 'ns3::UCD_FRAME_DATA', is_const=False)
    return

def register_Ns3Mac802_16_ofdma_ulmap_ie_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_ofdma_ulmap_ie::mac802_16_ofdma_ulmap_ie() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_ofdma_ulmap_ie::mac802_16_ofdma_ulmap_ie(ns3::mac802_16_ofdma_ulmap_ie const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_ofdma_ulmap_ie const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_ofdma_ulmap_ie::cdma_ie [variable]
    cls.add_instance_attribute('cdma_ie', 'ns3::CDMA_MAP_IE', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ofdma_ulmap_ie::cid [variable]
    cls.add_instance_attribute('cid', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ofdma_ulmap_ie::duration [variable]
    cls.add_instance_attribute('duration', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ofdma_ulmap_ie::repetition_coding [variable]
    cls.add_instance_attribute('repetition_coding', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ofdma_ulmap_ie::uiuc [variable]
    cls.add_instance_attribute('uiuc', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_phy_mode_id_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_phy_mode_id::mac802_16_phy_mode_id() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_phy_mode_id::mac802_16_phy_mode_id(ns3::mac802_16_phy_mode_id const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_phy_mode_id const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_phy_mode_id::bandwidth [variable]
    cls.add_instance_attribute('bandwidth', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_phy_mode_id::cp [variable]
    cls.add_instance_attribute('cp', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_phy_mode_id::duration_code [variable]
    cls.add_instance_attribute('duration_code', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_phy_mode_id::fttsize [variable]
    cls.add_instance_attribute('fttsize', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_phy_profile_id_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_phy_profile_id::mac802_16_phy_profile_id() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_phy_profile_id::mac802_16_phy_profile_id(ns3::mac802_16_phy_profile_id const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_phy_profile_id const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_phy_profile_id::FAconfig [variable]
    cls.add_instance_attribute('FAconfig', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_phy_profile_id::FAindex [variable]
    cls.add_instance_attribute('FAindex', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_phy_profile_id::bs_eirp [variable]
    cls.add_instance_attribute('bs_eirp', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_phy_profile_id::colocatedFA [variable]
    cls.add_instance_attribute('colocatedFA', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_phy_profile_id::dcducd_ref [variable]
    cls.add_instance_attribute('dcducd_ref', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_phy_profile_id::timefreq_synch [variable]
    cls.add_instance_attribute('timefreq_synch', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_phy_profile_id::trigger_ref [variable]
    cls.add_instance_attribute('trigger_ref', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_reg_req_frame_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_reg_req_frame::mac802_16_reg_req_frame() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_reg_req_frame::mac802_16_reg_req_frame(ns3::mac802_16_reg_req_frame const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_reg_req_frame const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_reg_req_frame::ip_mngmt_support [variable]
    cls.add_instance_attribute('ip_mngmt_support', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_reg_req_frame::ss_mngmt_support [variable]
    cls.add_instance_attribute('ss_mngmt_support', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_reg_req_frame::type [variable]
    cls.add_instance_attribute('type', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_reg_req_frame::uplink_cid_support [variable]
    cls.add_instance_attribute('uplink_cid_support', 'uint16_t', is_const=False)
    return

def register_Ns3Mac802_16_reg_rsp_frame_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_reg_rsp_frame::mac802_16_reg_rsp_frame() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_reg_rsp_frame::mac802_16_reg_rsp_frame(ns3::mac802_16_reg_rsp_frame const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_reg_rsp_frame const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_reg_rsp_frame::response [variable]
    cls.add_instance_attribute('response', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_reg_rsp_frame::sec_mngmt_cid [variable]
    cls.add_instance_attribute('sec_mngmt_cid', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_reg_rsp_frame::ss_mngmt_support [variable]
    cls.add_instance_attribute('ss_mngmt_support', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_reg_rsp_frame::type [variable]
    cls.add_instance_attribute('type', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_rng_req_frame_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_rng_req_frame::mac802_16_rng_req_frame() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_rng_req_frame::mac802_16_rng_req_frame(ns3::mac802_16_rng_req_frame const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_rng_req_frame const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_rng_req_frame::channel_num [variable]
    cls.add_instance_attribute('channel_num', 'uint32_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_rng_req_frame::dc_id [variable]
    cls.add_instance_attribute('dc_id', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_rng_req_frame::req_dl_burst_profile [variable]
    cls.add_instance_attribute('req_dl_burst_profile', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_rng_req_frame::ss_mac_address [variable]
    cls.add_instance_attribute('ss_mac_address', 'ns3::Mac48Address', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_rng_req_frame::type [variable]
    cls.add_instance_attribute('type', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_rng_rsp_frame_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_rng_rsp_frame::mac802_16_rng_rsp_frame() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_rng_rsp_frame::mac802_16_rng_rsp_frame(ns3::mac802_16_rng_rsp_frame const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_rng_rsp_frame const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_rng_rsp_frame::aas_bc_perm [variable]
    cls.add_instance_attribute('aas_bc_perm', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_rng_rsp_frame::basic_cid [variable]
    cls.add_instance_attribute('basic_cid', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_rng_rsp_frame::code [variable]
    cls.add_instance_attribute('code', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_rng_rsp_frame::dl_op_burst_profile [variable]
    cls.add_instance_attribute('dl_op_burst_profile', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_rng_rsp_frame::freq_adjust [variable]
    cls.add_instance_attribute('freq_adjust', 'uint32_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_rng_rsp_frame::primary_cid [variable]
    cls.add_instance_attribute('primary_cid', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_rng_rsp_frame::pw_adjust [variable]
    cls.add_instance_attribute('pw_adjust', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_rng_rsp_frame::rng_status [variable]
    cls.add_instance_attribute('rng_status', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_rng_rsp_frame::ss_mac_address [variable]
    cls.add_instance_attribute('ss_mac_address', 'ns3::Mac48Address', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_rng_rsp_frame::top [variable]
    cls.add_instance_attribute('top', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_rng_rsp_frame::type [variable]
    cls.add_instance_attribute('type', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_rng_rsp_frame::uc_id [variable]
    cls.add_instance_attribute('uc_id', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_ucd_frame_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_ucd_frame::mac802_16_ucd_frame() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_ucd_frame::mac802_16_ucd_frame(ns3::mac802_16_ucd_frame const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_ucd_frame const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_ucd_frame::bw_req_size [variable]
    cls.add_instance_attribute('bw_req_size', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ucd_frame::config_change_count [variable]
    cls.add_instance_attribute('config_change_count', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ucd_frame::nb_prof [variable]
    cls.add_instance_attribute('nb_prof', 'uint32_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ucd_frame::profiles [variable]
    cls.add_instance_attribute('profiles', 'ns3::mac802_16_ucd_profile [ 10 ]', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ucd_frame::req_backoff_end [variable]
    cls.add_instance_attribute('req_backoff_end', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ucd_frame::req_backoff_start [variable]
    cls.add_instance_attribute('req_backoff_start', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ucd_frame::rng_backoff_end [variable]
    cls.add_instance_attribute('rng_backoff_end', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ucd_frame::rng_backoff_start [variable]
    cls.add_instance_attribute('rng_backoff_start', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ucd_frame::rng_req_size [variable]
    cls.add_instance_attribute('rng_req_size', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ucd_frame::type [variable]
    cls.add_instance_attribute('type', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_ucd_profile_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_ucd_profile::mac802_16_ucd_profile() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_ucd_profile::mac802_16_ucd_profile(ns3::mac802_16_ucd_profile const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_ucd_profile const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_ucd_profile::fec [variable]
    cls.add_instance_attribute('fec', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ucd_profile::uiuc [variable]
    cls.add_instance_attribute('uiuc', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_ul_map_frame_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_ul_map_frame::mac802_16_ul_map_frame() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_ul_map_frame::mac802_16_ul_map_frame(ns3::mac802_16_ul_map_frame const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_ul_map_frame const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_ul_map_frame::allocation_start [variable]
    cls.add_instance_attribute('allocation_start', 'uint32_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ul_map_frame::ies [variable]
    cls.add_instance_attribute('ies', 'ns3::UL_MAP_IE [ 2048 ]', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ul_map_frame::nb_ies [variable]
    cls.add_instance_attribute('nb_ies', 'uint32_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ul_map_frame::num_ofdma_symbols [variable]
    cls.add_instance_attribute('num_ofdma_symbols', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ul_map_frame::type [variable]
    cls.add_instance_attribute('type', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ul_map_frame::ucd_count [variable]
    cls.add_instance_attribute('ucd_count', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ul_map_frame::ucid [variable]
    cls.add_instance_attribute('ucid', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_ulmap_ie_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_ulmap_ie::mac802_16_ulmap_ie() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::mac802_16_ulmap_ie::mac802_16_ulmap_ie(ns3::mac802_16_ulmap_ie const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_ulmap_ie const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_ulmap_ie::cdma_ie [variable]
    cls.add_instance_attribute('cdma_ie', 'ns3::CDMA_MAP_IE', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ulmap_ie::cid [variable]
    cls.add_instance_attribute('cid', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ulmap_ie::duration [variable]
    cls.add_instance_attribute('duration', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ulmap_ie::extended_uiuc [variable]
    cls.add_instance_attribute('extended_uiuc', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ulmap_ie::fast_ranging [variable]
    cls.add_instance_attribute('fast_ranging', 'ns3::Fast_Ranging_IE', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ulmap_ie::length [variable]
    cls.add_instance_attribute('length', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ulmap_ie::midamble_rep [variable]
    cls.add_instance_attribute('midamble_rep', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ulmap_ie::num_of_subchannels [variable]
    cls.add_instance_attribute('num_of_subchannels', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ulmap_ie::num_of_symbols [variable]
    cls.add_instance_attribute('num_of_symbols', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ulmap_ie::ranging_method [variable]
    cls.add_instance_attribute('ranging_method', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ulmap_ie::start_time [variable]
    cls.add_instance_attribute('start_time', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ulmap_ie::sub_channel_index [variable]
    cls.add_instance_attribute('sub_channel_index', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ulmap_ie::subchannel_offset [variable]
    cls.add_instance_attribute('subchannel_offset', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ulmap_ie::symbol_offset [variable]
    cls.add_instance_attribute('symbol_offset', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_ulmap_ie::uiuc [variable]
    cls.add_instance_attribute('uiuc', 'uint8_t', is_const=False)
    return

def register_Ns3New_client_t_methods(root_module, cls):
    ## wimax2-bs-net-device.h: ns3::new_client_t::new_client_t() [constructor]
    cls.add_constructor([])
    ## wimax2-bs-net-device.h: ns3::new_client_t::new_client_t(ns3::new_client_t const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::new_client_t const &', 'arg0')])
    ## wimax2-bs-net-device.h: ns3::new_client_t::cid [variable]
    cls.add_instance_attribute('cid', 'int', is_const=False)
    ## wimax2-bs-net-device.h: ns3::new_client_t::next [variable]
    cls.add_instance_attribute('next', 'ns3::new_client_t *', is_const=False)
    return

def register_Ns3Pack_subheader_s_methods(root_module, cls):
    ## 802_16headers.h: ns3::pack_subheader_s::pack_subheader_s() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::pack_subheader_s::pack_subheader_s(ns3::pack_subheader_s const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::pack_subheader_s const &', 'arg0')])
    ## 802_16headers.h: ns3::pack_subheader_s::fc [variable]
    cls.add_instance_attribute('fc', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::pack_subheader_s::length [variable]
    cls.add_instance_attribute('length', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::pack_subheader_s::sn [variable]
    cls.add_instance_attribute('sn', 'uint16_t', is_const=False)
    return

def register_Ns3PeerNode_list_methods(root_module, cls):
    ## peernode.h: ns3::peerNode_list::peerNode_list() [constructor]
    cls.add_constructor([])
    ## peernode.h: ns3::peerNode_list::peerNode_list(ns3::peerNode_list const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::peerNode_list const &', 'arg0')])
    ## peernode.h: ns3::peerNode_list::lh_first [variable]
    cls.add_instance_attribute('lh_first', 'ns3::PeerNode *', is_const=False)
    return

def register_Ns3Peer_node_link_methods(root_module, cls):
    ## peernode.h: ns3::peer_node_link::peer_node_link() [constructor]
    cls.add_constructor([])
    ## peernode.h: ns3::peer_node_link::peer_node_link(ns3::peer_node_link const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::peer_node_link const &', 'arg0')])
    ## peernode.h: ns3::peer_node_link::le_next [variable]
    cls.add_instance_attribute('le_next', 'ns3::PeerNode *', is_const=False)
    ## peernode.h: ns3::peer_node_link::le_prev [variable]
    cls.add_instance_attribute('le_prev', 'ns3::PeerNode * *', is_const=False)
    return

def register_Ns3Scanning_structure_methods(root_module, cls):
    ## wimax2-ss-net-device.h: ns3::scanning_structure::scanning_structure() [constructor]
    cls.add_constructor([])
    ## wimax2-ss-net-device.h: ns3::scanning_structure::scanning_structure(ns3::scanning_structure const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::scanning_structure const &', 'arg0')])
    ## wimax2-ss-net-device.h: ns3::scanning_structure::count [variable]
    cls.add_instance_attribute('count', 'int', is_const=False)
    ## wimax2-ss-net-device.h: ns3::scanning_structure::handoff_timeout [variable]
    cls.add_instance_attribute('handoff_timeout', 'int', is_const=False)
    ## wimax2-ss-net-device.h: ns3::scanning_structure::iteration [variable]
    cls.add_instance_attribute('iteration', 'int', is_const=False)
    ## wimax2-ss-net-device.h: ns3::scanning_structure::nb_rdv_timers [variable]
    cls.add_instance_attribute('nb_rdv_timers', 'int', is_const=False)
    ## wimax2-ss-net-device.h: ns3::scanning_structure::nbr [variable]
    cls.add_instance_attribute('nbr', 'ns3::WimaxNeighborEntry *', is_const=False)
    ## wimax2-ss-net-device.h: ns3::scanning_structure::normal_state [variable]
    cls.add_instance_attribute('normal_state', 'ns3::sched_state_info', is_const=False)
    ## wimax2-ss-net-device.h: ns3::scanning_structure::rdv_timers [variable]
    cls.add_instance_attribute('rdv_timers', 'ns3::WimaxRdvTimer * [ 20 ]', is_const=False)
    ## wimax2-ss-net-device.h: ns3::scanning_structure::rsp [variable]
    cls.add_instance_attribute('rsp', 'ns3::mac802_16_mob_scn_rsp_frame *', is_const=False)
    ## wimax2-ss-net-device.h: ns3::scanning_structure::scan_state [variable]
    cls.add_instance_attribute('scan_state', 'ns3::sched_state_info', is_const=False)
    ## wimax2-ss-net-device.h: ns3::scanning_structure::scn_timer_ [variable]
    cls.add_instance_attribute('scn_timer_', 'ns3::WimaxScanIntervalTimer *', is_const=False)
    ## wimax2-ss-net-device.h: ns3::scanning_structure::serving_bsid [variable]
    cls.add_instance_attribute('serving_bsid', 'ns3::Mac48Address', is_const=False)
    ## wimax2-ss-net-device.h: ns3::scanning_structure::substate [variable]
    cls.add_instance_attribute('substate', 'ns3::ss_sub_state', is_const=False)
    return

def register_Ns3Sched_state_info_methods(root_module, cls):
    ## wimaxneighborentry.h: ns3::sched_state_info::sched_state_info() [constructor]
    cls.add_constructor([])
    ## wimaxneighborentry.h: ns3::sched_state_info::sched_state_info(ns3::sched_state_info const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::sched_state_info const &', 'arg0')])
    ## wimaxneighborentry.h: ns3::sched_state_info::lostDLMAPtimer [variable]
    cls.add_instance_attribute('lostDLMAPtimer', 'ns3::WimaxLostDLMAPTimer *', is_const=False)
    ## wimaxneighborentry.h: ns3::sched_state_info::lostULMAPtimer [variable]
    cls.add_instance_attribute('lostULMAPtimer', 'ns3::WimaxLostULMAPTimer *', is_const=False)
    ## wimaxneighborentry.h: ns3::sched_state_info::map [variable]
    cls.add_instance_attribute('map', 'ns3::FrameMap *', is_const=False)
    ## wimaxneighborentry.h: ns3::sched_state_info::state_info [variable]
    cls.add_instance_attribute('state_info', 'ns3::state_info *', is_const=False)
    ## wimaxneighborentry.h: ns3::sched_state_info::t12timer [variable]
    cls.add_instance_attribute('t12timer', 'ns3::WimaxT12Timer *', is_const=False)
    ## wimaxneighborentry.h: ns3::sched_state_info::t1timer [variable]
    cls.add_instance_attribute('t1timer', 'ns3::WimaxT1Timer *', is_const=False)
    ## wimaxneighborentry.h: ns3::sched_state_info::t21timer [variable]
    cls.add_instance_attribute('t21timer', 'ns3::WimaxT21Timer *', is_const=False)
    ## wimaxneighborentry.h: ns3::sched_state_info::t2timer [variable]
    cls.add_instance_attribute('t2timer', 'ns3::WimaxT2Timer *', is_const=False)
    ## wimaxneighborentry.h: ns3::sched_state_info::t44timer [variable]
    cls.add_instance_attribute('t44timer', 'ns3::WimaxT44Timer *', is_const=False)
    ## wimaxneighborentry.h: ns3::sched_state_info::t6timer [variable]
    cls.add_instance_attribute('t6timer', 'ns3::WimaxT6Timer *', is_const=False)
    return

def register_Ns3SduClassifier_list_methods(root_module, cls):
    ## sduclassifier.h: ns3::sduClassifier_list::sduClassifier_list() [constructor]
    cls.add_constructor([])
    ## sduclassifier.h: ns3::sduClassifier_list::sduClassifier_list(ns3::sduClassifier_list const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::sduClassifier_list const &', 'arg0')])
    ## sduclassifier.h: ns3::sduClassifier_list::lh_first [variable]
    cls.add_instance_attribute('lh_first', 'ns3::SDUClassifier *', is_const=False)
    return

def register_Ns3Sdulink_methods(root_module, cls):
    ## sduclassifier.h: ns3::sdulink::sdulink() [constructor]
    cls.add_constructor([])
    ## sduclassifier.h: ns3::sdulink::sdulink(ns3::sdulink const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::sdulink const &', 'arg0')])
    ## sduclassifier.h: ns3::sdulink::le_next [variable]
    cls.add_instance_attribute('le_next', 'ns3::SDUClassifier *', is_const=False)
    ## sduclassifier.h: ns3::sdulink::le_prev [variable]
    cls.add_instance_attribute('le_prev', 'ns3::SDUClassifier * *', is_const=False)
    return

def register_Ns3Service_flow_link_methods(root_module, cls):
    ## wimax2-serviceflow.h: ns3::service_flow_link::service_flow_link() [constructor]
    cls.add_constructor([])
    ## wimax2-serviceflow.h: ns3::service_flow_link::service_flow_link(ns3::service_flow_link const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::service_flow_link const &', 'arg0')])
    ## wimax2-serviceflow.h: ns3::service_flow_link::le_next [variable]
    cls.add_instance_attribute('le_next', 'ns3::Wimax2ServiceFlow *', is_const=False)
    ## wimax2-serviceflow.h: ns3::service_flow_link::le_prev [variable]
    cls.add_instance_attribute('le_prev', 'ns3::Wimax2ServiceFlow * *', is_const=False)
    return

def register_Ns3Serviceflow_list_methods(root_module, cls):
    ## wimax2-serviceflow.h: ns3::serviceflow_list::serviceflow_list() [constructor]
    cls.add_constructor([])
    ## wimax2-serviceflow.h: ns3::serviceflow_list::serviceflow_list(ns3::serviceflow_list const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::serviceflow_list const &', 'arg0')])
    ## wimax2-serviceflow.h: ns3::serviceflow_list::lh_first [variable]
    cls.add_instance_attribute('lh_first', 'ns3::Wimax2ServiceFlow *', is_const=False)
    return

def register_Ns3State_info_methods(root_module, cls):
    ## wimax2-ss-net-device.h: ns3::state_info::state_info() [constructor]
    cls.add_constructor([])
    ## wimax2-ss-net-device.h: ns3::state_info::state_info(ns3::state_info const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::state_info const &', 'arg0')])
    ## wimax2-ss-net-device.h: ns3::state_info::bs_id [variable]
    cls.add_instance_attribute('bs_id', 'int', is_const=False)
    ## wimax2-ss-net-device.h: ns3::state_info::channel [variable]
    cls.add_instance_attribute('channel', 'int', is_const=False)
    ## wimax2-ss-net-device.h: ns3::state_info::connectionManager [variable]
    cls.add_instance_attribute('connectionManager', 'ns3::ConnectionManager *', is_const=False)
    ## wimax2-ss-net-device.h: ns3::state_info::frame_number [variable]
    cls.add_instance_attribute('frame_number', 'int', is_const=False)
    ## wimax2-ss-net-device.h: ns3::state_info::frameduration [variable]
    cls.add_instance_attribute('frameduration', 'double', is_const=False)
    ## wimax2-ss-net-device.h: ns3::state_info::nb_peer [variable]
    cls.add_instance_attribute('nb_peer', 'int', is_const=False)
    ## wimax2-ss-net-device.h: ns3::state_info::peer_list [variable]
    cls.add_instance_attribute('peer_list', 'ns3::peerNode_list *', is_const=False)
    ## wimax2-ss-net-device.h: ns3::state_info::serviceFlowHandler [variable]
    cls.add_instance_attribute('serviceFlowHandler', 'ns3::ServiceFlowHandler *', is_const=False)
    ## wimax2-ss-net-device.h: ns3::state_info::state [variable]
    cls.add_instance_attribute('state', 'ns3::Mac802_16State', is_const=False)
    return

def register_Ns3T17Element_list_methods(root_module, cls):
    ## wimax2-bs-net-device.h: ns3::t17Element_list::t17Element_list() [constructor]
    cls.add_constructor([])
    ## wimax2-bs-net-device.h: ns3::t17Element_list::t17Element_list(ns3::t17Element_list const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::t17Element_list const &', 'arg0')])
    ## wimax2-bs-net-device.h: ns3::t17Element_list::lh_first [variable]
    cls.add_instance_attribute('lh_first', 'ns3::T17Element *', is_const=False)
    return

def register_Ns3T17_list_entry_methods(root_module, cls):
    ## wimax2-bs-net-device.h: ns3::t17_list_entry::t17_list_entry() [constructor]
    cls.add_constructor([])
    ## wimax2-bs-net-device.h: ns3::t17_list_entry::t17_list_entry(ns3::t17_list_entry const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::t17_list_entry const &', 'arg0')])
    ## wimax2-bs-net-device.h: ns3::t17_list_entry::le_next [variable]
    cls.add_instance_attribute('le_next', 'ns3::T17Element *', is_const=False)
    ## wimax2-bs-net-device.h: ns3::t17_list_entry::le_prev [variable]
    cls.add_instance_attribute('le_prev', 'ns3::T17Element * *', is_const=False)
    return

def register_Ns3ARQTimer_methods(root_module, cls):
    ## wimax2-timer.h: ns3::ARQTimer::ARQTimer(ns3::ARQTimer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::ARQTimer const &', 'arg0')])
    ## wimax2-timer.h: ns3::ARQTimer::ARQTimer(ns3::Connection * connection) [constructor]
    cls.add_constructor([param('ns3::Connection *', 'connection')])
    ## wimax2-timer.h: void ns3::ARQTimer::expire() [member function]
    cls.add_method('expire', 
                   'void', 
                   [])
    ## wimax2-timer.h: ns3::Connection * ns3::ARQTimer::getConnection() [member function]
    cls.add_method('getConnection', 
                   'ns3::Connection *', 
                   [])
    ## wimax2-timer.h: void ns3::ARQTimer::sched(double s) [member function]
    cls.add_method('sched', 
                   'void', 
                   [param('double', 's')])
    ## wimax2-timer.h: void ns3::ARQTimer::setConnection(ns3::Connection * connection) [member function]
    cls.add_method('setConnection', 
                   'void', 
                   [param('ns3::Connection *', 'connection')])
    ## wimax2-timer.h: ns3::ARQTimer::connection_ [variable]
    cls.add_instance_attribute('connection_', 'ns3::Connection *', is_const=False)
    return

def register_Ns3DlTimer_methods(root_module, cls):
    ## wimax2-timer.h: ns3::DlTimer::DlTimer(ns3::DlTimer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::DlTimer const &', 'arg0')])
    ## wimax2-timer.h: ns3::DlTimer::DlTimer(ns3::Ptr<ns3::Wimax2NetDevice> m) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'm')])
    ## wimax2-timer.h: void ns3::DlTimer::expire() [member function]
    cls.add_method('expire', 
                   'void', 
                   [])
    ## wimax2-timer.h: void ns3::DlTimer::resched(double d) [member function]
    cls.add_method('resched', 
                   'void', 
                   [param('double', 'd')])
    return

def register_Ns3InitTimer_methods(root_module, cls):
    ## wimax2-timer.h: ns3::InitTimer::InitTimer(ns3::InitTimer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::InitTimer const &', 'arg0')])
    ## wimax2-timer.h: ns3::InitTimer::InitTimer(ns3::Ptr<ns3::Wimax2NetDevice> m) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'm')])
    ## wimax2-timer.h: void ns3::InitTimer::expire() [member function]
    cls.add_method('expire', 
                   'void', 
                   [])
    return

def register_Ns3MAC_TAG_methods(root_module, cls):
    ## 802_16headers.h: ns3::MAC_TAG::MAC_TAG(ns3::MAC_TAG const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::MAC_TAG const &', 'arg0')])
    ## 802_16headers.h: ns3::MAC_TAG::MAC_TAG() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::MAC_TAG::MAC_TAG(bool arg0) [constructor]
    cls.add_constructor([param('bool', 'arg0')])
    ## 802_16headers.h: void ns3::MAC_TAG::Deserialize(ns3::TagBuffer i) [member function]
    cls.add_method('Deserialize', 
                   'void', 
                   [param('ns3::TagBuffer', 'i')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::MAC_TAG::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::MAC_TAG::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::MAC_TAG::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::MAC_TAG::Serialize(ns3::TagBuffer i) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::TagBuffer', 'i')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::MAC_TAG::isMAC [variable]
    cls.add_instance_attribute('isMAC', 'bool', is_const=False)
    return

def register_Ns3MISC_OTHER_HEADER_methods(root_module, cls):
    ## 802_16headers.h: ns3::MISC_OTHER_HEADER::MISC_OTHER_HEADER(ns3::MISC_OTHER_HEADER const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::MISC_OTHER_HEADER const &', 'arg0')])
    ## 802_16headers.h: ns3::MISC_OTHER_HEADER::MISC_OTHER_HEADER() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::MISC_OTHER_HEADER::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::MISC_OTHER_HEADER::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::MISC_OTHER_HEADER::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::MISC_OTHER_HEADER::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::MISC_OTHER_HEADER::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::MISC_OTHER_HEADER::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::MISC_OTHER_HEADER::arq_ie [variable]
    cls.add_instance_attribute('arq_ie', 'ns3::arq_fb_ie [ 100 ]', is_const=False)
    ## 802_16headers.h: ns3::MISC_OTHER_HEADER::cdma [variable]
    cls.add_instance_attribute('cdma', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::MISC_OTHER_HEADER::dest [variable]
    cls.add_instance_attribute('dest', 'ns3::Mac48Address', is_const=False)
    ## 802_16headers.h: ns3::MISC_OTHER_HEADER::direction [variable]
    cls.add_instance_attribute('direction', 'ns3::dir_t', is_const=False)
    ## 802_16headers.h: ns3::MISC_OTHER_HEADER::error [variable]
    cls.add_instance_attribute('error', 'bool', is_const=False)
    ## 802_16headers.h: ns3::MISC_OTHER_HEADER::gm_sm [variable]
    cls.add_instance_attribute('gm_sm', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::MISC_OTHER_HEADER::mac_packet [variable]
    cls.add_instance_attribute('mac_packet', 'bool', is_const=False)
    ## 802_16headers.h: ns3::MISC_OTHER_HEADER::num_of_acks [variable]
    cls.add_instance_attribute('num_of_acks', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::MISC_OTHER_HEADER::timestamp [variable]
    cls.add_instance_attribute('timestamp', 'double', is_const=False)
    ## 802_16headers.h: ns3::MISC_OTHER_HEADER::txtime [variable]
    cls.add_instance_attribute('txtime', 'double', is_const=False)
    ## 802_16headers.h: ns3::MISC_OTHER_HEADER::type_arqfb [variable]
    cls.add_instance_attribute('type_arqfb', 'bool', is_const=False)
    return

def register_Ns3MOB_HO_IND_FRAME_HEADER_methods(root_module, cls):
    ## 802_16headers.h: ns3::MOB_HO_IND_FRAME_HEADER::MOB_HO_IND_FRAME_HEADER(ns3::MOB_HO_IND_FRAME_HEADER const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::MOB_HO_IND_FRAME_HEADER const &', 'arg0')])
    ## 802_16headers.h: ns3::MOB_HO_IND_FRAME_HEADER::MOB_HO_IND_FRAME_HEADER() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::MOB_HO_IND_FRAME_HEADER::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::MOB_HO_IND_FRAME_HEADER::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::MOB_HO_IND_FRAME_HEADER::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::MOB_HO_IND_FRAME_HEADER::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::MOB_HO_IND_FRAME_HEADER::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::MOB_HO_IND_FRAME_HEADER::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::MOB_HO_IND_FRAME_HEADER::data [variable]
    cls.add_instance_attribute('data', 'ns3::mac802_16_mob_ho_ind_frame', is_const=False)
    return

def register_Ns3MSHO_REQUEST_FRAME_HEADER_methods(root_module, cls):
    ## 802_16headers.h: ns3::MSHO_REQUEST_FRAME_HEADER::MSHO_REQUEST_FRAME_HEADER(ns3::MSHO_REQUEST_FRAME_HEADER const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::MSHO_REQUEST_FRAME_HEADER const &', 'arg0')])
    ## 802_16headers.h: ns3::MSHO_REQUEST_FRAME_HEADER::MSHO_REQUEST_FRAME_HEADER() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::MSHO_REQUEST_FRAME_HEADER::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::MSHO_REQUEST_FRAME_HEADER::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::MSHO_REQUEST_FRAME_HEADER::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::MSHO_REQUEST_FRAME_HEADER::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::MSHO_REQUEST_FRAME_HEADER::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::MSHO_REQUEST_FRAME_HEADER::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::MSHO_REQUEST_FRAME_HEADER::data [variable]
    cls.add_instance_attribute('data', 'ns3::mac802_16_mob_msho_req_frame', is_const=False)
    return

def register_Ns3NEIGHBOR_ADVERTISEMENT_FRAME_HEADER_methods(root_module, cls):
    ## 802_16headers.h: ns3::NEIGHBOR_ADVERTISEMENT_FRAME_HEADER::NEIGHBOR_ADVERTISEMENT_FRAME_HEADER(ns3::NEIGHBOR_ADVERTISEMENT_FRAME_HEADER const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::NEIGHBOR_ADVERTISEMENT_FRAME_HEADER const &', 'arg0')])
    ## 802_16headers.h: ns3::NEIGHBOR_ADVERTISEMENT_FRAME_HEADER::NEIGHBOR_ADVERTISEMENT_FRAME_HEADER() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::NEIGHBOR_ADVERTISEMENT_FRAME_HEADER::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::NEIGHBOR_ADVERTISEMENT_FRAME_HEADER::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::NEIGHBOR_ADVERTISEMENT_FRAME_HEADER::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::NEIGHBOR_ADVERTISEMENT_FRAME_HEADER::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::NEIGHBOR_ADVERTISEMENT_FRAME_HEADER::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::NEIGHBOR_ADVERTISEMENT_FRAME_HEADER::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::NEIGHBOR_ADVERTISEMENT_FRAME_HEADER::data [variable]
    cls.add_instance_attribute('data', 'ns3::mac802_16_mob_nbr_adv_frame', is_const=False)
    return

def register_Ns3PACKING_SUBHEADER_methods(root_module, cls):
    ## 802_16headers.h: ns3::PACKING_SUBHEADER::PACKING_SUBHEADER(ns3::PACKING_SUBHEADER const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::PACKING_SUBHEADER const &', 'arg0')])
    ## 802_16headers.h: ns3::PACKING_SUBHEADER::PACKING_SUBHEADER() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::PACKING_SUBHEADER::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::PACKING_SUBHEADER::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::PACKING_SUBHEADER::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::PACKING_SUBHEADER::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::PACKING_SUBHEADER::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::PACKING_SUBHEADER::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::PACKING_SUBHEADER::data [variable]
    cls.add_instance_attribute('data', 'ns3::pack_subheader_s', is_const=False)
    return

def register_Ns3PHY_INFO_Header_methods(root_module, cls):
    ## 802_16headers.h: ns3::PHY_INFO_Header::PHY_INFO_Header(ns3::PHY_INFO_Header const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::PHY_INFO_Header const &', 'arg0')])
    ## 802_16headers.h: ns3::PHY_INFO_Header::PHY_INFO_Header() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::PHY_INFO_Header::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::PHY_INFO_Header::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::PHY_INFO_Header::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::PHY_INFO_Header::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::PHY_INFO_Header::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::PHY_INFO_Header::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::PHY_INFO_Header::OFDMSymbol_offset [variable]
    cls.add_instance_attribute('OFDMSymbol_offset', 'uint32_t', is_const=False)
    ## 802_16headers.h: ns3::PHY_INFO_Header::channel_index [variable]
    cls.add_instance_attribute('channel_index', 'int32_t', is_const=False)
    ## 802_16headers.h: ns3::PHY_INFO_Header::direction [variable]
    cls.add_instance_attribute('direction', 'int32_t', is_const=False)
    ## 802_16headers.h: ns3::PHY_INFO_Header::freq_ [variable]
    cls.add_instance_attribute('freq_', 'double', is_const=False)
    ## 802_16headers.h: ns3::PHY_INFO_Header::g_ [variable]
    cls.add_instance_attribute('g_', 'double', is_const=False)
    ## 802_16headers.h: ns3::PHY_INFO_Header::modulation_ [variable]
    cls.add_instance_attribute('modulation_', 'ns3::Ofdm_mod_rate', is_const=False)
    ## 802_16headers.h: ns3::PHY_INFO_Header::num_OFDMSymbol [variable]
    cls.add_instance_attribute('num_OFDMSymbol', 'uint32_t', is_const=False)
    ## 802_16headers.h: ns3::PHY_INFO_Header::num_subchannels [variable]
    cls.add_instance_attribute('num_subchannels', 'uint32_t', is_const=False)
    ## 802_16headers.h: ns3::PHY_INFO_Header::subcarrier_lbound [variable]
    cls.add_instance_attribute('subcarrier_lbound', 'double', is_const=False)
    ## 802_16headers.h: ns3::PHY_INFO_Header::subcarrier_ubound [variable]
    cls.add_instance_attribute('subcarrier_ubound', 'double', is_const=False)
    ## 802_16headers.h: ns3::PHY_INFO_Header::subchannel_offset [variable]
    cls.add_instance_attribute('subchannel_offset', 'uint32_t', is_const=False)
    ## 802_16headers.h: ns3::PHY_INFO_Header::time_lbound [variable]
    cls.add_instance_attribute('time_lbound', 'double', is_const=False)
    ## 802_16headers.h: ns3::PHY_INFO_Header::time_ubound [variable]
    cls.add_instance_attribute('time_ubound', 'double', is_const=False)
    return

def register_Ns3RANGING_REQUEST_FRAME_methods(root_module, cls):
    ## 802_16headers.h: ns3::RANGING_REQUEST_FRAME::RANGING_REQUEST_FRAME(ns3::RANGING_REQUEST_FRAME const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::RANGING_REQUEST_FRAME const &', 'arg0')])
    ## 802_16headers.h: ns3::RANGING_REQUEST_FRAME::RANGING_REQUEST_FRAME() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::RANGING_REQUEST_FRAME::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::RANGING_REQUEST_FRAME::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::RANGING_REQUEST_FRAME::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::RANGING_REQUEST_FRAME::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::RANGING_REQUEST_FRAME::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::RANGING_REQUEST_FRAME::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::RANGING_REQUEST_FRAME::data [variable]
    cls.add_instance_attribute('data', 'ns3::mac802_16_rng_req_frame', is_const=False)
    return

def register_Ns3RANGING_RESPONSE_FRAME_methods(root_module, cls):
    ## 802_16headers.h: ns3::RANGING_RESPONSE_FRAME::RANGING_RESPONSE_FRAME(ns3::RANGING_RESPONSE_FRAME const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::RANGING_RESPONSE_FRAME const &', 'arg0')])
    ## 802_16headers.h: ns3::RANGING_RESPONSE_FRAME::RANGING_RESPONSE_FRAME() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::RANGING_RESPONSE_FRAME::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::RANGING_RESPONSE_FRAME::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::RANGING_RESPONSE_FRAME::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::RANGING_RESPONSE_FRAME::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::RANGING_RESPONSE_FRAME::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::RANGING_RESPONSE_FRAME::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::RANGING_RESPONSE_FRAME::data [variable]
    cls.add_instance_attribute('data', 'ns3::mac802_16_rng_rsp_frame', is_const=False)
    return

def register_Ns3REGISTRATION_REQUEST_FRAME_methods(root_module, cls):
    ## 802_16headers.h: ns3::REGISTRATION_REQUEST_FRAME::REGISTRATION_REQUEST_FRAME(ns3::REGISTRATION_REQUEST_FRAME const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::REGISTRATION_REQUEST_FRAME const &', 'arg0')])
    ## 802_16headers.h: ns3::REGISTRATION_REQUEST_FRAME::REGISTRATION_REQUEST_FRAME() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::REGISTRATION_REQUEST_FRAME::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::REGISTRATION_REQUEST_FRAME::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::REGISTRATION_REQUEST_FRAME::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::REGISTRATION_REQUEST_FRAME::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::REGISTRATION_REQUEST_FRAME::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::REGISTRATION_REQUEST_FRAME::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::REGISTRATION_REQUEST_FRAME::data [variable]
    cls.add_instance_attribute('data', 'ns3::mac802_16_reg_req_frame', is_const=False)
    return

def register_Ns3REGISTRATION_RESPONSE_FRAME_methods(root_module, cls):
    ## 802_16headers.h: ns3::REGISTRATION_RESPONSE_FRAME::REGISTRATION_RESPONSE_FRAME(ns3::REGISTRATION_RESPONSE_FRAME const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::REGISTRATION_RESPONSE_FRAME const &', 'arg0')])
    ## 802_16headers.h: ns3::REGISTRATION_RESPONSE_FRAME::REGISTRATION_RESPONSE_FRAME() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::REGISTRATION_RESPONSE_FRAME::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::REGISTRATION_RESPONSE_FRAME::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::REGISTRATION_RESPONSE_FRAME::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::REGISTRATION_RESPONSE_FRAME::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::REGISTRATION_RESPONSE_FRAME::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::REGISTRATION_RESPONSE_FRAME::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::REGISTRATION_RESPONSE_FRAME::data [variable]
    cls.add_instance_attribute('data', 'ns3::mac802_16_reg_rsp_frame', is_const=False)
    return

def register_Ns3SDUClassifier_methods(root_module, cls):
    ## sduclassifier.h: ns3::SDUClassifier::SDUClassifier(ns3::SDUClassifier const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::SDUClassifier const &', 'arg0')])
    ## sduclassifier.h: ns3::SDUClassifier::SDUClassifier() [constructor]
    cls.add_constructor([])
    ## sduclassifier.h: ns3::SDUClassifier::SDUClassifier(ns3::SDUClassifier * head) [constructor]
    cls.add_constructor([param('ns3::SDUClassifier *', 'head')])
    ## sduclassifier.h: int ns3::SDUClassifier::classify(ns3::Ptr<ns3::Packet> p, ns3::Address const & dest) [member function]
    cls.add_method('classify', 
                   'int', 
                   [param('ns3::Ptr< ns3::Packet >', 'p'), param('ns3::Address const &', 'dest')], 
                   is_pure_virtual=True, is_virtual=True)
    ## sduclassifier.h: ns3::Mac48Address ns3::SDUClassifier::declassify(int cid) [member function]
    cls.add_method('declassify', 
                   'ns3::Mac48Address', 
                   [param('int', 'cid')], 
                   is_pure_virtual=True, is_virtual=True)
    ## sduclassifier.h: int ns3::SDUClassifier::getPriority() [member function]
    cls.add_method('getPriority', 
                   'int', 
                   [])
    ## sduclassifier.h: void ns3::SDUClassifier::insert_entry(ns3::SDUClassifier * elem) [member function]
    cls.add_method('insert_entry', 
                   'void', 
                   [param('ns3::SDUClassifier *', 'elem')])
    ## sduclassifier.h: void ns3::SDUClassifier::insert_entry_head(ns3::sduClassifier_list * head) [member function]
    cls.add_method('insert_entry_head', 
                   'void', 
                   [param('ns3::sduClassifier_list *', 'head', transfer_ownership=True)])
    ## sduclassifier.h: ns3::SDUClassifier * ns3::SDUClassifier::next_entry() const [member function]
    cls.add_method('next_entry', 
                   'ns3::SDUClassifier *', 
                   [], 
                   is_const=True)
    ## sduclassifier.h: void ns3::SDUClassifier::remove_entry() [member function]
    cls.add_method('remove_entry', 
                   'void', 
                   [])
    ## sduclassifier.h: void ns3::SDUClassifier::setPriority(int pri) [member function]
    cls.add_method('setPriority', 
                   'void', 
                   [param('int', 'pri')])
    ## sduclassifier.h: ns3::SDUClassifier::link [variable]
    cls.add_instance_attribute('link', 'ns3::sdulink', is_const=False)
    ## sduclassifier.h: ns3::SDUClassifier::mac_ [variable]
    cls.add_instance_attribute('mac_', 'ns3::Ptr< ns3::Wimax2NetDevice >', is_const=False)
    ## sduclassifier.h: ns3::SDUClassifier::priority_ [variable]
    cls.add_instance_attribute('priority_', 'int', is_const=False)
    ## sduclassifier.h: void ns3::SDUClassifier::DoDispose() [member function]
    cls.add_method('DoDispose', 
                   'void', 
                   [], 
                   visibility='protected', is_virtual=True)
    ## sduclassifier.h: void ns3::SDUClassifier::setMac(ns3::Ptr<ns3::Wimax2NetDevice> mac) [member function]
    cls.add_method('setMac', 
                   'void', 
                   [param('ns3::Ptr< ns3::Wimax2NetDevice >', 'mac')], 
                   visibility='protected')
    return

def register_Ns3Signaling_MAC_Header_methods(root_module, cls):
    ## 802_16headers.h: ns3::Signaling_MAC_Header::Signaling_MAC_Header(ns3::Signaling_MAC_Header const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::Signaling_MAC_Header const &', 'arg0')])
    ## 802_16headers.h: ns3::Signaling_MAC_Header::Signaling_MAC_Header() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::Signaling_MAC_Header::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::Signaling_MAC_Header::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::Signaling_MAC_Header::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::Signaling_MAC_Header::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::Signaling_MAC_Header::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::Signaling_MAC_Header::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::Signaling_MAC_Header::setBandwidthRequested(uint32_t arg0) [member function]
    cls.add_method('setBandwidthRequested', 
                   'void', 
                   [param('uint32_t', 'arg0')])
    ## 802_16headers.h: void ns3::Signaling_MAC_Header::setCID(uint16_t arg0) [member function]
    cls.add_method('setCID', 
                   'void', 
                   [param('uint16_t', 'arg0')])
    ## 802_16headers.h: void ns3::Signaling_MAC_Header::setEncryptionControl(uint8_t arg0) [member function]
    cls.add_method('setEncryptionControl', 
                   'void', 
                   [param('uint8_t', 'arg0')])
    ## 802_16headers.h: void ns3::Signaling_MAC_Header::setHCS(uint8_t arg0) [member function]
    cls.add_method('setHCS', 
                   'void', 
                   [param('uint8_t', 'arg0')])
    ## 802_16headers.h: void ns3::Signaling_MAC_Header::setHeaderType(uint8_t arg0) [member function]
    cls.add_method('setHeaderType', 
                   'void', 
                   [param('uint8_t', 'arg0')])
    ## 802_16headers.h: void ns3::Signaling_MAC_Header::setType(uint8_t arg0) [member function]
    cls.add_method('setType', 
                   'void', 
                   [param('uint8_t', 'arg0')])
    ## 802_16headers.h: ns3::Signaling_MAC_Header::BRH [variable]
    cls.add_instance_attribute('BRH', 'ns3::bw_req_header_t', is_const=False)
    return

def register_Ns3Type_Check_methods(root_module, cls):
    ## 802_16headers.h: ns3::Type_Check::Type_Check(ns3::Type_Check const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::Type_Check const &', 'arg0')])
    ## 802_16headers.h: ns3::Type_Check::Type_Check() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::Type_Check::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::Type_Check::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::Type_Check::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::Type_Check::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::Type_Check::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::Type_Check::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::Type_Check::type [variable]
    cls.add_instance_attribute('type', 'uint8_t', is_const=False)
    return

def register_Ns3UCD_FRAME_DATA_methods(root_module, cls):
    ## 802_16headers.h: ns3::UCD_FRAME_DATA::UCD_FRAME_DATA(ns3::UCD_FRAME_DATA const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::UCD_FRAME_DATA const &', 'arg0')])
    ## 802_16headers.h: ns3::UCD_FRAME_DATA::UCD_FRAME_DATA() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::UCD_FRAME_DATA::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::UCD_FRAME_DATA::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::UCD_FRAME_DATA::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::UCD_FRAME_DATA::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::UCD_FRAME_DATA::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::UCD_FRAME_DATA::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::UCD_FRAME_DATA::ucdf [variable]
    cls.add_instance_attribute('ucdf', 'ns3::mac802_16_ucd_frame', is_const=False)
    return

def register_Ns3UL_MAP_FRAME_HEADER_methods(root_module, cls):
    ## 802_16headers.h: ns3::UL_MAP_FRAME_HEADER::UL_MAP_FRAME_HEADER(ns3::UL_MAP_FRAME_HEADER const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::UL_MAP_FRAME_HEADER const &', 'arg0')])
    ## 802_16headers.h: ns3::UL_MAP_FRAME_HEADER::UL_MAP_FRAME_HEADER() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::UL_MAP_FRAME_HEADER::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::UL_MAP_FRAME_HEADER::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::UL_MAP_FRAME_HEADER::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::UL_MAP_FRAME_HEADER::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::UL_MAP_FRAME_HEADER::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::UL_MAP_FRAME_HEADER::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::UL_MAP_FRAME_HEADER::mf [variable]
    cls.add_instance_attribute('mf', 'ns3::mac802_16_ul_map_frame', is_const=False)
    return

def register_Ns3UL_MAP_IE_methods(root_module, cls):
    ## 802_16headers.h: ns3::UL_MAP_IE::UL_MAP_IE(ns3::UL_MAP_IE const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::UL_MAP_IE const &', 'arg0')])
    ## 802_16headers.h: ns3::UL_MAP_IE::UL_MAP_IE() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::UL_MAP_IE::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::UL_MAP_IE::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::UL_MAP_IE::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::UL_MAP_IE::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::UL_MAP_IE::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::UL_MAP_IE::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::UL_MAP_IE::ie [variable]
    cls.add_instance_attribute('ie', 'ns3::mac802_16_ofdma_ulmap_ie', is_const=False)
    return

def register_Ns3UL_Protocol_Header_methods(root_module, cls):
    ## 802_16headers.h: ns3::UL_Protocol_Header::UL_Protocol_Header(ns3::UL_Protocol_Header const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::UL_Protocol_Header const &', 'arg0')])
    ## 802_16headers.h: ns3::UL_Protocol_Header::UL_Protocol_Header() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: ns3::UL_Protocol_Header::UL_Protocol_Header(uint16_t ptcl) [constructor]
    cls.add_constructor([param('uint16_t', 'ptcl')])
    ## 802_16headers.h: uint32_t ns3::UL_Protocol_Header::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::UL_Protocol_Header::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::UL_Protocol_Header::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::UL_Protocol_Header::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::UL_Protocol_Header::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::UL_Protocol_Header::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::UL_Protocol_Header::protocol [variable]
    cls.add_instance_attribute('protocol', 'uint16_t', is_const=False)
    return

def register_Ns3Wimax2Phy_methods(root_module, cls):
    ## wimax2-phy.h: ns3::Wimax2Phy::Wimax2Phy(ns3::Wimax2Phy const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::Wimax2Phy const &', 'arg0')])
    ## wimax2-phy.h: ns3::Wimax2Phy::Wimax2Phy() [constructor]
    cls.add_constructor([])
    ## wimax2-phy.h: ns3::Wimax2Phy::Wimax2Phy(ns3::Ptr<ns3::Wimax2NetDevice> mac) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'mac')])
    ## wimax2-phy.h: ns3::Wimax2Phy::Wimax2Phy(double bw, ns3::Permutation_scheme d, ns3::Permutation_scheme u) [constructor]
    cls.add_constructor([param('double', 'bw'), param('ns3::Permutation_scheme', 'd'), param('ns3::Permutation_scheme', 'u')])
    ## wimax2-phy.h: void ns3::Wimax2Phy::DoDispose() [member function]
    cls.add_method('DoDispose', 
                   'void', 
                   [], 
                   is_virtual=True)
    ## wimax2-phy.h: ns3::TypeId ns3::Wimax2Phy::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## wimax2-phy.h: ns3::Ptr<ns3::Wimax2NetDevice> ns3::Wimax2Phy::GetMac() [member function]
    cls.add_method('GetMac', 
                   'ns3::Ptr< ns3::Wimax2NetDevice >', 
                   [])
    ## wimax2-phy.h: static ns3::TypeId ns3::Wimax2Phy::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## wimax2-phy.h: void ns3::Wimax2Phy::ReceiveSlot(ns3::Ptr<ns3::Packet> p, uint8_t subchannel) [member function]
    cls.add_method('ReceiveSlot', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p'), param('uint8_t', 'subchannel')])
    ## wimax2-phy.h: void ns3::Wimax2Phy::Send(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('Send', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')])
    ## wimax2-phy.h: void ns3::Wimax2Phy::SetMac(ns3::Ptr<ns3::Wimax2NetDevice> mac) [member function]
    cls.add_method('SetMac', 
                   'void', 
                   [param('ns3::Ptr< ns3::Wimax2NetDevice >', 'mac')])
    ## wimax2-phy.h: void ns3::Wimax2Phy::SynchronizeAll() [member function]
    cls.add_method('SynchronizeAll', 
                   'void', 
                   [])
    ## wimax2-phy.h: double ns3::Wimax2Phy::getBitsPerSubchannel(ns3::Ofdm_mod_rate mod, ns3::direction dir) [member function]
    cls.add_method('getBitsPerSubchannel', 
                   'double', 
                   [param('ns3::Ofdm_mod_rate', 'mod'), param('ns3::direction', 'dir')])
    ## wimax2-phy.h: uint32_t ns3::Wimax2Phy::getBlockCapacity(ns3::Ofdm_mod_rate rate, ns3::direction dir) [member function]
    cls.add_method('getBlockCapacity', 
                   'uint32_t', 
                   [param('ns3::Ofdm_mod_rate', 'rate'), param('ns3::direction', 'dir')])
    ## wimax2-phy.h: double ns3::Wimax2Phy::getCPRatio() [member function]
    cls.add_method('getCPRatio', 
                   'double', 
                   [])
    ## wimax2-phy.h: ns3::Ptr<ns3::Wimax2Channel> ns3::Wimax2Phy::getChannel() [member function]
    cls.add_method('getChannel', 
                   'ns3::Ptr< ns3::Wimax2Channel >', 
                   [])
    ## wimax2-phy.h: int ns3::Wimax2Phy::getFFT() [member function]
    cls.add_method('getFFT', 
                   'int', 
                   [])
    ## wimax2-phy.h: double ns3::Wimax2Phy::getFreq() [member function]
    cls.add_method('getFreq', 
                   'double', 
                   [])
    ## wimax2-phy.h: int ns3::Wimax2Phy::getMCSIndex(ns3::Ofdm_mod_rate rate, int block_size) [member function]
    cls.add_method('getMCSIndex', 
                   'int', 
                   [param('ns3::Ofdm_mod_rate', 'rate'), param('int', 'block_size')])
    ## wimax2-phy.h: int ns3::Wimax2Phy::getMaxBlockSize(ns3::Ofdm_mod_rate rate) [member function]
    cls.add_method('getMaxBlockSize', 
                   'int', 
                   [param('ns3::Ofdm_mod_rate', 'rate')])
    ## wimax2-phy.h: int ns3::Wimax2Phy::getMaxPktSize(int numSubchannels, ns3::Ofdm_mod_rate mod, ns3::direction dir) [member function]
    cls.add_method('getMaxPktSize', 
                   'int', 
                   [param('int', 'numSubchannels'), param('ns3::Ofdm_mod_rate', 'mod'), param('ns3::direction', 'dir')])
    ## wimax2-phy.h: int ns3::Wimax2Phy::getMaxPktSizeForSymbol(int nbsymbols, ns3::Ofdm_mod_rate mod, ns3::direction dir) [member function]
    cls.add_method('getMaxPktSizeForSymbol', 
                   'int', 
                   [param('int', 'nbsymbols'), param('ns3::Ofdm_mod_rate', 'mod'), param('ns3::direction', 'dir')])
    ## wimax2-phy.h: ns3::Ofdm_phy_state ns3::Wimax2Phy::getMode() [member function]
    cls.add_method('getMode', 
                   'ns3::Ofdm_phy_state', 
                   [])
    ## wimax2-phy.h: ns3::Ofdm_mod_rate ns3::Wimax2Phy::getModulation() [member function]
    cls.add_method('getModulation', 
                   'ns3::Ofdm_mod_rate', 
                   [])
    ## wimax2-phy.h: double ns3::Wimax2Phy::getModulationRate(ns3::Ofdm_mod_rate mod) [member function]
    cls.add_method('getModulationRate', 
                   'double', 
                   [param('ns3::Ofdm_mod_rate', 'mod')])
    ## wimax2-phy.h: ns3::Ofdm_mod_rate ns3::Wimax2Phy::getModulationScheme(int bytes_per_subchannel_symbol, ns3::direction dir) [member function]
    cls.add_method('getModulationScheme', 
                   'ns3::Ofdm_mod_rate', 
                   [param('int', 'bytes_per_subchannel_symbol'), param('ns3::direction', 'dir')])
    ## wimax2-phy.h: int ns3::Wimax2Phy::getNUsed(ns3::direction dir) [member function]
    cls.add_method('getNUsed', 
                   'int', 
                   [param('ns3::direction', 'dir')])
    ## wimax2-phy.h: int ns3::Wimax2Phy::getNumDataSubcarrier(ns3::direction dir) [member function]
    cls.add_method('getNumDataSubcarrier', 
                   'int', 
                   [param('ns3::direction', 'dir')])
    ## wimax2-phy.h: int ns3::Wimax2Phy::getNumSubcarrier(ns3::direction dir) [member function]
    cls.add_method('getNumSubcarrier', 
                   'int', 
                   [param('ns3::direction', 'dir')])
    ## wimax2-phy.h: int ns3::Wimax2Phy::getNumSubchannels(int sdusize, ns3::Ofdm_mod_rate mod, ns3::direction dir) [member function]
    cls.add_method('getNumSubchannels', 
                   'int', 
                   [param('int', 'sdusize'), param('ns3::Ofdm_mod_rate', 'mod'), param('ns3::direction', 'dir')])
    ## wimax2-phy.h: int ns3::Wimax2Phy::getNumsubchannels(ns3::direction dir) [member function]
    cls.add_method('getNumsubchannels', 
                   'int', 
                   [param('ns3::direction', 'dir')])
    ## wimax2-phy.h: double ns3::Wimax2Phy::getPS() [member function]
    cls.add_method('getPS', 
                   'double', 
                   [])
    ## wimax2-phy.h: ns3::Permutation_scheme ns3::Wimax2Phy::getPermutationscheme(ns3::direction dir) [member function]
    cls.add_method('getPermutationscheme', 
                   'ns3::Permutation_scheme', 
                   [param('ns3::direction', 'dir')])
    ## wimax2-phy.h: double ns3::Wimax2Phy::getPt() [member function]
    cls.add_method('getPt', 
                   'double', 
                   [])
    ## wimax2-phy.h: int32_t ns3::Wimax2Phy::getSlotCapacity(ns3::Ofdm_mod_rate rate, ns3::direction dir) [member function]
    cls.add_method('getSlotCapacity', 
                   'int32_t', 
                   [param('ns3::Ofdm_mod_rate', 'rate'), param('ns3::direction', 'dir')])
    ## wimax2-phy.h: int ns3::Wimax2Phy::getSlotLength(ns3::direction dir) [member function]
    cls.add_method('getSlotLength', 
                   'int', 
                   [param('ns3::direction', 'dir')])
    ## wimax2-phy.h: int ns3::Wimax2Phy::getSymbolPS() [member function]
    cls.add_method('getSymbolPS', 
                   'int', 
                   [])
    ## wimax2-phy.h: double ns3::Wimax2Phy::getSymbolTime() [member function]
    cls.add_method('getSymbolTime', 
                   'double', 
                   [])
    ## wimax2-phy.h: double ns3::Wimax2Phy::getTrxSymbolTime(int arg0, ns3::Ofdm_mod_rate arg1, int arg2, ns3::direction arg3) [member function]
    cls.add_method('getTrxSymbolTime', 
                   'double', 
                   [param('int', 'arg0'), param('ns3::Ofdm_mod_rate', 'arg1'), param('int', 'arg2'), param('ns3::direction', 'arg3')])
    ## wimax2-phy.h: double ns3::Wimax2Phy::getTrxSymbolTime(int arg0, ns3::Ofdm_mod_rate arg1) [member function]
    cls.add_method('getTrxSymbolTime', 
                   'double', 
                   [param('int', 'arg0'), param('ns3::Ofdm_mod_rate', 'arg1')])
    ## wimax2-phy.h: double ns3::Wimax2Phy::getTrxTime(int arg0, ns3::Ofdm_mod_rate arg1, int arg2, ns3::direction arg3) [member function]
    cls.add_method('getTrxTime', 
                   'double', 
                   [param('int', 'arg0'), param('ns3::Ofdm_mod_rate', 'arg1'), param('int', 'arg2'), param('ns3::direction', 'arg3')])
    ## wimax2-phy.h: double ns3::Wimax2Phy::getTrxTime(int arg0, ns3::Ofdm_mod_rate arg1) [member function]
    cls.add_method('getTrxTime', 
                   'double', 
                   [param('int', 'arg0'), param('ns3::Ofdm_mod_rate', 'arg1')])
    ## wimax2-phy.h: double ns3::Wimax2Phy::getTxPower() [member function]
    cls.add_method('getTxPower', 
                   'double', 
                   [])
    ## wimax2-phy.h: void ns3::Wimax2Phy::node_off() [member function]
    cls.add_method('node_off', 
                   'void', 
                   [])
    ## wimax2-phy.h: void ns3::Wimax2Phy::node_on() [member function]
    cls.add_method('node_on', 
                   'void', 
                   [])
    ## wimax2-phy.h: void ns3::Wimax2Phy::setCPRatio(double g) [member function]
    cls.add_method('setCPRatio', 
                   'void', 
                   [param('double', 'g')])
    ## wimax2-phy.h: void ns3::Wimax2Phy::setChannel(ns3::Ptr<ns3::Wimax2Channel> chan) [member function]
    cls.add_method('setChannel', 
                   'void', 
                   [param('ns3::Ptr< ns3::Wimax2Channel >', 'chan')])
    ## wimax2-phy.h: void ns3::Wimax2Phy::setFrequency(double freq) [member function]
    cls.add_method('setFrequency', 
                   'void', 
                   [param('double', 'freq')])
    ## wimax2-phy.h: void ns3::Wimax2Phy::setMode(ns3::Ofdm_phy_state mode) [member function]
    cls.add_method('setMode', 
                   'void', 
                   [param('ns3::Ofdm_phy_state', 'mode')])
    ## wimax2-phy.h: void ns3::Wimax2Phy::setModulation(ns3::Ofdm_mod_rate modulation) [member function]
    cls.add_method('setModulation', 
                   'void', 
                   [param('ns3::Ofdm_mod_rate', 'modulation')])
    ## wimax2-phy.h: void ns3::Wimax2Phy::setPermutationscheme(ns3::Permutation_scheme perm, ns3::direction dir) [member function]
    cls.add_method('setPermutationscheme', 
                   'void', 
                   [param('ns3::Permutation_scheme', 'perm'), param('ns3::direction', 'dir')])
    ## wimax2-phy.h: void ns3::Wimax2Phy::setTxPower(double power) [member function]
    cls.add_method('setTxPower', 
                   'void', 
                   [param('double', 'power')])
    ## wimax2-phy.h: void ns3::Wimax2Phy::updateFs() [member function]
    cls.add_method('updateFs', 
                   'void', 
                   [], 
                   visibility='protected')
    return

def register_Ns3Mac802_16_mob_scn_req_frame_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_mob_scn_req_frame::mac802_16_mob_scn_req_frame(ns3::mac802_16_mob_scn_req_frame const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_mob_scn_req_frame const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_mob_scn_req_frame::mac802_16_mob_scn_req_frame() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::mac802_16_mob_scn_req_frame::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::mac802_16_mob_scn_req_frame::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::mac802_16_mob_scn_req_frame::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::mac802_16_mob_scn_req_frame::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::mac802_16_mob_scn_req_frame::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::mac802_16_mob_scn_req_frame::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_req_frame::ccc [variable]
    cls.add_instance_attribute('ccc', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_req_frame::interleaving_interval [variable]
    cls.add_instance_attribute('interleaving_interval', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_req_frame::n_recommended_bs_full [variable]
    cls.add_instance_attribute('n_recommended_bs_full', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_req_frame::n_recommended_bs_index [variable]
    cls.add_instance_attribute('n_recommended_bs_index', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_req_frame::rec_bs_full [variable]
    cls.add_instance_attribute('rec_bs_full', 'ns3::mac802_16_mob_scn_req_bs_full [ 10 ]', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_req_frame::rec_bs_index [variable]
    cls.add_instance_attribute('rec_bs_index', 'ns3::mac802_16_mob_scn_req_bs_index [ 10 ]', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_req_frame::scan_duration [variable]
    cls.add_instance_attribute('scan_duration', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_req_frame::scan_iteration [variable]
    cls.add_instance_attribute('scan_iteration', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_req_frame::type [variable]
    cls.add_instance_attribute('type', 'uint8_t', is_const=False)
    return

def register_Ns3Mac802_16_mob_scn_rsp_frame_methods(root_module, cls):
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_frame::mac802_16_mob_scn_rsp_frame(ns3::mac802_16_mob_scn_rsp_frame const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::mac802_16_mob_scn_rsp_frame const &', 'arg0')])
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_frame::mac802_16_mob_scn_rsp_frame() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::mac802_16_mob_scn_rsp_frame::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::mac802_16_mob_scn_rsp_frame::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::mac802_16_mob_scn_rsp_frame::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::mac802_16_mob_scn_rsp_frame::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::mac802_16_mob_scn_rsp_frame::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::mac802_16_mob_scn_rsp_frame::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_frame::ccc_mob_nbr_adv [variable]
    cls.add_instance_attribute('ccc_mob_nbr_adv', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_frame::interleaving_interval [variable]
    cls.add_instance_attribute('interleaving_interval', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_frame::n_recommended_bs_full [variable]
    cls.add_instance_attribute('n_recommended_bs_full', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_frame::n_recommended_bs_index [variable]
    cls.add_instance_attribute('n_recommended_bs_index', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_frame::rec_bs_full [variable]
    cls.add_instance_attribute('rec_bs_full', 'ns3::mac802_16_mob_scn_rsp_bs_full [ 10 ]', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_frame::rec_bs_index [variable]
    cls.add_instance_attribute('rec_bs_index', 'ns3::mac802_16_mob_scn_rsp_bs_index [ 10 ]', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_frame::report_metric [variable]
    cls.add_instance_attribute('report_metric', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_frame::report_mode [variable]
    cls.add_instance_attribute('report_mode', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_frame::report_period [variable]
    cls.add_instance_attribute('report_period', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_frame::scan_duration [variable]
    cls.add_instance_attribute('scan_duration', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_frame::scan_iteration [variable]
    cls.add_instance_attribute('scan_iteration', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_frame::start_frame [variable]
    cls.add_instance_attribute('start_frame', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::mac802_16_mob_scn_rsp_frame::type [variable]
    cls.add_instance_attribute('type', 'uint8_t', is_const=False)
    return

def register_Ns3ARQ_FB_IE_HEADER_methods(root_module, cls):
    ## 802_16headers.h: ns3::ARQ_FB_IE_HEADER::ARQ_FB_IE_HEADER(ns3::ARQ_FB_IE_HEADER const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::ARQ_FB_IE_HEADER const &', 'arg0')])
    ## 802_16headers.h: ns3::ARQ_FB_IE_HEADER::ARQ_FB_IE_HEADER() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::ARQ_FB_IE_HEADER::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::ARQ_FB_IE_HEADER::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::ARQ_FB_IE_HEADER::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::ARQ_FB_IE_HEADER::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::ARQ_FB_IE_HEADER::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::ARQ_FB_IE_HEADER::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::ARQ_FB_IE_HEADER::last(bool l) [member function]
    cls.add_method('last', 
                   'void', 
                   [param('bool', 'l')])
    ## 802_16headers.h: ns3::ARQ_FB_IE_HEADER::arqfbie [variable]
    cls.add_instance_attribute('arqfbie', 'ns3::arq_fb_ie', is_const=False)
    ## 802_16headers.h: ns3::ARQ_FB_IE_HEADER::last_ [variable]
    cls.add_instance_attribute('last_', 'bool', is_const=False)
    return

def register_Ns3All_Headers_methods(root_module, cls):
    ## 802_16headers.h: ns3::All_Headers::All_Headers(ns3::All_Headers const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::All_Headers const &', 'arg0')])
    ## 802_16headers.h: ns3::All_Headers::All_Headers() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::All_Headers::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::All_Headers::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::All_Headers::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::All_Headers::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::All_Headers::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::All_Headers::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::All_Headers::CRH [variable]
    cls.add_instance_attribute('CRH', 'ns3::CDMA_REQUEST_HEADER', is_const=False)
    ## 802_16headers.h: ns3::All_Headers::FFSH [variable]
    cls.add_instance_attribute('FFSH', 'ns3::FFB_SUBHEADER', is_const=False)
    ## 802_16headers.h: ns3::All_Headers::FSH [variable]
    cls.add_instance_attribute('FSH', 'ns3::FRAG_SUBHEADER', is_const=False)
    ## 802_16headers.h: ns3::All_Headers::GMH [variable]
    cls.add_instance_attribute('GMH', 'ns3::Generic_MAC_Header', is_const=False)
    ## 802_16headers.h: ns3::All_Headers::GMSH [variable]
    cls.add_instance_attribute('GMSH', 'ns3::GRANT_MAP_SUBHEADER', is_const=False)
    ## 802_16headers.h: ns3::All_Headers::PIH [variable]
    cls.add_instance_attribute('PIH', 'ns3::PHY_INFO_Header', is_const=False)
    ## 802_16headers.h: ns3::All_Headers::PSH [variable]
    cls.add_instance_attribute('PSH', 'ns3::PACKING_SUBHEADER', is_const=False)
    ## 802_16headers.h: ns3::All_Headers::SMH [variable]
    cls.add_instance_attribute('SMH', 'ns3::Signaling_MAC_Header', is_const=False)
    ## 802_16headers.h: ns3::All_Headers::arq_ie [variable]
    cls.add_instance_attribute('arq_ie', 'ns3::arq_fb_ie [ 100 ]', is_const=False)
    ## 802_16headers.h: ns3::All_Headers::cdma [variable]
    cls.add_instance_attribute('cdma', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::All_Headers::dest [variable]
    cls.add_instance_attribute('dest', 'ns3::Mac48Address', is_const=False)
    ## 802_16headers.h: ns3::All_Headers::direction [variable]
    cls.add_instance_attribute('direction', 'ns3::dir_t', is_const=False)
    ## 802_16headers.h: ns3::All_Headers::error [variable]
    cls.add_instance_attribute('error', 'bool', is_const=False)
    ## 802_16headers.h: ns3::All_Headers::gm_sm [variable]
    cls.add_instance_attribute('gm_sm', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::All_Headers::mac_packet [variable]
    cls.add_instance_attribute('mac_packet', 'bool', is_const=False)
    ## 802_16headers.h: ns3::All_Headers::num_of_acks [variable]
    cls.add_instance_attribute('num_of_acks', 'uint16_t', is_const=False)
    ## 802_16headers.h: ns3::All_Headers::timestamp [variable]
    cls.add_instance_attribute('timestamp', 'double', is_const=False)
    ## 802_16headers.h: ns3::All_Headers::txtime [variable]
    cls.add_instance_attribute('txtime', 'double', is_const=False)
    ## 802_16headers.h: ns3::All_Headers::type_arqfb [variable]
    cls.add_instance_attribute('type_arqfb', 'bool *', is_const=False)
    ## 802_16headers.h: ns3::All_Headers::type_ext [variable]
    cls.add_instance_attribute('type_ext', 'bool *', is_const=False)
    ## 802_16headers.h: ns3::All_Headers::type_fbgm [variable]
    cls.add_instance_attribute('type_fbgm', 'bool *', is_const=False)
    ## 802_16headers.h: ns3::All_Headers::type_frag [variable]
    cls.add_instance_attribute('type_frag', 'bool *', is_const=False)
    ## 802_16headers.h: ns3::All_Headers::type_pck [variable]
    cls.add_instance_attribute('type_pck', 'bool *', is_const=False)
    return

def register_Ns3BSHO_RESPONCE_FRAME_HEADER_methods(root_module, cls):
    ## 802_16headers.h: ns3::BSHO_RESPONCE_FRAME_HEADER::BSHO_RESPONCE_FRAME_HEADER(ns3::BSHO_RESPONCE_FRAME_HEADER const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::BSHO_RESPONCE_FRAME_HEADER const &', 'arg0')])
    ## 802_16headers.h: ns3::BSHO_RESPONCE_FRAME_HEADER::BSHO_RESPONCE_FRAME_HEADER() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::BSHO_RESPONCE_FRAME_HEADER::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::BSHO_RESPONCE_FRAME_HEADER::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::BSHO_RESPONCE_FRAME_HEADER::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::BSHO_RESPONCE_FRAME_HEADER::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::BSHO_RESPONCE_FRAME_HEADER::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::BSHO_RESPONCE_FRAME_HEADER::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::BSHO_RESPONCE_FRAME_HEADER::data [variable]
    cls.add_instance_attribute('data', 'ns3::mac802_16_mob_bsho_rsp_frame', is_const=False)
    return

def register_Ns3CDMA_MAP_IE_methods(root_module, cls):
    ## 802_16headers.h: ns3::CDMA_MAP_IE::CDMA_MAP_IE(ns3::CDMA_MAP_IE const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::CDMA_MAP_IE const &', 'arg0')])
    ## 802_16headers.h: ns3::CDMA_MAP_IE::CDMA_MAP_IE() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::CDMA_MAP_IE::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::CDMA_MAP_IE::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::CDMA_MAP_IE::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::CDMA_MAP_IE::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::CDMA_MAP_IE::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::CDMA_MAP_IE::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::CDMA_MAP_IE::ie [variable]
    cls.add_instance_attribute('ie', 'ns3::mac802_16_cdma_ie', is_const=False)
    return

def register_Ns3CDMA_REQUEST_HEADER_methods(root_module, cls):
    ## 802_16headers.h: ns3::CDMA_REQUEST_HEADER::CDMA_REQUEST_HEADER(ns3::CDMA_REQUEST_HEADER const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::CDMA_REQUEST_HEADER const &', 'arg0')])
    ## 802_16headers.h: ns3::CDMA_REQUEST_HEADER::CDMA_REQUEST_HEADER() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::CDMA_REQUEST_HEADER::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::CDMA_REQUEST_HEADER::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::CDMA_REQUEST_HEADER::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::CDMA_REQUEST_HEADER::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::CDMA_REQUEST_HEADER::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::CDMA_REQUEST_HEADER::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::CDMA_REQUEST_HEADER::data [variable]
    cls.add_instance_attribute('data', 'ns3::cdma_req_header_t', is_const=False)
    return

def register_Ns3Copy_Trailer_methods(root_module, cls):
    ## 802_16headers.h: ns3::Copy_Trailer::Copy_Trailer(ns3::Copy_Trailer const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::Copy_Trailer const &', 'arg0')])
    ## 802_16headers.h: ns3::Copy_Trailer::Copy_Trailer(uint16_t len) [constructor]
    cls.add_constructor([param('uint16_t', 'len')])
    ## 802_16headers.h: ns3::Copy_Trailer::Copy_Trailer() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::Copy_Trailer::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::Copy_Trailer::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::Copy_Trailer::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::Copy_Trailer::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::Copy_Trailer::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::Copy_Trailer::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::Copy_Trailer::d [variable]
    cls.add_instance_attribute('d', 'uint8_t *', is_const=False)
    ## 802_16headers.h: ns3::Copy_Trailer::length [variable]
    cls.add_instance_attribute('length', 'uint16_t', is_const=False)
    return

def register_Ns3DCD_FRAME_HEADER_methods(root_module, cls):
    ## 802_16headers.h: ns3::DCD_FRAME_HEADER::DCD_FRAME_HEADER(ns3::DCD_FRAME_HEADER const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::DCD_FRAME_HEADER const &', 'arg0')])
    ## 802_16headers.h: ns3::DCD_FRAME_HEADER::DCD_FRAME_HEADER() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::DCD_FRAME_HEADER::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::DCD_FRAME_HEADER::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::DCD_FRAME_HEADER::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::DCD_FRAME_HEADER::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::DCD_FRAME_HEADER::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::DCD_FRAME_HEADER::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::DCD_FRAME_HEADER::mf [variable]
    cls.add_instance_attribute('mf', 'ns3::mac802_16_dcd_frame', is_const=False)
    return

def register_Ns3DL_MAP_FRAME_HEADER_methods(root_module, cls):
    ## 802_16headers.h: ns3::DL_MAP_FRAME_HEADER::DL_MAP_FRAME_HEADER(ns3::DL_MAP_FRAME_HEADER const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::DL_MAP_FRAME_HEADER const &', 'arg0')])
    ## 802_16headers.h: ns3::DL_MAP_FRAME_HEADER::DL_MAP_FRAME_HEADER() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::DL_MAP_FRAME_HEADER::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::DL_MAP_FRAME_HEADER::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::DL_MAP_FRAME_HEADER::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::DL_MAP_FRAME_HEADER::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::DL_MAP_FRAME_HEADER::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::DL_MAP_FRAME_HEADER::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::DL_MAP_FRAME_HEADER::mf [variable]
    cls.add_instance_attribute('mf', 'ns3::mac802_16_dl_map_frame', is_const=False)
    return

def register_Ns3DL_MAP_IE_methods(root_module, cls):
    ## 802_16headers.h: ns3::DL_MAP_IE::DL_MAP_IE(ns3::DL_MAP_IE const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::DL_MAP_IE const &', 'arg0')])
    ## 802_16headers.h: ns3::DL_MAP_IE::DL_MAP_IE() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::DL_MAP_IE::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::DL_MAP_IE::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::DL_MAP_IE::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::DL_MAP_IE::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::DL_MAP_IE::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::DL_MAP_IE::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::DL_MAP_IE::ie [variable]
    cls.add_instance_attribute('ie', 'ns3::mac802_16_compressed_ie', is_const=False)
    return

def register_Ns3DSA_ACK_FRAME_HEADER_methods(root_module, cls):
    ## 802_16headers.h: ns3::DSA_ACK_FRAME_HEADER::DSA_ACK_FRAME_HEADER(ns3::DSA_ACK_FRAME_HEADER const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::DSA_ACK_FRAME_HEADER const &', 'arg0')])
    ## 802_16headers.h: ns3::DSA_ACK_FRAME_HEADER::DSA_ACK_FRAME_HEADER() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::DSA_ACK_FRAME_HEADER::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::DSA_ACK_FRAME_HEADER::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::DSA_ACK_FRAME_HEADER::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::DSA_ACK_FRAME_HEADER::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::DSA_ACK_FRAME_HEADER::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::DSA_ACK_FRAME_HEADER::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::DSA_ACK_FRAME_HEADER::data [variable]
    cls.add_instance_attribute('data', 'ns3::mac802_16_dsa_ack_frame', is_const=False)
    return

def register_Ns3DSA_REQ_FRAME_HEADER_methods(root_module, cls):
    ## 802_16headers.h: ns3::DSA_REQ_FRAME_HEADER::DSA_REQ_FRAME_HEADER(ns3::DSA_REQ_FRAME_HEADER const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::DSA_REQ_FRAME_HEADER const &', 'arg0')])
    ## 802_16headers.h: ns3::DSA_REQ_FRAME_HEADER::DSA_REQ_FRAME_HEADER() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::DSA_REQ_FRAME_HEADER::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::DSA_REQ_FRAME_HEADER::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::DSA_REQ_FRAME_HEADER::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::DSA_REQ_FRAME_HEADER::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::DSA_REQ_FRAME_HEADER::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::DSA_REQ_FRAME_HEADER::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::DSA_REQ_FRAME_HEADER::data [variable]
    cls.add_instance_attribute('data', 'ns3::mac802_16_dsa_req_frame', is_const=False)
    return

def register_Ns3DSA_RSP_FRAME_HEADER_methods(root_module, cls):
    ## 802_16headers.h: ns3::DSA_RSP_FRAME_HEADER::DSA_RSP_FRAME_HEADER(ns3::DSA_RSP_FRAME_HEADER const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::DSA_RSP_FRAME_HEADER const &', 'arg0')])
    ## 802_16headers.h: ns3::DSA_RSP_FRAME_HEADER::DSA_RSP_FRAME_HEADER() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::DSA_RSP_FRAME_HEADER::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::DSA_RSP_FRAME_HEADER::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::DSA_RSP_FRAME_HEADER::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::DSA_RSP_FRAME_HEADER::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::DSA_RSP_FRAME_HEADER::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::DSA_RSP_FRAME_HEADER::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::DSA_RSP_FRAME_HEADER::data [variable]
    cls.add_instance_attribute('data', 'ns3::mac802_16_dsa_rsp_frame', is_const=False)
    return

def register_Ns3DestClassifier_methods(root_module, cls):
    ## destclassifier.h: ns3::DestClassifier::DestClassifier(ns3::DestClassifier const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::DestClassifier const &', 'arg0')])
    ## destclassifier.h: ns3::DestClassifier::DestClassifier() [constructor]
    cls.add_constructor([])
    ## destclassifier.h: ns3::DestClassifier::DestClassifier(ns3::Ptr<ns3::Wimax2NetDevice> mac) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'mac')])
    ## destclassifier.h: ns3::DestClassifier::DestClassifier(ns3::Ptr<ns3::Wimax2NetDevice> mac, int priority) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Wimax2NetDevice >', 'mac'), param('int', 'priority')])
    ## destclassifier.h: int ns3::DestClassifier::classify(ns3::Ptr<ns3::Packet> p, ns3::Mac48Address & addr) [member function]
    cls.add_method('classify', 
                   'int', 
                   [param('ns3::Ptr< ns3::Packet >', 'p'), param('ns3::Mac48Address &', 'addr')])
    ## destclassifier.h: int ns3::DestClassifier::classify(ns3::Ptr<ns3::Packet> p, ns3::Address const & adr) [member function]
    cls.add_method('classify', 
                   'int', 
                   [param('ns3::Ptr< ns3::Packet >', 'p'), param('ns3::Address const &', 'adr')], 
                   is_virtual=True)
    ## destclassifier.h: ns3::Mac48Address ns3::DestClassifier::declassify(int cid) [member function]
    cls.add_method('declassify', 
                   'ns3::Mac48Address', 
                   [param('int', 'cid')], 
                   is_virtual=True)
    ## destclassifier.h: bool ns3::DestClassifier::isFromUpperLayer(int cid) [member function]
    cls.add_method('isFromUpperLayer', 
                   'bool', 
                   [param('int', 'cid')])
    ## destclassifier.h: void ns3::DestClassifier::DoDispose() [member function]
    cls.add_method('DoDispose', 
                   'void', 
                   [], 
                   visibility='protected', is_virtual=True)
    return

def register_Ns3FFB_SUBHEADER_methods(root_module, cls):
    ## 802_16headers.h: ns3::FFB_SUBHEADER::FFB_SUBHEADER(ns3::FFB_SUBHEADER const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::FFB_SUBHEADER const &', 'arg0')])
    ## 802_16headers.h: ns3::FFB_SUBHEADER::FFB_SUBHEADER() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::FFB_SUBHEADER::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::FFB_SUBHEADER::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::FFB_SUBHEADER::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::FFB_SUBHEADER::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::FFB_SUBHEADER::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::FFB_SUBHEADER::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::FFB_SUBHEADER::data [variable]
    cls.add_instance_attribute('data', 'ns3::ffb_subheader_s', is_const=False)
    return

def register_Ns3FRAG_SUBHEADER_methods(root_module, cls):
    ## 802_16headers.h: ns3::FRAG_SUBHEADER::FRAG_SUBHEADER(ns3::FRAG_SUBHEADER const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::FRAG_SUBHEADER const &', 'arg0')])
    ## 802_16headers.h: ns3::FRAG_SUBHEADER::FRAG_SUBHEADER() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::FRAG_SUBHEADER::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::FRAG_SUBHEADER::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::FRAG_SUBHEADER::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::FRAG_SUBHEADER::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::FRAG_SUBHEADER::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::FRAG_SUBHEADER::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::FRAG_SUBHEADER::data [variable]
    cls.add_instance_attribute('data', 'ns3::frag_subheader_s', is_const=False)
    return

def register_Ns3Fast_Ranging_IE_methods(root_module, cls):
    ## 802_16headers.h: ns3::Fast_Ranging_IE::Fast_Ranging_IE(ns3::Fast_Ranging_IE const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::Fast_Ranging_IE const &', 'arg0')])
    ## 802_16headers.h: ns3::Fast_Ranging_IE::Fast_Ranging_IE() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::Fast_Ranging_IE::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::Fast_Ranging_IE::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::Fast_Ranging_IE::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::Fast_Ranging_IE::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::Fast_Ranging_IE::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::Fast_Ranging_IE::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::Fast_Ranging_IE::ie [variable]
    cls.add_instance_attribute('ie', 'ns3::mac802_16_fast_ranging_ie', is_const=False)
    return

def register_Ns3Frame_Prefix_Header_methods(root_module, cls):
    ## 802_16headers.h: ns3::Frame_Prefix_Header::Frame_Prefix_Header(ns3::Frame_Prefix_Header const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::Frame_Prefix_Header const &', 'arg0')])
    ## 802_16headers.h: ns3::Frame_Prefix_Header::Frame_Prefix_Header() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::Frame_Prefix_Header::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::Frame_Prefix_Header::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::Frame_Prefix_Header::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::Frame_Prefix_Header::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::Frame_Prefix_Header::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::Frame_Prefix_Header::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::Frame_Prefix_Header::DL_MAP_length [variable]
    cls.add_instance_attribute('DL_MAP_length', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::Frame_Prefix_Header::coding_indication [variable]
    cls.add_instance_attribute('coding_indication', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::Frame_Prefix_Header::ranging_change [variable]
    cls.add_instance_attribute('ranging_change', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::Frame_Prefix_Header::repetition_coding [variable]
    cls.add_instance_attribute('repetition_coding', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::Frame_Prefix_Header::reserved [variable]
    cls.add_instance_attribute('reserved', 'uint8_t', is_const=False)
    ## 802_16headers.h: ns3::Frame_Prefix_Header::used_subchannel_bmp [variable]
    cls.add_instance_attribute('used_subchannel_bmp', 'uint8_t', is_const=False)
    return

def register_Ns3GRANT_MAP_SUBHEADER_methods(root_module, cls):
    ## 802_16headers.h: ns3::GRANT_MAP_SUBHEADER::GRANT_MAP_SUBHEADER(ns3::GRANT_MAP_SUBHEADER const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::GRANT_MAP_SUBHEADER const &', 'arg0')])
    ## 802_16headers.h: ns3::GRANT_MAP_SUBHEADER::GRANT_MAP_SUBHEADER() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::GRANT_MAP_SUBHEADER::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::GRANT_MAP_SUBHEADER::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::GRANT_MAP_SUBHEADER::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::GRANT_MAP_SUBHEADER::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::GRANT_MAP_SUBHEADER::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::GRANT_MAP_SUBHEADER::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: ns3::GRANT_MAP_SUBHEADER::data [variable]
    cls.add_instance_attribute('data', 'ns3::grant_subheader_s', is_const=False)
    return

def register_Ns3Generic_MAC_Header_methods(root_module, cls):
    ## 802_16headers.h: ns3::Generic_MAC_Header::Generic_MAC_Header(ns3::Generic_MAC_Header const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::Generic_MAC_Header const &', 'arg0')])
    ## 802_16headers.h: ns3::Generic_MAC_Header::Generic_MAC_Header() [constructor]
    cls.add_constructor([])
    ## 802_16headers.h: uint32_t ns3::Generic_MAC_Header::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize', 
                   'uint32_t', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_virtual=True)
    ## 802_16headers.h: ns3::TypeId ns3::Generic_MAC_Header::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: uint32_t ns3::Generic_MAC_Header::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: static ns3::TypeId ns3::Generic_MAC_Header::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## 802_16headers.h: void ns3::Generic_MAC_Header::Print(std::ostream & os) const [member function]
    cls.add_method('Print', 
                   'void', 
                   [param('std::ostream &', 'os')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::Generic_MAC_Header::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize', 
                   'void', 
                   [param('ns3::Buffer::Iterator', 'start')], 
                   is_const=True, is_virtual=True)
    ## 802_16headers.h: void ns3::Generic_MAC_Header::setARQFB(bool arg0) [member function]
    cls.add_method('setARQFB', 
                   'void', 
                   [param('bool', 'arg0')])
    ## 802_16headers.h: void ns3::Generic_MAC_Header::setCI(bool arg0) [member function]
    cls.add_method('setCI', 
                   'void', 
                   [param('bool', 'arg0')])
    ## 802_16headers.h: void ns3::Generic_MAC_Header::setCID(uint16_t arg0) [member function]
    cls.add_method('setCID', 
                   'void', 
                   [param('uint16_t', 'arg0')])
    ## 802_16headers.h: void ns3::Generic_MAC_Header::setEks(uint8_t arg0) [member function]
    cls.add_method('setEks', 
                   'void', 
                   [param('uint8_t', 'arg0')])
    ## 802_16headers.h: void ns3::Generic_MAC_Header::setEncryptionControl(bool arg0) [member function]
    cls.add_method('setEncryptionControl', 
                   'void', 
                   [param('bool', 'arg0')])
    ## 802_16headers.h: void ns3::Generic_MAC_Header::setExt(bool arg0) [member function]
    cls.add_method('setExt', 
                   'void', 
                   [param('bool', 'arg0')])
    ## 802_16headers.h: void ns3::Generic_MAC_Header::setFFBGM(bool arg0) [member function]
    cls.add_method('setFFBGM', 
                   'void', 
                   [param('bool', 'arg0')])
    ## 802_16headers.h: void ns3::Generic_MAC_Header::setFrag(bool arg0) [member function]
    cls.add_method('setFrag', 
                   'void', 
                   [param('bool', 'arg0')])
    ## 802_16headers.h: void ns3::Generic_MAC_Header::setHCS(uint8_t arg0) [member function]
    cls.add_method('setHCS', 
                   'void', 
                   [param('uint8_t', 'arg0')])
    ## 802_16headers.h: void ns3::Generic_MAC_Header::setHeaderType(bool arg0) [member function]
    cls.add_method('setHeaderType', 
                   'void', 
                   [param('bool', 'arg0')])
    ## 802_16headers.h: void ns3::Generic_MAC_Header::setPck(bool arg0) [member function]
    cls.add_method('setPck', 
                   'void', 
                   [param('bool', 'arg0')])
    ## 802_16headers.h: void ns3::Generic_MAC_Header::setPduLen(uint16_t arg0) [member function]
    cls.add_method('setPduLen', 
                   'void', 
                   [param('uint16_t', 'arg0')])
    ## 802_16headers.h: ns3::Generic_MAC_Header::GMH [variable]
    cls.add_instance_attribute('GMH', 'ns3::gen_mac_header_t', is_const=False)
    return

def register_Ns3HeadQueue_methods(root_module, cls):
    ## head_queue.h: ns3::HeadQueue::HeadQueue(ns3::HeadQueue const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::HeadQueue const &', 'arg0')])
    ## head_queue.h: ns3::HeadQueue::HeadQueue() [constructor]
    cls.add_constructor([])
    ## head_queue.h: bool ns3::HeadQueue::EnqueueHead(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('EnqueueHead', 
                   'bool', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')])
    ## head_queue.h: ns3::HeadQueue::Mode ns3::HeadQueue::GetMode() [member function]
    cls.add_method('GetMode', 
                   'ns3::HeadQueue::Mode', 
                   [])
    ## head_queue.h: uint32_t ns3::HeadQueue::GetNPackets() [member function]
    cls.add_method('GetNPackets', 
                   'uint32_t', 
                   [])
    ## head_queue.h: uint32_t ns3::HeadQueue::GetQueueLength() [member function]
    cls.add_method('GetQueueLength', 
                   'uint32_t', 
                   [])
    ## head_queue.h: static ns3::TypeId ns3::HeadQueue::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## head_queue.h: void ns3::HeadQueue::Remove(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('Remove', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')])
    ## head_queue.h: void ns3::HeadQueue::SetMode(ns3::HeadQueue::Mode mode) [member function]
    cls.add_method('SetMode', 
                   'void', 
                   [param('ns3::HeadQueue::Mode', 'mode')])
    ## head_queue.h: ns3::Ptr<ns3::Packet> ns3::HeadQueue::getNext() [member function]
    cls.add_method('getNext', 
                   'ns3::Ptr< ns3::Packet >', 
                   [])
    ## head_queue.h: ns3::Ptr<ns3::Packet> ns3::HeadQueue::head() [member function]
    cls.add_method('head', 
                   'ns3::Ptr< ns3::Packet >', 
                   [])
    ## head_queue.h: ns3::Ptr<ns3::Packet> ns3::HeadQueue::lookup(int i) [member function]
    cls.add_method('lookup', 
                   'ns3::Ptr< ns3::Packet >', 
                   [param('int', 'i')])
    ## head_queue.h: void ns3::HeadQueue::resetIterator() [member function]
    cls.add_method('resetIterator', 
                   'void', 
                   [])
    ## head_queue.h: void ns3::HeadQueue::DoDispose() [member function]
    cls.add_method('DoDispose', 
                   'void', 
                   [], 
                   visibility='protected', is_virtual=True)
    ## head_queue.h: ns3::Ptr<ns3::Packet> ns3::HeadQueue::DoDequeue() [member function]
    cls.add_method('DoDequeue', 
                   'ns3::Ptr< ns3::Packet >', 
                   [], 
                   visibility='private', is_virtual=True)
    ## head_queue.h: bool ns3::HeadQueue::DoEnqueue(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('DoEnqueue', 
                   'bool', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')], 
                   visibility='private', is_virtual=True)
    ## head_queue.h: ns3::Ptr<ns3::Packet const> ns3::HeadQueue::DoPeek() const [member function]
    cls.add_method('DoPeek', 
                   'ns3::Ptr< ns3::Packet const >', 
                   [], 
                   is_const=True, visibility='private', is_virtual=True)
    return

def register_Ns3Wimax2Channel_methods(root_module, cls):
    ## wimax2-channel.h: ns3::Wimax2Channel::Wimax2Channel(ns3::Wimax2Channel const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::Wimax2Channel const &', 'arg0')])
    ## wimax2-channel.h: ns3::Wimax2Channel::Wimax2Channel() [constructor]
    cls.add_constructor([])
    ## wimax2-channel.h: void ns3::Wimax2Channel::Add(ns3::Ptr<ns3::Wimax2Phy> device) [member function]
    cls.add_method('Add', 
                   'void', 
                   [param('ns3::Ptr< ns3::Wimax2Phy >', 'device')])
    ## wimax2-channel.h: void ns3::Wimax2Channel::Add(ns3::Ptr<ns3::Wimax2NetDevice> device) [member function]
    cls.add_method('Add', 
                   'void', 
                   [param('ns3::Ptr< ns3::Wimax2NetDevice >', 'device')])
    ## wimax2-channel.h: ns3::Ptr<ns3::NetDevice> ns3::Wimax2Channel::GetDevice(uint32_t i) const [member function]
    cls.add_method('GetDevice', 
                   'ns3::Ptr< ns3::NetDevice >', 
                   [param('uint32_t', 'i')], 
                   is_const=True, is_virtual=True)
    ## wimax2-channel.h: uint32_t ns3::Wimax2Channel::GetNDevices() const [member function]
    cls.add_method('GetNDevices', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## wimax2-channel.h: ns3::Ptr<ns3::Wimax2Phy> ns3::Wimax2Channel::GetPhy(uint32_t i) const [member function]
    cls.add_method('GetPhy', 
                   'ns3::Ptr< ns3::Wimax2Phy >', 
                   [param('uint32_t', 'i')], 
                   is_const=True, is_virtual=True)
    ## wimax2-channel.h: static ns3::TypeId ns3::Wimax2Channel::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## wimax2-channel.h: void ns3::Wimax2Channel::Send(ns3::Ptr<ns3::Packet> p, ns3::Ptr<ns3::Wimax2Phy> sender, uint8_t subchannel) [member function]
    cls.add_method('Send', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p'), param('ns3::Ptr< ns3::Wimax2Phy >', 'sender'), param('uint8_t', 'subchannel')])
    ## wimax2-channel.h: void ns3::Wimax2Channel::initializeCollisionDetection() [member function]
    cls.add_method('initializeCollisionDetection', 
                   'void', 
                   [], 
                   is_virtual=True)
    ## wimax2-channel.h: void ns3::Wimax2Channel::resetCollisionMonitor() [member function]
    cls.add_method('resetCollisionMonitor', 
                   'void', 
                   [], 
                   is_virtual=True)
    ## wimax2-channel.h: void ns3::Wimax2Channel::sync_preamble() [member function]
    cls.add_method('sync_preamble', 
                   'void', 
                   [], 
                   is_virtual=True)
    ## wimax2-channel.h: void ns3::Wimax2Channel::DoDispose() [member function]
    cls.add_method('DoDispose', 
                   'void', 
                   [], 
                   visibility='protected', is_virtual=True)
    return

def register_Ns3Wimax2NetDevice_methods(root_module, cls):
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::Wimax2NetDevice(ns3::Wimax2NetDevice const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::Wimax2NetDevice const &', 'arg0')])
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::Wimax2NetDevice(ns3::Time boot) [constructor]
    cls.add_constructor([param('ns3::Time', 'boot')])
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::Wimax2NetDevice() [constructor]
    cls.add_constructor([])
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::AddLinkChangeCallback(ns3::Callback<void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> callback) [member function]
    cls.add_method('AddLinkChangeCallback', 
                   'void', 
                   [param('ns3::Callback< void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'callback')], 
                   is_virtual=True)
    ## wimax2-net-device.h: int ns3::Wimax2NetDevice::GetActualLength(ns3::Ptr<ns3::Packet> p, bool uplink) [member function]
    cls.add_method('GetActualLength', 
                   'int', 
                   [param('ns3::Ptr< ns3::Packet >', 'p'), param('bool', 'uplink')])
    ## wimax2-net-device.h: ns3::Address ns3::Wimax2NetDevice::GetAddress() const [member function]
    cls.add_method('GetAddress', 
                   'ns3::Address', 
                   [], 
                   is_const=True, is_virtual=True)
    ## wimax2-net-device.h: ns3::Address ns3::Wimax2NetDevice::GetBroadcast() const [member function]
    cls.add_method('GetBroadcast', 
                   'ns3::Address', 
                   [], 
                   is_const=True, is_virtual=True)
    ## wimax2-net-device.h: ns3::Ptr<ns3::Channel> ns3::Wimax2NetDevice::GetChannel() const [member function]
    cls.add_method('GetChannel', 
                   'ns3::Ptr< ns3::Channel >', 
                   [], 
                   is_const=True, is_virtual=True)
    ## wimax2-net-device.h: uint32_t ns3::Wimax2NetDevice::GetIfIndex() const [member function]
    cls.add_method('GetIfIndex', 
                   'uint32_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## wimax2-net-device.h: uint16_t ns3::Wimax2NetDevice::GetMtu() const [member function]
    cls.add_method('GetMtu', 
                   'uint16_t', 
                   [], 
                   is_const=True, is_virtual=True)
    ## wimax2-net-device.h: ns3::Address ns3::Wimax2NetDevice::GetMulticast(ns3::Ipv4Address multicastGroup) const [member function]
    cls.add_method('GetMulticast', 
                   'ns3::Address', 
                   [param('ns3::Ipv4Address', 'multicastGroup')], 
                   is_const=True, is_virtual=True)
    ## wimax2-net-device.h: ns3::Address ns3::Wimax2NetDevice::GetMulticast(ns3::Ipv6Address addr) const [member function]
    cls.add_method('GetMulticast', 
                   'ns3::Address', 
                   [param('ns3::Ipv6Address', 'addr')], 
                   is_const=True, is_virtual=True)
    ## wimax2-net-device.h: ns3::Ptr<ns3::Node> ns3::Wimax2NetDevice::GetNode() const [member function]
    cls.add_method('GetNode', 
                   'ns3::Ptr< ns3::Node >', 
                   [], 
                   is_const=True, is_virtual=True)
    ## wimax2-net-device.h: static ns3::TypeId ns3::Wimax2NetDevice::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## wimax2-net-device.h: ns3::Ptr<ns3::Wimax2Channel> ns3::Wimax2NetDevice::GetWimaxChannel() const [member function]
    cls.add_method('GetWimaxChannel', 
                   'ns3::Ptr< ns3::Wimax2Channel >', 
                   [], 
                   is_const=True)
    ## wimax2-net-device.h: bool ns3::Wimax2NetDevice::IsBridge() const [member function]
    cls.add_method('IsBridge', 
                   'bool', 
                   [], 
                   is_const=True, is_virtual=True)
    ## wimax2-net-device.h: bool ns3::Wimax2NetDevice::IsBroadcast() const [member function]
    cls.add_method('IsBroadcast', 
                   'bool', 
                   [], 
                   is_const=True, is_virtual=True)
    ## wimax2-net-device.h: bool ns3::Wimax2NetDevice::IsLinkUp() const [member function]
    cls.add_method('IsLinkUp', 
                   'bool', 
                   [], 
                   is_const=True, is_virtual=True)
    ## wimax2-net-device.h: bool ns3::Wimax2NetDevice::IsMulticast() const [member function]
    cls.add_method('IsMulticast', 
                   'bool', 
                   [], 
                   is_const=True, is_virtual=True)
    ## wimax2-net-device.h: bool ns3::Wimax2NetDevice::IsPointToPoint() const [member function]
    cls.add_method('IsPointToPoint', 
                   'bool', 
                   [], 
                   is_const=True, is_virtual=True)
    ## wimax2-net-device.h: bool ns3::Wimax2NetDevice::NeedsArp() const [member function]
    cls.add_method('NeedsArp', 
                   'bool', 
                   [], 
                   is_const=True, is_virtual=True)
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::Receive(ns3::Ptr<ns3::Packet> packet, uint16_t protocol, ns3::Mac48Address to, ns3::Mac48Address from) [member function]
    cls.add_method('Receive', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'packet'), param('uint16_t', 'protocol'), param('ns3::Mac48Address', 'to'), param('ns3::Mac48Address', 'from')], 
                   is_virtual=True)
    ## wimax2-net-device.h: bool ns3::Wimax2NetDevice::Send(ns3::Ptr<ns3::Packet> packet, ns3::Address const & dest, uint16_t protocolNumber) [member function]
    cls.add_method('Send', 
                   'bool', 
                   [param('ns3::Ptr< ns3::Packet >', 'packet'), param('ns3::Address const &', 'dest'), param('uint16_t', 'protocolNumber')], 
                   is_virtual=True)
    ## wimax2-net-device.h: bool ns3::Wimax2NetDevice::SendFrom(ns3::Ptr<ns3::Packet> arg0, ns3::Address const & source, ns3::Address const & dest, uint16_t protocolNumber) [member function]
    cls.add_method('SendFrom', 
                   'bool', 
                   [param('ns3::Ptr< ns3::Packet >', 'arg0'), param('ns3::Address const &', 'source'), param('ns3::Address const &', 'dest'), param('uint16_t', 'protocolNumber')], 
                   is_virtual=True)
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::SetAddress(ns3::Address address) [member function]
    cls.add_method('SetAddress', 
                   'void', 
                   [param('ns3::Address', 'address')], 
                   is_virtual=True)
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::SetChannel(ns3::Ptr<ns3::Wimax2Channel> channel) [member function]
    cls.add_method('SetChannel', 
                   'void', 
                   [param('ns3::Ptr< ns3::Wimax2Channel >', 'channel')], 
                   is_virtual=True)
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::SetIfIndex(uint32_t const index) [member function]
    cls.add_method('SetIfIndex', 
                   'void', 
                   [param('uint32_t const', 'index')], 
                   is_virtual=True)
    ## wimax2-net-device.h: bool ns3::Wimax2NetDevice::SetMtu(uint16_t const mtu) [member function]
    cls.add_method('SetMtu', 
                   'bool', 
                   [param('uint16_t const', 'mtu')], 
                   is_virtual=True)
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::SetNode(ns3::Ptr<ns3::Node> node) [member function]
    cls.add_method('SetNode', 
                   'void', 
                   [param('ns3::Ptr< ns3::Node >', 'node')], 
                   is_virtual=True)
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::SetPhy(ns3::Ptr<ns3::Wimax2Phy> phy) [member function]
    cls.add_method('SetPhy', 
                   'void', 
                   [param('ns3::Ptr< ns3::Wimax2Phy >', 'phy')])
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::SetPromiscReceiveCallback(ns3::Callback<bool, ns3::Ptr<ns3::NetDevice>, ns3::Ptr<ns3::Packet const>, unsigned short, ns3::Address const&, ns3::Address const&, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty> cb) [member function]
    cls.add_method('SetPromiscReceiveCallback', 
                   'void', 
                   [param('ns3::Callback< bool, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::Address const &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty >', 'cb')], 
                   is_virtual=True)
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::SetReceiveCallback(ns3::Callback<bool, ns3::Ptr<ns3::NetDevice>, ns3::Ptr<ns3::Packet const>, unsigned short, ns3::Address const&, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> cb) [member function]
    cls.add_method('SetReceiveCallback', 
                   'void', 
                   [param('ns3::Callback< bool, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'cb')], 
                   is_virtual=True)
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::SetReceiveErrorModel(ns3::Ptr<ns3::ErrorModel> em) [member function]
    cls.add_method('SetReceiveErrorModel', 
                   'void', 
                   [param('ns3::Ptr< ns3::ErrorModel >', 'em')], 
                   is_virtual=True)
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::SetSchedulerDlRatio(double rat) [member function]
    cls.add_method('SetSchedulerDlRatio', 
                   'void', 
                   [param('double', 'rat')])
    ## wimax2-net-device.h: bool ns3::Wimax2NetDevice::SupportsSendFrom() const [member function]
    cls.add_method('SupportsSendFrom', 
                   'bool', 
                   [], 
                   is_const=True, is_virtual=True)
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::SynchronizeFrameStart(ns3::Time start) [member function]
    cls.add_method('SynchronizeFrameStart', 
                   'void', 
                   [param('ns3::Time', 'start')])
    ## wimax2-net-device.h: bool ns3::Wimax2NetDevice::TagIncomingMACPacket(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('TagIncomingMACPacket', 
                   'bool', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')])
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::addClassifier(ns3::SDUClassifier * arg0) [member function]
    cls.add_method('addClassifier', 
                   'void', 
                   [param('ns3::SDUClassifier *', 'arg0')], 
                   is_virtual=True)
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::addPacket(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('addPacket', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')])
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::addPeerNode(ns3::PeerNode * node) [member function]
    cls.add_method('addPeerNode', 
                   'void', 
                   [param('ns3::PeerNode *', 'node', transfer_ownership=True)], 
                   is_virtual=True)
    ## wimax2-net-device.h: ns3::Mac48Address ns3::Wimax2NetDevice::addr() [member function]
    cls.add_method('addr', 
                   'ns3::Mac48Address', 
                   [])
    ## wimax2-net-device.h: char const * ns3::Wimax2NetDevice::addr_s() [member function]
    cls.add_method('addr_s', 
                   'char const *', 
                   [])
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::assemble_incoming_packet(ns3::PHY_INFO_Header * pih) [member function]
    cls.add_method('assemble_incoming_packet', 
                   'void', 
                   [param('ns3::PHY_INFO_Header *', 'pih')], 
                   is_virtual=True)
    ## wimax2-net-device.h: int ns3::Wimax2NetDevice::classify(ns3::Ptr<ns3::Packet> p, ns3::Address const & dest) [member function]
    cls.add_method('classify', 
                   'int', 
                   [param('ns3::Ptr< ns3::Packet >', 'p'), param('ns3::Address const &', 'dest')], 
                   is_virtual=True)
    ## wimax2-net-device.h: int ns3::Wimax2NetDevice::classify(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('classify', 
                   'int', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')], 
                   is_virtual=True)
    ## wimax2-net-device.h: ns3::DestClassifier * ns3::Wimax2NetDevice::d_classifier() [member function]
    cls.add_method('d_classifier', 
                   'ns3::DestClassifier *', 
                   [])
    ## wimax2-net-device.h: ns3::Mac48Address ns3::Wimax2NetDevice::declassify(int cid) [member function]
    cls.add_method('declassify', 
                   'ns3::Mac48Address', 
                   [param('int', 'cid')], 
                   is_virtual=True)
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::drop(ns3::Ptr<ns3::Packet> p, std::string reason) [member function]
    cls.add_method('drop', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p'), param('std::string', 'reason')], 
                   is_virtual=True)
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::expire(ns3::timer_id id) [member function]
    cls.add_method('expire', 
                   'void', 
                   [param('ns3::timer_id', 'id')], 
                   is_virtual=True)
    ## wimax2-net-device.h: ns3::ConnectionManager * ns3::Wimax2NetDevice::getCManager() [member function]
    cls.add_method('getCManager', 
                   'ns3::ConnectionManager *', 
                   [])
    ## wimax2-net-device.h: int ns3::Wimax2NetDevice::getChannel() [member function]
    cls.add_method('getChannel', 
                   'int', 
                   [])
    ## wimax2-net-device.h: int ns3::Wimax2NetDevice::getChannel(double freq) [member function]
    cls.add_method('getChannel', 
                   'int', 
                   [param('double', 'freq')])
    ## wimax2-net-device.h: double ns3::Wimax2NetDevice::getFrameDuration() [member function]
    cls.add_method('getFrameDuration', 
                   'double', 
                   [])
    ## wimax2-net-device.h: int ns3::Wimax2NetDevice::getFrameNumber() [member function]
    cls.add_method('getFrameNumber', 
                   'int', 
                   [])
    ## wimax2-net-device.h: int ns3::Wimax2NetDevice::getITU_PDP() [member function]
    cls.add_method('getITU_PDP', 
                   'int', 
                   [])
    ## wimax2-net-device.h: uint32_t ns3::Wimax2NetDevice::getIdIndex() [member function]
    cls.add_method('getIdIndex', 
                   'uint32_t', 
                   [])
    ## wimax2-net-device.h: ns3::Mac802_16MIB * ns3::Wimax2NetDevice::getMacMIB() [member function]
    cls.add_method('getMacMIB', 
                   'ns3::Mac802_16MIB *', 
                   [])
    ## wimax2-net-device.h: ns3::FrameMap * ns3::Wimax2NetDevice::getMap() [member function]
    cls.add_method('getMap', 
                   'ns3::FrameMap *', 
                   [])
    ## wimax2-net-device.h: int ns3::Wimax2NetDevice::getMaxDlduration() [member function]
    cls.add_method('getMaxDlduration', 
                   'int', 
                   [])
    ## wimax2-net-device.h: int ns3::Wimax2NetDevice::getMaxUlduration() [member function]
    cls.add_method('getMaxUlduration', 
                   'int', 
                   [])
    ## wimax2-net-device.h: int ns3::Wimax2NetDevice::getNbPeerNodes() [member function]
    cls.add_method('getNbPeerNodes', 
                   'int', 
                   [], 
                   is_virtual=True)
    ## wimax2-net-device.h: ns3::station_type_t ns3::Wimax2NetDevice::getNodeType() [member function]
    cls.add_method('getNodeType', 
                   'ns3::station_type_t', 
                   [])
    ## wimax2-net-device.h: ns3::Ptr<ns3::Packet> ns3::Wimax2NetDevice::getPacket() [member function]
    cls.add_method('getPacket', 
                   'ns3::Ptr< ns3::Packet >', 
                   [])
    ## wimax2-net-device.h: ns3::PeerNode * ns3::Wimax2NetDevice::getPeerNode(ns3::Mac48Address addr) [member function]
    cls.add_method('getPeerNode', 
                   'ns3::PeerNode *', 
                   [param('ns3::Mac48Address', 'addr')], 
                   is_virtual=True)
    ## wimax2-net-device.h: ns3::PeerNode * ns3::Wimax2NetDevice::getPeerNode_head() [member function]
    cls.add_method('getPeerNode_head', 
                   'ns3::PeerNode *', 
                   [], 
                   is_virtual=True)
    ## wimax2-net-device.h: ns3::Ptr<ns3::Wimax2Phy> ns3::Wimax2NetDevice::getPhy() [member function]
    cls.add_method('getPhy', 
                   'ns3::Ptr< ns3::Wimax2Phy >', 
                   [])
    ## wimax2-net-device.h: ns3::Phy802_16MIB ns3::Wimax2NetDevice::getPhyMIB() [member function]
    cls.add_method('getPhyMIB', 
                   'ns3::Phy802_16MIB', 
                   [])
    ## wimax2-net-device.h: ns3::Wimax2Scheduler * ns3::Wimax2NetDevice::getScheduler() [member function]
    cls.add_method('getScheduler', 
                   'ns3::Wimax2Scheduler *', 
                   [])
    ## wimax2-net-device.h: ns3::ServiceFlowHandler * ns3::Wimax2NetDevice::getServiceHandler() [member function]
    cls.add_method('getServiceHandler', 
                   'ns3::ServiceFlowHandler *', 
                   [])
    ## wimax2-net-device.h: uint8_t ns3::Wimax2NetDevice::get_diuc() [member function]
    cls.add_method('get_diuc', 
                   'uint8_t', 
                   [], 
                   is_virtual=True)
    ## wimax2-net-device.h: bool ns3::Wimax2NetDevice::isLinkUp() [member function]
    cls.add_method('isLinkUp', 
                   'bool', 
                   [])
    ## wimax2-net-device.h: bool ns3::Wimax2NetDevice::isMACPacket(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('isMACPacket', 
                   'bool', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')])
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::nextChannel() [member function]
    cls.add_method('nextChannel', 
                   'void', 
                   [])
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::receive(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('receive', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')], 
                   is_virtual=True)
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::removePacket(ns3::PacketTimerRecord * arg0) [member function]
    cls.add_method('removePacket', 
                   'void', 
                   [param('ns3::PacketTimerRecord *', 'arg0')])
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::removePeerNode(ns3::PeerNode * node) [member function]
    cls.add_method('removePeerNode', 
                   'void', 
                   [param('ns3::PeerNode *', 'node', transfer_ownership=True)], 
                   is_virtual=True)
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::sendDown(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('sendDown', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')], 
                   is_virtual=True)
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::sendUp(ns3::Ptr<ns3::Packet> p, uint8_t subchannel, ns3::Time r_time) [member function]
    cls.add_method('sendUp', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p'), param('uint8_t', 'subchannel'), param('ns3::Time', 'r_time')], 
                   is_virtual=True)
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::setChannel(int channel) [member function]
    cls.add_method('setChannel', 
                   'void', 
                   [param('int', 'channel')])
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::setFrameDuration(double duration) [member function]
    cls.add_method('setFrameDuration', 
                   'void', 
                   [param('double', 'duration')])
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::setMacMIB(ns3::Mac802_16MIB * mib) [member function]
    cls.add_method('setMacMIB', 
                   'void', 
                   [param('ns3::Mac802_16MIB *', 'mib', transfer_ownership=False)])
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::setMaxDlduration(int maxdlduration) [member function]
    cls.add_method('setMaxDlduration', 
                   'void', 
                   [param('int', 'maxdlduration')])
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::setMaxUlduration(int maxulduration) [member function]
    cls.add_method('setMaxUlduration', 
                   'void', 
                   [param('int', 'maxulduration')])
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::setNotify_upper(bool notify) [member function]
    cls.add_method('setNotify_upper', 
                   'void', 
                   [param('bool', 'notify')])
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::setPhyMIB(ns3::Phy802_16MIB * mib) [member function]
    cls.add_method('setPhyMIB', 
                   'void', 
                   [param('ns3::Phy802_16MIB *', 'mib', transfer_ownership=False)])
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::start_dlsubframe() [member function]
    cls.add_method('start_dlsubframe', 
                   'void', 
                   [], 
                   is_virtual=True)
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::start_ulsubframe() [member function]
    cls.add_method('start_ulsubframe', 
                   'void', 
                   [], 
                   is_virtual=True)
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::transmit(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('transmit', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')], 
                   is_virtual=True)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::Dlduration_ [variable]
    cls.add_instance_attribute('Dlduration_', 'int', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::MaxDlduration_ [variable]
    cls.add_instance_attribute('MaxDlduration_', 'int', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::MaxUlduration_ [variable]
    cls.add_instance_attribute('MaxUlduration_', 'int', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::accepting_ [variable]
    cls.add_instance_attribute('accepting_', 'bool', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::arq_block_size_ [variable]
    cls.add_instance_attribute('arq_block_size_', 'int', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::arqfb_in_dl_data_ [variable]
    cls.add_instance_attribute('arqfb_in_dl_data_', 'int', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::arqfb_in_ul_data_ [variable]
    cls.add_instance_attribute('arqfb_in_ul_data_', 'int', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::basepower_ [variable]
    cls.add_instance_attribute('basepower_', 'double * *', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::classifier_list_ [variable]
    cls.add_instance_attribute('classifier_list_', 'ns3::sduClassifier_list', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::collision_ [variable]
    cls.add_instance_attribute('collision_', 'bool', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::connectionManager_ [variable]
    cls.add_instance_attribute('connectionManager_', 'ns3::ConnectionManager *', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::contPktRxing_ [variable]
    cls.add_instance_attribute('contPktRxing_', 'bool', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::data_loss_ [variable]
    cls.add_instance_attribute('data_loss_', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::dl_timer_ [variable]
    cls.add_instance_attribute('dl_timer_', 'ns3::DlTimer *', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::frame_number_ [variable]
    cls.add_instance_attribute('frame_number_', 'int', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::head_pkt_ [variable]
    cls.add_instance_attribute('head_pkt_', 'ns3::PacketTimerRecord *', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::id_index [variable]
    cls.add_instance_attribute('id_index', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::initTimer_ [variable]
    cls.add_instance_attribute('initTimer_', 'ns3::InitTimer *', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::intpower_ [variable]
    cls.add_instance_attribute('intpower_', 'double * *', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::last_tx_delay_ [variable]
    cls.add_instance_attribute('last_tx_delay_', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::last_tx_duration_ [variable]
    cls.add_instance_attribute('last_tx_duration_', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::last_tx_time_ [variable]
    cls.add_instance_attribute('last_tx_time_', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::m_address [variable]
    cls.add_instance_attribute('m_address', 'ns3::Mac48Address', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::m_channel [variable]
    cls.add_instance_attribute('m_channel', 'ns3::Ptr< ns3::Wimax2Channel >', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::m_ifIndex [variable]
    cls.add_instance_attribute('m_ifIndex', 'uint32_t', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::m_macPromixcRxTrace [variable]
    cls.add_instance_attribute('m_macPromixcRxTrace', 'ns3::TracedCallback< ns3::Ptr< ns3::Packet const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::m_macRxDropTrace [variable]
    cls.add_instance_attribute('m_macRxDropTrace', 'ns3::TracedCallback< ns3::Ptr< ns3::Packet const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::m_macRxTrace [variable]
    cls.add_instance_attribute('m_macRxTrace', 'ns3::TracedCallback< ns3::Ptr< ns3::Packet const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::m_macTxDropTrace [variable]
    cls.add_instance_attribute('m_macTxDropTrace', 'ns3::TracedCallback< ns3::Ptr< ns3::Packet const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::m_macTxTrace [variable]
    cls.add_instance_attribute('m_macTxTrace', 'ns3::TracedCallback< ns3::Ptr< ns3::Packet const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::m_mtu [variable]
    cls.add_instance_attribute('m_mtu', 'uint16_t', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::m_node [variable]
    cls.add_instance_attribute('m_node', 'ns3::Ptr< ns3::Node >', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::m_phyRxBeginTrace [variable]
    cls.add_instance_attribute('m_phyRxBeginTrace', 'ns3::TracedCallback< ns3::Ptr< ns3::Packet const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::m_phyRxDropTrace [variable]
    cls.add_instance_attribute('m_phyRxDropTrace', 'ns3::TracedCallback< ns3::Ptr< ns3::Packet const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::m_phyRxEndTrace [variable]
    cls.add_instance_attribute('m_phyRxEndTrace', 'ns3::TracedCallback< ns3::Ptr< ns3::Packet const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::m_phyTxBeginTrace [variable]
    cls.add_instance_attribute('m_phyTxBeginTrace', 'ns3::TracedCallback< ns3::Ptr< ns3::Packet const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::m_phyTxDropTrace [variable]
    cls.add_instance_attribute('m_phyTxDropTrace', 'ns3::TracedCallback< ns3::Ptr< ns3::Packet const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::m_phyTxEndTrace [variable]
    cls.add_instance_attribute('m_phyTxEndTrace', 'ns3::TracedCallback< ns3::Ptr< ns3::Packet const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::m_promiscCallback [variable]
    cls.add_instance_attribute('m_promiscCallback', 'ns3::Callback< bool, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::Address const &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty >', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::m_promixcSnifferTrace [variable]
    cls.add_instance_attribute('m_promixcSnifferTrace', 'ns3::TracedCallback< ns3::Ptr< ns3::Packet const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::m_receiveErrorModel [variable]
    cls.add_instance_attribute('m_receiveErrorModel', 'ns3::Ptr< ns3::ErrorModel >', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::m_rxCallback [variable]
    cls.add_instance_attribute('m_rxCallback', 'ns3::Callback< bool, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::m_snifferTrace [variable]
    cls.add_instance_attribute('m_snifferTrace', 'ns3::TracedCallback< ns3::Ptr< ns3::Packet const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::macmib_ [variable]
    cls.add_instance_attribute('macmib_', 'ns3::Mac802_16MIB *', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::map_ [variable]
    cls.add_instance_attribute('map_', 'ns3::FrameMap *', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::nb_peer_ [variable]
    cls.add_instance_attribute('nb_peer_', 'int', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::nbr_db_ [variable]
    cls.add_instance_attribute('nbr_db_', 'ns3::NeighborDB *', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::nohead_ [variable]
    cls.add_instance_attribute('nohead_', 'uint8_t', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::notify_upper_ [variable]
    cls.add_instance_attribute('notify_upper_', 'bool', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::peer_list_ [variable]
    cls.add_instance_attribute('peer_list_', 'ns3::peerNode_list *', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::phy_ [variable]
    cls.add_instance_attribute('phy_', 'ns3::Ptr< ns3::Wimax2Phy >', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::phymib_ [variable]
    cls.add_instance_attribute('phymib_', 'ns3::Phy802_16MIB', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::pktBuf_ [variable]
    cls.add_instance_attribute('pktBuf_', 'ns3::Ptr< ns3::Packet >', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::r_delta_bs [variable]
    cls.add_instance_attribute('r_delta_bs', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::r_delta_ss [variable]
    cls.add_instance_attribute('r_delta_ss', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::recv_delta [variable]
    cls.add_instance_attribute('recv_delta', 'double', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::reg_SS_number [variable]
    cls.add_instance_attribute('reg_SS_number', 'int', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::scheduler_ [variable]
    cls.add_instance_attribute('scheduler_', 'ns3::Wimax2Scheduler *', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::serviceFlowHandler_ [variable]
    cls.add_instance_attribute('serviceFlowHandler_', 'ns3::ServiceFlowHandler *', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::start_of_frame [variable]
    cls.add_instance_attribute('start_of_frame', 'ns3::Time', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::tail_pkt_ [variable]
    cls.add_instance_attribute('tail_pkt_', 'ns3::PacketTimerRecord *', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::trash_pkt_ [variable]
    cls.add_instance_attribute('trash_pkt_', 'ns3::PacketTimerRecord *', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::type_ [variable]
    cls.add_instance_attribute('type_', 'ns3::station_type_t', is_const=False)
    ## wimax2-net-device.h: ns3::Wimax2NetDevice::ul_timer_ [variable]
    cls.add_instance_attribute('ul_timer_', 'ns3::UlTimer *', is_const=False)
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::DoDispose() [member function]
    cls.add_method('DoDispose', 
                   'void', 
                   [], 
                   visibility='protected', is_virtual=True)
    ## wimax2-net-device.h: int ns3::Wimax2NetDevice::getFrameDurationCode() [member function]
    cls.add_method('getFrameDurationCode', 
                   'int', 
                   [], 
                   visibility='protected')
    ## wimax2-net-device.h: ns3::incoming_packet ns3::Wimax2NetDevice::get_grid_element(uint8_t x, uint8_t y) [member function]
    cls.add_method('get_grid_element', 
                   'ns3::incoming_packet', 
                   [param('uint8_t', 'x'), param('uint8_t', 'y')], 
                   visibility='protected')
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::init() [member function]
    cls.add_method('init', 
                   'void', 
                   [], 
                   visibility='protected', is_virtual=True)
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::initialize_grid() [member function]
    cls.add_method('initialize_grid', 
                   'void', 
                   [], 
                   visibility='protected')
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::process_new_packet(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('process_new_packet', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')], 
                   visibility='protected', is_virtual=True)
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::reset_grid() [member function]
    cls.add_method('reset_grid', 
                   'void', 
                   [], 
                   visibility='protected')
    ## wimax2-net-device.h: void ns3::Wimax2NetDevice::setFrameDurationCode(int code) [member function]
    cls.add_method('setFrameDurationCode', 
                   'void', 
                   [param('int', 'code')], 
                   visibility='protected')
    ## wimax2-net-device.h: bool ns3::Wimax2NetDevice::set_grid_element(uint8_t x, uint8_t y, ns3::incoming_packet inc_p) [member function]
    cls.add_method('set_grid_element', 
                   'bool', 
                   [param('uint8_t', 'x'), param('uint8_t', 'y'), param('ns3::incoming_packet', 'inc_p')], 
                   visibility='protected')
    return

def register_Ns3Wimax2SSNetDevice_methods(root_module, cls):
    ## wimax2-ss-net-device.h: ns3::Wimax2SSNetDevice::Wimax2SSNetDevice(ns3::Wimax2SSNetDevice const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::Wimax2SSNetDevice const &', 'arg0')])
    ## wimax2-ss-net-device.h: ns3::Wimax2SSNetDevice::Wimax2SSNetDevice(ns3::Time boot) [constructor]
    cls.add_constructor([param('ns3::Time', 'boot')])
    ## wimax2-ss-net-device.h: ns3::Wimax2SSNetDevice::Wimax2SSNetDevice() [constructor]
    cls.add_constructor([])
    ## wimax2-ss-net-device.h: int ns3::Wimax2SSNetDevice::GetInitialChannel() [member function]
    cls.add_method('GetInitialChannel', 
                   'int', 
                   [])
    ## wimax2-ss-net-device.h: static ns3::TypeId ns3::Wimax2SSNetDevice::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## wimax2-ss-net-device.h: bool ns3::Wimax2SSNetDevice::IsCollision(ns3::All_Headers const * wimaxHdr, double power_subchannel) [member function]
    cls.add_method('IsCollision', 
                   'bool', 
                   [param('ns3::All_Headers const *', 'wimaxHdr'), param('double', 'power_subchannel')])
    ## wimax2-ss-net-device.h: bool ns3::Wimax2SSNetDevice::IsLinkUp() [member function]
    cls.add_method('IsLinkUp', 
                   'bool', 
                   [])
    ## wimax2-ss-net-device.h: void ns3::Wimax2SSNetDevice::StartSubframe(bool new_subframe_is_dl) [member function]
    cls.add_method('StartSubframe', 
                   'void', 
                   [param('bool', 'new_subframe_is_dl')])
    ## wimax2-ss-net-device.h: void ns3::Wimax2SSNetDevice::addPowerinfo(ns3::All_Headers * wimaxHdr, double power, bool collision) [member function]
    cls.add_method('addPowerinfo', 
                   'void', 
                   [param('ns3::All_Headers *', 'wimaxHdr'), param('double', 'power'), param('bool', 'collision')])
    ## wimax2-ss-net-device.h: ns3::state_info * ns3::Wimax2SSNetDevice::backup_state() [member function]
    cls.add_method('backup_state', 
                   'ns3::state_info *', 
                   [])
    ## wimax2-ss-net-device.h: ns3::Mac48Address ns3::Wimax2SSNetDevice::getBSAddr() [member function]
    cls.add_method('getBSAddr', 
                   'ns3::Mac48Address', 
                   [])
    ## wimax2-ss-net-device.h: ns3::Mac802_16State ns3::Wimax2SSNetDevice::getMacState() [member function]
    cls.add_method('getMacState', 
                   'ns3::Mac802_16State', 
                   [])
    ## wimax2-ss-net-device.h: uint8_t ns3::Wimax2SSNetDevice::get_diuc() [member function]
    cls.add_method('get_diuc', 
                   'uint8_t', 
                   [], 
                   is_virtual=True)
    ## wimax2-ss-net-device.h: void ns3::Wimax2SSNetDevice::link_scan(void * req) [member function]
    cls.add_method('link_scan', 
                   'void', 
                   [param('void *', 'req')])
    ## wimax2-ss-net-device.h: void ns3::Wimax2SSNetDevice::process_FCH() [member function]
    cls.add_method('process_FCH', 
                   'void', 
                   [])
    ## wimax2-ss-net-device.h: void ns3::Wimax2SSNetDevice::receive(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('receive', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')], 
                   is_virtual=True)
    ## wimax2-ss-net-device.h: void ns3::Wimax2SSNetDevice::restore_state(ns3::state_info * state) [member function]
    cls.add_method('restore_state', 
                   'void', 
                   [param('ns3::state_info *', 'state')])
    ## wimax2-ss-net-device.h: void ns3::Wimax2SSNetDevice::sendDown(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('sendDown', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')], 
                   is_virtual=True)
    ## wimax2-ss-net-device.h: void ns3::Wimax2SSNetDevice::setBSAddr(ns3::Mac48Address adr) [member function]
    cls.add_method('setBSAddr', 
                   'void', 
                   [param('ns3::Mac48Address', 'adr')])
    ## wimax2-ss-net-device.h: void ns3::Wimax2SSNetDevice::setMacState(ns3::Mac802_16State state) [member function]
    cls.add_method('setMacState', 
                   'void', 
                   [param('ns3::Mac802_16State', 'state')])
    ## wimax2-ss-net-device.h: void ns3::Wimax2SSNetDevice::transmit(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('transmit', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')], 
                   is_virtual=True)
    ## wimax2-ss-net-device.h: void ns3::Wimax2SSNetDevice::DoDispose() [member function]
    cls.add_method('DoDispose', 
                   'void', 
                   [], 
                   visibility='protected', is_virtual=True)
    ## wimax2-ss-net-device.h: void ns3::Wimax2SSNetDevice::expire(ns3::timer_id id) [member function]
    cls.add_method('expire', 
                   'void', 
                   [param('ns3::timer_id', 'id')], 
                   visibility='protected', is_virtual=True)
    ## wimax2-ss-net-device.h: void ns3::Wimax2SSNetDevice::init() [member function]
    cls.add_method('init', 
                   'void', 
                   [], 
                   visibility='protected', is_virtual=True)
    ## wimax2-ss-net-device.h: void ns3::Wimax2SSNetDevice::init_default_connections() [member function]
    cls.add_method('init_default_connections', 
                   'void', 
                   [], 
                   visibility='protected')
    ## wimax2-ss-net-device.h: void ns3::Wimax2SSNetDevice::lost_synch() [member function]
    cls.add_method('lost_synch', 
                   'void', 
                   [], 
                   visibility='protected')
    ## wimax2-ss-net-device.h: void ns3::Wimax2SSNetDevice::pause_scanning() [member function]
    cls.add_method('pause_scanning', 
                   'void', 
                   [], 
                   visibility='protected')
    ## wimax2-ss-net-device.h: void ns3::Wimax2SSNetDevice::resume_scanning() [member function]
    cls.add_method('resume_scanning', 
                   'void', 
                   [], 
                   visibility='protected')
    ## wimax2-ss-net-device.h: void ns3::Wimax2SSNetDevice::start_dlsubframe() [member function]
    cls.add_method('start_dlsubframe', 
                   'void', 
                   [], 
                   visibility='protected', is_virtual=True)
    ## wimax2-ss-net-device.h: void ns3::Wimax2SSNetDevice::start_ulsubframe() [member function]
    cls.add_method('start_ulsubframe', 
                   'void', 
                   [], 
                   visibility='protected', is_virtual=True)
    return

def register_Ns3Wimax2BSNetDevice_methods(root_module, cls):
    ## wimax2-bs-net-device.h: ns3::Wimax2BSNetDevice::Wimax2BSNetDevice(ns3::Wimax2BSNetDevice const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::Wimax2BSNetDevice const &', 'arg0')])
    ## wimax2-bs-net-device.h: ns3::Wimax2BSNetDevice::Wimax2BSNetDevice() [constructor]
    cls.add_constructor([])
    ## wimax2-bs-net-device.h: static ns3::TypeId ns3::Wimax2BSNetDevice::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## wimax2-bs-net-device.h: bool ns3::Wimax2BSNetDevice::IsCollision(ns3::All_Headers const * wimaxHdr, double power_subchannel) [member function]
    cls.add_method('IsCollision', 
                   'bool', 
                   [param('ns3::All_Headers const *', 'wimaxHdr'), param('double', 'power_subchannel')])
    ## wimax2-bs-net-device.h: void ns3::Wimax2BSNetDevice::addPowerinfo(ns3::All_Headers * wimaxHdr, double power, bool collision) [member function]
    cls.add_method('addPowerinfo', 
                   'void', 
                   [param('ns3::All_Headers *', 'wimaxHdr'), param('double', 'power'), param('bool', 'collision')])
    ## wimax2-bs-net-device.h: void ns3::Wimax2BSNetDevice::receive(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('receive', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')], 
                   is_virtual=True)
    ## wimax2-bs-net-device.h: void ns3::Wimax2BSNetDevice::sendDown(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('sendDown', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')], 
                   is_virtual=True)
    ## wimax2-bs-net-device.h: void ns3::Wimax2BSNetDevice::transmit(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('transmit', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')], 
                   is_virtual=True)
    ## wimax2-bs-net-device.h: ns3::Wimax2BSNetDevice::dlccc_ [variable]
    cls.add_instance_attribute('dlccc_', 'int', is_const=False)
    ## wimax2-bs-net-device.h: ns3::Wimax2BSNetDevice::m_traceRx [variable]
    cls.add_instance_attribute('m_traceRx', 'ns3::TracedCallback< ns3::Ptr< ns3::Packet const >, ns3::Mac48Address const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', is_const=False)
    ## wimax2-bs-net-device.h: ns3::Wimax2BSNetDevice::m_traceTx [variable]
    cls.add_instance_attribute('m_traceTx', 'ns3::TracedCallback< ns3::Ptr< ns3::Packet const >, ns3::Mac48Address const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', is_const=False)
    ## wimax2-bs-net-device.h: ns3::Wimax2BSNetDevice::sendDCD [variable]
    cls.add_instance_attribute('sendDCD', 'bool', is_const=False)
    ## wimax2-bs-net-device.h: ns3::Wimax2BSNetDevice::sendUCD [variable]
    cls.add_instance_attribute('sendUCD', 'bool', is_const=False)
    ## wimax2-bs-net-device.h: ns3::Wimax2BSNetDevice::ulccc_ [variable]
    cls.add_instance_attribute('ulccc_', 'int', is_const=False)
    ## wimax2-bs-net-device.h: void ns3::Wimax2BSNetDevice::DoDispose() [member function]
    cls.add_method('DoDispose', 
                   'void', 
                   [], 
                   visibility='protected', is_virtual=True)
    ## wimax2-bs-net-device.h: void ns3::Wimax2BSNetDevice::addNewFastRanging(double time, ns3::Mac48Address macAddr) [member function]
    cls.add_method('addNewFastRanging', 
                   'void', 
                   [param('double', 'time'), param('ns3::Mac48Address', 'macAddr')], 
                   visibility='protected')
    ## wimax2-bs-net-device.h: void ns3::Wimax2BSNetDevice::expire(ns3::timer_id id) [member function]
    cls.add_method('expire', 
                   'void', 
                   [param('ns3::timer_id', 'id')], 
                   visibility='protected', is_virtual=True)
    ## wimax2-bs-net-device.h: void ns3::Wimax2BSNetDevice::init() [member function]
    cls.add_method('init', 
                   'void', 
                   [], 
                   visibility='protected', is_virtual=True)
    ## wimax2-bs-net-device.h: void ns3::Wimax2BSNetDevice::init_default_connections() [member function]
    cls.add_method('init_default_connections', 
                   'void', 
                   [], 
                   visibility='protected')
    ## wimax2-bs-net-device.h: bool ns3::Wimax2BSNetDevice::isPeerScanning(ns3::Mac48Address nodeid) [member function]
    cls.add_method('isPeerScanning', 
                   'bool', 
                   [param('ns3::Mac48Address', 'nodeid')], 
                   visibility='protected')
    ## wimax2-bs-net-device.h: void ns3::Wimax2BSNetDevice::process_cdma_req(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('process_cdma_req', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'p')], 
                   visibility='protected')
    ## wimax2-bs-net-device.h: void ns3::Wimax2BSNetDevice::send_scan_response(ns3::mac802_16_mob_scn_rsp_frame * rsp, int cid) [member function]
    cls.add_method('send_scan_response', 
                   'void', 
                   [param('ns3::mac802_16_mob_scn_rsp_frame *', 'rsp'), param('int', 'cid')], 
                   visibility='protected')
    ## wimax2-bs-net-device.h: void ns3::Wimax2BSNetDevice::setCtrlAgent(ns3::Wimax2ControlAgent * agent) [member function]
    cls.add_method('setCtrlAgent', 
                   'void', 
                   [param('ns3::Wimax2ControlAgent *', 'agent')], 
                   visibility='protected')
    ## wimax2-bs-net-device.h: void ns3::Wimax2BSNetDevice::start_dlsubframe() [member function]
    cls.add_method('start_dlsubframe', 
                   'void', 
                   [], 
                   visibility='protected', is_virtual=True)
    ## wimax2-bs-net-device.h: void ns3::Wimax2BSNetDevice::start_ulsubframe() [member function]
    cls.add_method('start_ulsubframe', 
                   'void', 
                   [], 
                   visibility='protected', is_virtual=True)
    return

def register_functions(root_module):
    module = root_module
    register_functions_ns3_Config(module.get_submodule('Config'), root_module)
    register_functions_ns3_FatalImpl(module.get_submodule('FatalImpl'), root_module)
    register_functions_ns3_addressUtils(module.get_submodule('addressUtils'), root_module)
    register_functions_ns3_aodv(module.get_submodule('aodv'), root_module)
    register_functions_ns3_dot11s(module.get_submodule('dot11s'), root_module)
    register_functions_ns3_dsdv(module.get_submodule('dsdv'), root_module)
    register_functions_ns3_flame(module.get_submodule('flame'), root_module)
    register_functions_ns3_internal(module.get_submodule('internal'), root_module)
    register_functions_ns3_olsr(module.get_submodule('olsr'), root_module)
    return

def register_functions_ns3_Config(module, root_module):
    return

def register_functions_ns3_FatalImpl(module, root_module):
    return

def register_functions_ns3_addressUtils(module, root_module):
    return

def register_functions_ns3_aodv(module, root_module):
    return

def register_functions_ns3_dot11s(module, root_module):
    return

def register_functions_ns3_dsdv(module, root_module):
    return

def register_functions_ns3_flame(module, root_module):
    return

def register_functions_ns3_internal(module, root_module):
    return

def register_functions_ns3_olsr(module, root_module):
    return

